#ifndef LOOKUP_HPP
#define LOOKUP_HPP

#include <CTRPluginFramework.hpp>
#include "stdafx.hpp"
#include "Helpers.hpp"

namespace CTRPluginFramework {
    extern u16 spwnSpecies;
    extern u8 spawnLv;
    extern u8 spwnForm;

    namespace English {
        static const char *allPkmn[807] = {
            "Bulbasaur",
            "Ivysaur",
            "Venusaur",
            "Charmander",
            "Charmeleon",
            "Charizard",
            "Squirtle",
            "Wartortle",
            "Blastoise",
            "Caterpie",
            "Metapod",
            "Butterfree",
            "Weedle",
            "Kakuna",
            "Beedrill",
            "Pidgey",
            "Pidgeotto",
            "Pidgeot",
            "Rattata",
            "Raticate",
            "Spearow",
            "Fearow",
            "Ekans",
            "Arbok",
            "Pikachu",
            "Raichu",
            "Sandshrew",
            "Sandslash",
            "NidoranF",
            "Nidorina",
            "Nidoqueen",
            "NidoranM",
            "Nidorino",
            "Nidoking",
            "Clefairy",
            "Clefable",
            "Vulpix",
            "Ninetales",
            "Jigglypuff",
            "Wigglytuff",
            "Zubat",
            "Golbat",
            "Oddish",
            "Gloom",
            "Vileplume",
            "Paras",
            "Parasect",
            "Venonat",
            "Venomoth",
            "Diglett",
            "Dugtrio",
            "Meowth",
            "Persian",
            "Psyduck",
            "Golduck",
            "Mankey",
            "Primeape",
            "Growlithe",
            "Arcanine",
            "Poliwag",
            "Poliwhirl",
            "Poliwrath",
            "Abra",
            "Kadabra",
            "Alakazam",
            "Machop",
            "Machoke",
            "Machamp",
            "Bellsprout",
            "Weepinbell",
            "Victreebel",
            "Tentacool",
            "Tentacruel",
            "Geodude",
            "Graveler",
            "Golem",
            "Ponyta",
            "Rapidash",
            "Slowpoke",
            "Slowbro",
            "Magnemite",
            "Magneton",
            "Farfetchd",
            "Doduo",
            "Dodrio",
            "Seel",
            "Dewgong",
            "Grimer",
            "Muk",
            "Shellder",
            "Cloyster",
            "Gastly",
            "Haunter",
            "Gengar",
            "Onix",
            "Drowzee",
            "Hypno",
            "Krabby",
            "Kingler",
            "Voltorb",
            "Electrode",
            "Exeggcute",
            "Exeggutor",
            "Cubone",
            "Marowak",
            "Hitmonlee",
            "Hitmonchan",
            "Lickitung",
            "Koffing",
            "Weezing",
            "Rhyhorn",
            "Rhydon",
            "Chansey",
            "Tangela",
            "Kangaskhan",
            "Horsea",
            "Seadra",
            "Goldeen",
            "Seaking",
            "Staryu",
            "Starmie",
            "MrMime",
            "Scyther",
            "Jynx",
            "Electabuzz",
            "Magmar",
            "Pinsir",
            "Tauros",
            "Magikarp",
            "Gyarados",
            "Lapras",
            "Ditto",
            "Eevee",
            "Vaporeon",
            "Jolteon",
            "Flareon",
            "Porygon",
            "Omanyte",
            "Omastar",
            "Kabuto",
            "Kabutops",
            "Aerodactyl",
            "Snorlax",
            "Articuno",
            "Zapdos",
            "Moltres",
            "Dratini",
            "Dragonair",
            "Dragonite",
            "Mewtwo",
            "Mew",
            "Chikorita",
            "Bayleef",
            "Meganium",
            "Cyndaquil",
            "Quilava",
            "Typhlosion",
            "Totodile",
            "Croconaw",
            "Feraligatr",
            "Sentret",
            "Furret",
            "Hoothoot",
            "Noctowl",
            "Ledyba",
            "Ledian",
            "Spinarak",
            "Ariados",
            "Crobat",
            "Chinchou",
            "Lanturn",
            "Pichu",
            "Cleffa",
            "Igglybuff",
            "Togepi",
            "Togetic",
            "Natu",
            "Xatu",
            "Mareep",
            "Flaaffy",
            "Ampharos",
            "Bellossom",
            "Marill",
            "Azumarill",
            "Sudowoodo",
            "Politoed",
            "Hoppip",
            "Skiploom",
            "Jumpluff",
            "Aipom",
            "Sunkern",
            "Sunflora",
            "Yanma",
            "Wooper",
            "Quagsire",
            "Espeon",
            "Umbreon",
            "Murkrow",
            "Slowking",
            "Misdreavus",
            "Unown",
            "Wobbuffet",
            "Girafarig",
            "Pineco",
            "Forretress",
            "Dunsparce",
            "Gligar",
            "Steelix",
            "Snubbull",
            "Granbull",
            "Qwilfish",
            "Scizor",
            "Shuckle",
            "Heracross",
            "Sneasel",
            "Teddiursa",
            "Ursaring",
            "Slugma",
            "Magcargo",
            "Swinub",
            "Piloswine",
            "Corsola",
            "Remoraid",
            "Octillery",
            "Delibird",
            "Mantine",
            "Skarmory",
            "Houndour",
            "Houndoom",
            "Kingdra",
            "Phanpy",
            "Donphan",
            "Porygon2",
            "Stantler",
            "Smeargle",
            "Tyrogue",
            "Hitmontop",
            "Smoochum",
            "Elekid",
            "Magby",
            "Miltank",
            "Blissey",
            "Raikou",
            "Entei",
            "Suicune",
            "Larvitar",
            "Pupitar",
            "Tyranitar",
            "Lugia",
            "Ho-Oh",
            "Celebi",
            "Treecko",
            "Grovyle",
            "Sceptile",
            "Torchic",
            "Combusken",
            "Blaziken",
            "Mudkip",
            "Marshtomp",
            "Swampert",
            "Poochyena",
            "Mightyena",
            "Zigzagoon",
            "Linoone",
            "Wurmple",
            "Silcoon",
            "Beautifly",
            "Cascoon",
            "Dustox",
            "Lotad",
            "Lombre",
            "Ludicolo",
            "Seedot",
            "Nuzleaf",
            "Shiftry",
            "Taillow",
            "Swellow",
            "Wingull",
            "Pelipper",
            "Ralts",
            "Kirlia",
            "Gardevoir",
            "Surskit",
            "Masquerain",
            "Shroomish",
            "Breloom",
            "Slakoth",
            "Vigoroth",
            "Slaking",
            "Nincada",
            "Ninjask",
            "Shedinja",
            "Whismur",
            "Loudred",
            "Exploud",
            "Makuhita",
            "Hariyama",
            "Azurill",
            "Nosepass",
            "Skitty",
            "Delcatty",
            "Sableye",
            "Mawile",
            "Aron",
            "Lairon",
            "Aggron",
            "Meditite",
            "Medicham",
            "Electrike",
            "Manectric",
            "Plusle",
            "Minun",
            "Volbeat",
            "Illumise",
            "Roselia",
            "Gulpin",
            "Swalot",
            "Carvanha",
            "Sharpedo",
            "Wailmer",
            "Wailord",
            "Numel",
            "Camerupt",
            "Torkoal",
            "Spoink",
            "Grumpig",
            "Spinda",
            "Trapinch",
            "Vibrava",
            "Flygon",
            "Cacnea",
            "Cacturne",
            "Swablu",
            "Altaria",
            "Zangoose",
            "Seviper",
            "Lunatone",
            "Solrock",
            "Barboach",
            "Whiscash",
            "Corphish",
            "Crawdaunt",
            "Baltoy",
            "Claydol",
            "Lileep",
            "Cradily",
            "Anorith",
            "Armaldo",
            "Feebas",
            "Milotic",
            "Castform",
            "Kecleon",
            "Shuppet",
            "Banette",
            "Duskull",
            "Dusclops",
            "Tropius",
            "Chimecho",
            "Absol",
            "Wynaut",
            "Snorunt",
            "Glalie",
            "Spheal",
            "Sealeo",
            "Walrein",
            "Clamperl",
            "Huntail",
            "Gorebyss",
            "Relicanth",
            "Luvdisc",
            "Bagon",
            "Shelgon",
            "Salamence",
            "Beldum",
            "Metang",
            "Metagross",
            "Regirock",
            "Regice",
            "Registeel",
            "Latias",
            "Latios",
            "Kyogre",
            "Groudon",
            "Rayquaza",
            "Jirachi",
            "Deoxys",
            "Turtwig",
            "Grotle",
            "Torterra",
            "Chimchar",
            "Monferno",
            "Infernape",
            "Piplup",
            "Prinplup",
            "Empoleon",
            "Starly",
            "Staravia",
            "Staraptor",
            "Bidoof",
            "Bibarel",
            "Kricketot",
            "Kricketune",
            "Shinx",
            "Luxio",
            "Luxray",
            "Budew",
            "Roserade",
            "Cranidos",
            "Rampardos",
            "Shieldon",
            "Bastiodon",
            "Burmy",
            "Wormadam",
            "Mothim",
            "Combee",
            "Vespiquen",
            "Pachirisu",
            "Buizel",
            "Floatzel",
            "Cherubi",
            "Cherrim",
            "Shellos",
            "Gastrodon",
            "Ambipom",
            "Drifloon",
            "Drifblim",
            "Buneary",
            "Lopunny",
            "Mismagius",
            "Honchkrow",
            "Glameow",
            "Purugly",
            "Chingling",
            "Stunky",
            "Skuntank",
            "Bronzor",
            "Bronzong",
            "Bonsly",
            "MimeJr",
            "Happiny",
            "Chatot",
            "Spiritomb",
            "Gible",
            "Gabite",
            "Garchomp",
            "Munchlax",
            "Riolu",
            "Lucario",
            "Hippopotas",
            "Hippowdon",
            "Skorupi",
            "Drapion",
            "Croagunk",
            "Toxicroak",
            "Carnivine",
            "Finneon",
            "Lumineon",
            "Mantyke",
            "Snover",
            "Abomasnow",
            "Weavile",
            "Magnezone",
            "Lickilicky",
            "Rhyperior",
            "Tangrowth",
            "Electivire",
            "Magmortar",
            "Togekiss",
            "Yanmega",
            "Leafeon",
            "Glaceon",
            "Gliscor",
            "Mamoswine",
            "PorygonZ",
            "Gallade",
            "Probopass",
            "Dusknoir",
            "Froslass",
            "Rotom",
            "Uxie",
            "Mesprit",
            "Azelf",
            "Dialga",
            "Palkia",
            "Heatran",
            "Regigigas",
            "Giratina",
            "Cresselia",
            "Phione",
            "Manaphy",
            "Darkrai",
            "Shaymin",
            "Arceus",
            "Victini",
            "Snivy",
            "Servine",
            "Serperior",
            "Tepig",
            "Pignite",
            "Emboar",
            "Oshawott",
            "Dewott",
            "Samurott",
            "Patrat",
            "Watchog",
            "Lillipup",
            "Herdier",
            "Stoutland",
            "Purrloin",
            "Liepard",
            "Pansage",
            "Simisage",
            "Pansear",
            "Simisear",
            "Panpour",
            "Simipour",
            "Munna",
            "Musharna",
            "Pidove",
            "Tranquill",
            "Unfezant",
            "Blitzle",
            "Zebstrika",
            "Roggenrola",
            "Boldore",
            "Gigalith",
            "Woobat",
            "Swoobat",
            "Drilbur",
            "Excadrill",
            "Audino",
            "Timburr",
            "Gurdurr",
            "Conkeldurr",
            "Tympole",
            "Palpitoad",
            "Seismitoad",
            "Throh",
            "Sawk",
            "Sewaddle",
            "Swadloon",
            "Leavanny",
            "Venipede",
            "Whirlipede",
            "Scolipede",
            "Cottonee",
            "Whimsicott",
            "Petilil",
            "Lilligant",
            "Basculin",
            "Sandile",
            "Krokorok",
            "Krookodile",
            "Darumaka",
            "Darmanitan",
            "Maractus",
            "Dwebble",
            "Crustle",
            "Scraggy",
            "Scrafty",
            "Sigilyph",
            "Yamask",
            "Cofagrigus",
            "Tirtouga",
            "Carracosta",
            "Archen",
            "Archeops",
            "Trubbish",
            "Garbodor",
            "Zorua",
            "Zoroark",
            "Minccino",
            "Cinccino",
            "Gothita",
            "Gothorita",
            "Gothitelle",
            "Solosis",
            "Duosion",
            "Reuniclus",
            "Ducklett",
            "Swanna",
            "Vanillite",
            "Vanillish",
            "Vanilluxe",
            "Deerling",
            "Sawsbuck",
            "Emolga",
            "Karrablast",
            "Escavalier",
            "Foongus",
            "Amoonguss",
            "Frillish",
            "Jellicent",
            "Alomomola",
            "Joltik",
            "Galvantula",
            "Ferroseed",
            "Ferrothorn",
            "Klink",
            "Klang",
            "Klinklang",
            "Tynamo",
            "Eelektrik",
            "Eelektross",
            "Elgyem",
            "Beheeyem",
            "Litwick",
            "Lampent",
            "Chandelure",
            "Axew",
            "Fraxure",
            "Haxorus",
            "Cubchoo",
            "Beartic",
            "Cryogonal",
            "Shelmet",
            "Accelgor",
            "Stunfisk",
            "Mienfoo",
            "Mienshao",
            "Druddigon",
            "Golett",
            "Golurk",
            "Pawniard",
            "Bisharp",
            "Bouffalant",
            "Rufflet",
            "Braviary",
            "Vullaby",
            "Mandibuzz",
            "Heatmor",
            "Durant",
            "Deino",
            "Zweilous",
            "Hydreigon",
            "Larvesta",
            "Volcarona",
            "Cobalion",
            "Terrakion",
            "Virizion",
            "Tornadus",
            "Thundurus",
            "Reshiram",
            "Zekrom",
            "Landorus",
            "Kyurem",
            "Keldeo",
            "Meloetta",
            "Genesect",
            "Chespin",
            "Quilladin",
            "Chesnaught",
            "Fennekin",
            "Braixen",
            "Delphox",
            "Froakie",
            "Frogadier",
            "Greninja",
            "Bunnelby",
            "Diggersby",
            "Fletchling",
            "Fletchinder",
            "Talonflame",
            "Scatterbug",
            "Spewpa",
            "Vivillon",
            "Litleo",
            "Pyroar",
            "Flabebe",
            "Floette",
            "Florges",
            "Skiddo",
            "Gogoat",
            "Pancham",
            "Pangoro",
            "Furfrou",
            "Espurr",
            "Meowstic",
            "Honedge",
            "Doublade",
            "Aegislash",
            "Spritzee",
            "Aromatisse",
            "Swirlix",
            "Slurpuff",
            "Inkay",
            "Malamar",
            "Binacle",
            "Barbaracle",
            "Skrelp",
            "Dragalge",
            "Clauncher",
            "Clawitzer",
            "Helioptile",
            "Heliolisk",
            "Tyrunt",
            "Tyrantrum",
            "Amaura",
            "Aurorus",
            "Sylveon",
            "Hawlucha",
            "Dedenne",
            "Carbink",
            "Goomy",
            "Sliggoo",
            "Goodra",
            "Klefki",
            "Phantump",
            "Trevenant",
            "Pumpkaboo",
            "Gourgeist",
            "Bergmite",
            "Avalugg",
            "Noibat",
            "Noivern",
            "Xerneas",
            "Yveltal",
            "Zygarde",
            "Diancie",
            "Hoopa",
            "Volcanion",
            "Rowlet",
            "Dartrix",
            "Decidueye",
            "Litten",
            "Torracat",
            "Incineroar",
            "Popplio",
            "Brionne",
            "Primarina",
            "Pikipek",
            "Trumbeak",
            "Toucannon",
            "Yungoos",
            "Gumshoos",
            "Grubbin",
            "Charjabug",
            "Vikavolt",
            "Crabrawler",
            "Crabominable",
            "Oricorio",
            "Cutiefly",
            "Ribombee",
            "Rockruff",
            "Lycanroc",
            "Wishiwashi",
            "Mareanie",
            "Toxapex",
            "Mudbray",
            "Mudsdale",
            "Dewpider",
            "Araquanid",
            "Fomantis",
            "Lurantis",
            "Morelull",
            "Shiinotic",
            "Salandit",
            "Salazzle",
            "Stufful",
            "Bewear",
            "Bounsweet",
            "Steenee",
            "Tsareena",
            "Comfey",
            "Oranguru",
            "Passimian",
            "Wimpod",
            "Golisopod",
            "Sandygast",
            "Palossand",
            "Pyukumuku",
            "TypeNull",
            "Silvally",
            "Minior",
            "Komala",
            "Turtonator",
            "Togedemaru",
            "Mimikyu",
            "Bruxish",
            "Drampa",
            "Dhelmise",
            "Jangmoo",
            "Hakamoo",
            "Kommoo",
            "TapuKoko",
            "TapuLele",
            "TapuBulu",
            "TapuFini",
            "Cosmog",
            "Cosmoem",
            "Solgaleo",
            "Lunala",
            "Nihilego",
            "Buzzwole",
            "Pheromosa",
            "Xurkitree",
            "Celesteela",
            "Kartana",
            "Guzzlord",
            "Necrozma",
            "Magearna",
            "Marshadow",
            "Poipole",
            "Naganadel",
            "Stakataka",
            "Blacephalon",
            "Zeraora"
        };
    }

    namespace French {
        static const char *allPkmn[807] = {
            "Bulbizarre",
            "Herbizarre",
            "Florizarre",
            "Salamèche",
            "Reptincel",
            "Dracaufeu",
            "Carapuce",
            "Carabaffe",
            "Tortank",
            "Chenipan",
            "Chrysacier",
            "Papilusion",
            "Aspicot",
            "Coconfort",
            "Dardargnan",
            "Roucool",
            "Roucoups",
            "Roucarnage",
            "Rattata",
            "Rattatac",
            "Piafabec",
            "Rapasdepic",
            "Abo",
            "Arbok",
            "Pikachu",
            "Raichu",
            "Sabelette",
            "Sablaireau",
            "Nidoran♀",
            "Nidorina",
            "Nidoqueen",
            "Nidoran♂",
            "Nidorino",
            "Nidoking",
            "Mélofée",
            "Mélodelfe",
            "Goupix",
            "Feunard",
            "Rondoudou",
            "Grodoudou",
            "Nosferapti",
            "Nosferalto",
            "Mystherbe",
            "Ortide",
            "Rafflesia",
            "Paras",
            "Parasect",
            "Mimitoss",
            "Aéromite",
            "Taupiqueur",
            "Triopikeur",
            "Miaouss",
            "Persian",
            "Psykokwak",
            "Akwakwak",
            "Férosinge",
            "Colossinge",
            "Caninos",
            "Arcanin",
            "Ptitard",
            "Têtarte",
            "Tartard",
            "Abra",
            "Kadabra",
            "Alakazam",
            "Machoc",
            "Machopeur",
            "Mackogneur",
            "Chétiflor",
            "Boustiflor",
            "Empiflor",
            "Tentacool",
            "Tentacruel",
            "Racaillou",
            "Gravalanch",
            "Grolem",
            "Ponyta",
            "Galopa",
            "Ramoloss",
            "Flagadoss",
            "Magnéti",
            "Magnéton",
            "Canarticho",
            "Doduo",
            "Dodrio",
            "Otaria",
            "Lamantine",
            "Tadmorv",
            "Grotadmorv",
            "Kokiyas",
            "Crustabri",
            "Fantominus",
            "Spectrum",
            "Ectoplasma",
            "Onix",
            "Soporifik",
            "Hypnomade",
            "Krabby",
            "Krabboss",
            "Voltorbe",
            "Électrode",
            "Noeunoeuf",
            "Noadkoko",
            "Osselait",
            "Ossatueur",
            "Kicklee",
            "Tygnon",
            "Excelangue",
            "Smogo",
            "Smogogo",
            "Rhinocorne",
            "Rhinoféros",
            "Leveinard",
            "Saquedeneu",
            "Kangourex",
            "Hypotrempe",
            "Hypocéan",
            "Poissirène",
            "Poissoroy",
            "Stari",
            "Staross",
            "M. Mime",
            "Insécateur",
            "Lippoutou",
            "Élektek",
            "Magmar",
            "Scarabrute",
            "Tauros",
            "Magicarpe",
            "Léviator",
            "Lokhlass",
            "Métamorph",
            "Évoli",
            "Aquali",
            "Voltali",
            "Pyroli",
            "Porygon",
            "Amonita",
            "Amonistar",
            "Kabuto",
            "Kabutops",
            "Ptéra",
            "Ronflex",
            "Artikodin",
            "Électhor",
            "Sulfura",
            "Minidraco",
            "Draco",
            "Dracolosse",
            "Mewtwo",
            "Mew",
            "Germignon",
            "Macronium",
            "Méganium",
            "Héricendre",
            "Feurisson",
            "Typhlosion",
            "Kaiminus",
            "Crocrodil",
            "Aligatueur",
            "Fouinette",
            "Fouinar",
            "Hoothoot",
            "Noarfang",
            "Coxy",
            "Coxyclaque",
            "Mimigal",
            "Migalos",
            "Nostenfer",
            "Loupio",
            "Lanturn",
            "Pichu",
            "Mélo",
            "Toudoudou",
            "Togepi",
            "Togetic",
            "Natu",
            "Xatu",
            "Wattouat",
            "Lainergie",
            "Pharamp",
            "Joliflor",
            "Marill",
            "Azumarill",
            "Simularbre",
            "Tarpaud",
            "Granivol",
            "Floravol",
            "Cotovol",
            "Capumain",
            "Tournegrin",
            "Héliatronc",
            "Yanma",
            "Axoloto",
            "Maraiste",
            "Mentali",
            "Noctali",
            "Cornèbre",
            "Roigada",
            "Feuforêve",
            "Zarbi",
            "Qulbutoké",
            "Girafarig",
            "Pomdepik",
            "Foretress",
            "Insolourdo",
            "Scorplane",
            "Steelix",
            "Snubbull",
            "Granbull",
            "Qwilfish",
            "Cizayox",
            "Caratroc",
            "Scarhino",
            "Farfuret",
            "Teddiursa",
            "Ursaring",
            "Limagma",
            "Volcaropod",
            "Marcacrin",
            "Cochignon",
            "Corayon",
            "Rémoraid",
            "Octillery",
            "Cadoizo",
            "Démanta",
            "Airmure",
            "Malosse",
            "Démolosse",
            "Hyporoi",
            "Phanpy",
            "Donphan",
            "Porygon2",
            "Cerfrousse",
            "Queulorior",
            "Debugant",
            "Kapoera",
            "Lippouti",
            "Élekid",
            "Magby",
            "Écrémeuh",
            "Leuphorie",
            "Raikou",
            "Entei",
            "Suicune",
            "Embrylex",
            "Ymphect",
            "Tyranocif",
            "Lugia",
            "Ho-Oh",
            "Celebi",
            "Arcko",
            "Massko",
            "Jungko",
            "Poussifeu",
            "Galifeu",
            "Braségali",
            "Gobou",
            "Flobio",
            "Laggron",
            "Medhyèna",
            "Grahyèna",
            "Zigzaton",
            "Linéon",
            "Chenipotte",
            "Armulys",
            "Charmillon",
            "Blindalys",
            "Papinox",
            "Nénupiot",
            "Lombre",
            "Ludicolo",
            "Grainipiot",
            "Pifeuil",
            "Tengalice",
            "Nirondelle",
            "Hélédelle",
            "Goélise",
            "Bekipan",
            "Tarsal",
            "Kirlia",
            "Gardevoir",
            "Arakdo",
            "Maskadra",
            "Balignon",
            "Chapignon",
            "Parecool",
            "Vigoroth",
            "Monaflèmit",
            "Ningale",
            "Ninjask",
            "Munja",
            "Chuchmur",
            "Ramboum",
            "Brouhabam",
            "Makuhita",
            "Hariyama",
            "Azurill",
            "Tarinor",
            "Skitty",
            "Delcatty",
            "Ténéfix",
            "Mysdibule",
            "Galekid",
            "Galegon",
            "Galeking",
            "Méditikka",
            "Charmina",
            "Dynavolt",
            "Élecsprint",
            "Posipi",
            "Négapi",
            "Muciole",
            "Lumivole",
            "Rosélia",
            "Gloupti",
            "Avaltout",
            "Carvanha",
            "Sharpedo",
            "Wailmer",
            "Wailord",
            "Chamallot",
            "Camérupt",
            "Chartor",
            "Spoink",
            "Groret",
            "Spinda",
            "Kraknoix",
            "Vibraninf",
            "Libégon",
            "Cacnea",
            "Cacturne",
            "Tylton",
            "Altaria",
            "Mangriff",
            "Séviper",
            "Séléroc",
            "Solaroc",
            "Barloche",
            "Barbicha",
            "Écrapince",
            "Colhomard",
            "Balbuto",
            "Kaorine",
            "Lilia",
            "Vacilys",
            "Anorith",
            "Armaldo",
            "Barpau",
            "Milobellus",
            "Morphéo",
            "Kecleon",
            "Polichombr",
            "Branette",
            "Skelénox",
            "Téraclope",
            "Tropius",
            "Éoko",
            "Absol",
            "Okéoké",
            "Stalgamin",
            "Oniglali",
            "Obalie",
            "Phogleur",
            "Kaimorse",
            "Coquiperl",
            "Serpang",
            "Rosabyss",
            "Relicanth",
            "Lovdisc",
            "Draby",
            "Drackhaus",
            "Drattak",
            "Terhal",
            "Métang",
            "Métalosse",
            "Regirock",
            "Regice",
            "Registeel",
            "Latias",
            "Latios",
            "Kyogre",
            "Groudon",
            "Rayquaza",
            "Jirachi",
            "Deoxys",
            "Tortipouss",
            "Boskara",
            "Torterra",
            "Ouisticram",
            "Chimpenfeu",
            "Simiabraz",
            "Tiplouf",
            "Prinplouf",
            "Pingoléon",
            "Étourmi",
            "Étourvol",
            "Étouraptor",
            "Keunotor",
            "Castorno",
            "Crikzik",
            "Mélokrik",
            "Lixy",
            "Luxio",
            "Luxray",
            "Rozbouton",
            "Roserade",
            "Kranidos",
            "Charkos",
            "Dinoclier",
            "Bastiodon",
            "Cheniti",
            "Cheniselle",
            "Papilord",
            "Apitrini",
            "Apireine",
            "Pachirisu",
            "Mustébouée",
            "Mustéflott",
            "Ceribou",
            "Ceriflor",
            "Sancoki",
            "Tritosor",
            "Capidextre",
            "Baudrive",
            "Grodrive",
            "Laporeille",
            "Lockpin",
            "Magirêve",
            "Corboss",
            "Chaglam",
            "Chaffreux",
            "Korillon",
            "Moufouette",
            "Moufflair",
            "Archéomire",
            "Archéodong",
            "Manzaï",
            "Mime Jr.",
            "Ptiravi",
            "Pijako",
            "Spiritomb",
            "Griknot",
            "Carmache",
            "Carchacrok",
            "Goinfrex",
            "Riolu",
            "Lucario",
            "Hippopotas",
            "Hippodocus",
            "Rapion",
            "Drascore",
            "Cradopaud",
            "Coatox",
            "Vortente",
            "Écayon",
            "Luminéon",
            "Babimanta",
            "Blizzi",
            "Blizzaroi",
            "Dimoret",
            "Magnézone",
            "Coudlangue",
            "Rhinastoc",
            "Bouldeneu",
            "Élekable",
            "Maganon",
            "Togekiss",
            "Yanmega",
            "Phyllali",
            "Givrali",
            "Scorvol",
            "Mammochon",
            "Porygon-Z",
            "Gallame",
            "Tarinorme",
            "Noctunoir",
            "Momartik",
            "Motisma",
            "Créhelf",
            "Créfollet",
            "Créfadet",
            "Dialga",
            "Palkia",
            "Heatran",
            "Regigigas",
            "Giratina",
            "Cresselia",
            "Phione",
            "Manaphy",
            "Darkrai",
            "Shaymin",
            "Arceus",
            "Victini",
            "Vipélierre",
            "Lianaja",
            "Majaspic",
            "Gruikui",
            "Grotichon",
            "Roitiflam",
            "Moustillon",
            "Mateloutre",
            "Clamiral",
            "Ratentif",
            "Miradar",
            "Ponchiot",
            "Ponchien",
            "Mastouffe",
            "Chacripan",
            "Léopardus",
            "Feuillajou",
            "Feuiloutan",
            "Flamajou",
            "Flamoutan",
            "Flotajou",
            "Flotoutan",
            "Munna",
            "Mushana",
            "Poichigeon",
            "Colombeau",
            "Déflaisan",
            "Zébibron",
            "Zéblitz",
            "Nodulithe",
            "Géolithe",
            "Gigalithe",
            "Chovsourir",
            "Rhinolove",
            "Rototaupe",
            "Minotaupe",
            "Nanméouïe",
            "Charpenti",
            "Ouvrifier",
            "Bétochef",
            "Tritonde",
            "Batracné",
            "Crapustule",
            "Judokrak",
            "Karaclée",
            "Larveyette",
            "Couverdure",
            "Manternel",
            "Venipatte",
            "Scobolide",
            "Brutapode",
            "Doudouvet",
            "Farfaduvet",
            "Chlorobule",
            "Fragilady",
            "Bargantua",
            "Mascaïman",
            "Escroco",
            "Crocorible",
            "Darumarond",
            "Darumacho",
            "Maracachi",
            "Crabicoque",
            "Crabaraque",
            "Baggiguane",
            "Baggaïd",
            "Cryptéro",
            "Tutafeh",
            "Tutankafer",
            "Carapagos",
            "Mégapagos",
            "Arkéapti",
            "Aéroptéryx",
            "Miamiasme",
            "Miasmax",
            "Zorua",
            "Zoroark",
            "Chinchidou",
            "Pashmilla",
            "Scrutella",
            "Mesmérella",
            "Sidérella",
            "Nucléos",
            "Méios",
            "Symbios",
            "Couaneton",
            "Lakmécygne",
            "Sorbébé",
            "Sorboul",
            "Sorbouboul",
            "Vivaldaim",
            "Haydaim",
            "Emolga",
            "Carabing",
            "Lançargot",
            "Trompignon",
            "Gaulet",
            "Viskuse",
            "Moyade",
            "Mamanbo",
            "Statitik",
            "Mygavolt",
            "Grindur",
            "Noacier",
            "Tic",
            "Clic",
            "Cliticlic",
            "Anchwatt",
            "Lampéroie",
            "Ohmassacre",
            "Lewsor",
            "Neitram",
            "Funécire",
            "Mélancolux",
            "Lugulabre",
            "Coupenotte",
            "Incisache",
            "Tranchodon",
            "Polarhume",
            "Polagriffe",
            "Hexagel",
            "Escargaume",
            "Limaspeed",
            "Limonde",
            "Kungfouine",
            "Shaofouine",
            "Drakkarmin",
            "Gringolem",
            "Golemastoc",
            "Scalpion",
            "Scalproie",
            "Frison",
            "Furaiglon",
            "Gueriaigle",
            "Vostourno",
            "Vaututrice",
            "Aflamanoir",
            "Fermite",
            "Solochi",
            "Diamat",
            "Trioxhydre",
            "Pyronille",
            "Pyrax",
            "Cobaltium",
            "Terrakium",
            "Viridium",
            "Boréas",
            "Fulguris",
            "Reshiram",
            "Zekrom",
            "Démétéros",
            "Kyurem",
            "Keldeo",
            "Meloetta",
            "Genesect",
            "Marisson",
            "Boguérisse",
            "Blindépique",
            "Feunnec",
            "Roussil",
            "Goupelin",
            "Grenousse",
            "Croâporal",
            "Amphinobi",
            "Sapereau",
            "Excavarenne",
            "Passerouge",
            "Braisillon",
            "Flambusard",
            "Lépidonille",
            "Pérégrain",
            "Prismillon",
            "Hélionceau",
            "Némélios",
            "Flabébé",
            "Floette",
            "Florges",
            "Cabriolaine",
            "Chevroum",
            "Pandespiègle",
            "Pandarbare",
            "Couafarel",
            "Psystigri",
            "Mistigrix",
            "Monorpale",
            "Dimoclès",
            "Exagide",
            "Fluvetin",
            "Cocotine",
            "Sucroquin",
            "Cupcanaille",
            "Sepiatop",
            "Sepiatroce",
            "Opermine",
            "Golgopathe",
            "Venalgue",
            "Kravarech",
            "Flingouste",
            "Gamblast",
            "Galvaran",
            "Iguolta",
            "Ptyranidur",
            "Rexillius",
            "Amagara",
            "Dragmara",
            "Nymphali",
            "Brutalibré",
            "Dedenne",
            "Strassie",
            "Mucuscule",
            "Colimucus",
            "Muplodocus",
            "Trousselin",
            "Brocélôme",
            "Desséliande",
            "Pitrouille",
            "Banshitrouye",
            "Grelaçon",
            "Séracrawl",
            "Sonistrelle",
            "Bruyverne",
            "Xerneas",
            "Yveltal",
            "Zygarde",
            "Diancie",
            "Hoopa",
            "Volcanion",
            "Brindibou",
            "Efflèche",
            "Archéduc",
            "Flamiaou",
            "Matoufeu",
            "Félinferno",
            "Otaquin",
            "Otarlette",
            "Oratoria",
            "Picassaut",
            "Piclairon",
            "Bazoucan",
            "Manglouton",
            "Argouste",
            "Larvibule",
            "Chrysapile",
            "Lucanon",
            "Crabagarre",
            "Crabominable",
            "Plumeline",
            "Bombydou",
            "Rubombelle",
            "Rocabot",
            "Lougaroc",
            "Froussardine",
            "Vorastérie",
            "Prédastérie",
            "Tiboudet",
            "Bourrinos",
            "Araqua",
            "Tarenbulle",
            "Mimantis",
            "Floramantis",
            "Spododo",
            "Lampignon",
            "Tritox",
            "Malamandre",
            "Nounourson",
            "Chelours",
            "Croquine",
            "Candine",
            "Sucreine",
            "Guérilande",
            "Gouroutan",
            "Quartermac",
            "Sovkipou",
            "Sarmuraï",
            "Bacabouh",
            "Trépassable",
            "Concombaffe",
            "Type:0",
            "Silvallié",
            "Météno",
            "Dodoala",
            "Boumata",
            "Togedemaru",
            "Mimiqui",
            "Denticrisse",
            "Draïeul",
            "Sinistrail",
            "Bébécaille",
            "Écaïd",
            "Ékaïser",
            "Tokorico",
            "Tokopiyon",
            "Tokotoro",
            "Tokopisco",
            "Cosmog",
            "Cosmovum",
            "Solgaleo",
            "Lunala",
            "Zéroïd",
            "Mouscoto",
            "Cancrelove",
            "Câblifère",
            "Bamboiselle",
            "Katagami",
            "Engloutyran",
            "Necrozma",
            "Magearna",
            "Marshadow",
            "Vémini",
            "Mandrillon",
            "Ama-Ama",
            "Pierroteknik",
            "Zeraora",
        };
    }

    namespace Italian {
        static const char *allPkmn[807] = {
            "Bulbasaur",
            "Ivysaur",
            "Venusaur",
            "Charmander",
            "Charmeleon",
            "Charizard",
            "Squirtle",
            "Wartortle",
            "Blastoise",
            "Caterpie",
            "Metapod",
            "Butterfree",
            "Weedle",
            "Kakuna",
            "Beedrill",
            "Pidgey",
            "Pidgeotto",
            "Pidgeot",
            "Rattata",
            "Raticate",
            "Spearow",
            "Fearow",
            "Ekans",
            "Arbok",
            "Pikachu",
            "Raichu",
            "Sandshrew",
            "Sandslash",
            "NidoranF",
            "Nidorina",
            "Nidoqueen",
            "NidoranM",
            "Nidorino",
            "Nidoking",
            "Clefairy",
            "Clefable",
            "Vulpix",
            "Ninetales",
            "Jigglypuff",
            "Wigglytuff",
            "Zubat",
            "Golbat",
            "Oddish",
            "Gloom",
            "Vileplume",
            "Paras",
            "Parasect",
            "Venonat",
            "Venomoth",
            "Diglett",
            "Dugtrio",
            "Meowth",
            "Persian",
            "Psyduck",
            "Golduck",
            "Mankey",
            "Primeape",
            "Growlithe",
            "Arcanine",
            "Poliwag",
            "Poliwhirl",
            "Poliwrath",
            "Abra",
            "Kadabra",
            "Alakazam",
            "Machop",
            "Machoke",
            "Machamp",
            "Bellsprout",
            "Weepinbell",
            "Victreebel",
            "Tentacool",
            "Tentacruel",
            "Geodude",
            "Graveler",
            "Golem",
            "Ponyta",
            "Rapidash",
            "Slowpoke",
            "Slowbro",
            "Magnemite",
            "Magneton",
            "Farfetchd",
            "Doduo",
            "Dodrio",
            "Seel",
            "Dewgong",
            "Grimer",
            "Muk",
            "Shellder",
            "Cloyster",
            "Gastly",
            "Haunter",
            "Gengar",
            "Onix",
            "Drowzee",
            "Hypno",
            "Krabby",
            "Kingler",
            "Voltorb",
            "Electrode",
            "Exeggcute",
            "Exeggutor",
            "Cubone",
            "Marowak",
            "Hitmonlee",
            "Hitmonchan",
            "Lickitung",
            "Koffing",
            "Weezing",
            "Rhyhorn",
            "Rhydon",
            "Chansey",
            "Tangela",
            "Kangaskhan",
            "Horsea",
            "Seadra",
            "Goldeen",
            "Seaking",
            "Staryu",
            "Starmie",
            "MrMime",
            "Scyther",
            "Jynx",
            "Electabuzz",
            "Magmar",
            "Pinsir",
            "Tauros",
            "Magikarp",
            "Gyarados",
            "Lapras",
            "Ditto",
            "Eevee",
            "Vaporeon",
            "Jolteon",
            "Flareon",
            "Porygon",
            "Omanyte",
            "Omastar",
            "Kabuto",
            "Kabutops",
            "Aerodactyl",
            "Snorlax",
            "Articuno",
            "Zapdos",
            "Moltres",
            "Dratini",
            "Dragonair",
            "Dragonite",
            "Mewtwo",
            "Mew",
            "Chikorita",
            "Bayleef",
            "Meganium",
            "Cyndaquil",
            "Quilava",
            "Typhlosion",
            "Totodile",
            "Croconaw",
            "Feraligatr",
            "Sentret",
            "Furret",
            "Hoothoot",
            "Noctowl",
            "Ledyba",
            "Ledian",
            "Spinarak",
            "Ariados",
            "Crobat",
            "Chinchou",
            "Lanturn",
            "Pichu",
            "Cleffa",
            "Igglybuff",
            "Togepi",
            "Togetic",
            "Natu",
            "Xatu",
            "Mareep",
            "Flaaffy",
            "Ampharos",
            "Bellossom",
            "Marill",
            "Azumarill",
            "Sudowoodo",
            "Politoed",
            "Hoppip",
            "Skiploom",
            "Jumpluff",
            "Aipom",
            "Sunkern",
            "Sunflora",
            "Yanma",
            "Wooper",
            "Quagsire",
            "Espeon",
            "Umbreon",
            "Murkrow",
            "Slowking",
            "Misdreavus",
            "Unown",
            "Wobbuffet",
            "Girafarig",
            "Pineco",
            "Forretress",
            "Dunsparce",
            "Gligar",
            "Steelix",
            "Snubbull",
            "Granbull",
            "Qwilfish",
            "Scizor",
            "Shuckle",
            "Heracross",
            "Sneasel",
            "Teddiursa",
            "Ursaring",
            "Slugma",
            "Magcargo",
            "Swinub",
            "Piloswine",
            "Corsola",
            "Remoraid",
            "Octillery",
            "Delibird",
            "Mantine",
            "Skarmory",
            "Houndour",
            "Houndoom",
            "Kingdra",
            "Phanpy",
            "Donphan",
            "Porygon2",
            "Stantler",
            "Smeargle",
            "Tyrogue",
            "Hitmontop",
            "Smoochum",
            "Elekid",
            "Magby",
            "Miltank",
            "Blissey",
            "Raikou",
            "Entei",
            "Suicune",
            "Larvitar",
            "Pupitar",
            "Tyranitar",
            "Lugia",
            "Ho-Oh",
            "Celebi",
            "Treecko",
            "Grovyle",
            "Sceptile",
            "Torchic",
            "Combusken",
            "Blaziken",
            "Mudkip",
            "Marshtomp",
            "Swampert",
            "Poochyena",
            "Mightyena",
            "Zigzagoon",
            "Linoone",
            "Wurmple",
            "Silcoon",
            "Beautifly",
            "Cascoon",
            "Dustox",
            "Lotad",
            "Lombre",
            "Ludicolo",
            "Seedot",
            "Nuzleaf",
            "Shiftry",
            "Taillow",
            "Swellow",
            "Wingull",
            "Pelipper",
            "Ralts",
            "Kirlia",
            "Gardevoir",
            "Surskit",
            "Masquerain",
            "Shroomish",
            "Breloom",
            "Slakoth",
            "Vigoroth",
            "Slaking",
            "Nincada",
            "Ninjask",
            "Shedinja",
            "Whismur",
            "Loudred",
            "Exploud",
            "Makuhita",
            "Hariyama",
            "Azurill",
            "Nosepass",
            "Skitty",
            "Delcatty",
            "Sableye",
            "Mawile",
            "Aron",
            "Lairon",
            "Aggron",
            "Meditite",
            "Medicham",
            "Electrike",
            "Manectric",
            "Plusle",
            "Minun",
            "Volbeat",
            "Illumise",
            "Roselia",
            "Gulpin",
            "Swalot",
            "Carvanha",
            "Sharpedo",
            "Wailmer",
            "Wailord",
            "Numel",
            "Camerupt",
            "Torkoal",
            "Spoink",
            "Grumpig",
            "Spinda",
            "Trapinch",
            "Vibrava",
            "Flygon",
            "Cacnea",
            "Cacturne",
            "Swablu",
            "Altaria",
            "Zangoose",
            "Seviper",
            "Lunatone",
            "Solrock",
            "Barboach",
            "Whiscash",
            "Corphish",
            "Crawdaunt",
            "Baltoy",
            "Claydol",
            "Lileep",
            "Cradily",
            "Anorith",
            "Armaldo",
            "Feebas",
            "Milotic",
            "Castform",
            "Kecleon",
            "Shuppet",
            "Banette",
            "Duskull",
            "Dusclops",
            "Tropius",
            "Chimecho",
            "Absol",
            "Wynaut",
            "Snorunt",
            "Glalie",
            "Spheal",
            "Sealeo",
            "Walrein",
            "Clamperl",
            "Huntail",
            "Gorebyss",
            "Relicanth",
            "Luvdisc",
            "Bagon",
            "Shelgon",
            "Salamence",
            "Beldum",
            "Metang",
            "Metagross",
            "Regirock",
            "Regice",
            "Registeel",
            "Latias",
            "Latios",
            "Kyogre",
            "Groudon",
            "Rayquaza",
            "Jirachi",
            "Deoxys",
            "Turtwig",
            "Grotle",
            "Torterra",
            "Chimchar",
            "Monferno",
            "Infernape",
            "Piplup",
            "Prinplup",
            "Empoleon",
            "Starly",
            "Staravia",
            "Staraptor",
            "Bidoof",
            "Bibarel",
            "Kricketot",
            "Kricketune",
            "Shinx",
            "Luxio",
            "Luxray",
            "Budew",
            "Roserade",
            "Cranidos",
            "Rampardos",
            "Shieldon",
            "Bastiodon",
            "Burmy",
            "Wormadam",
            "Mothim",
            "Combee",
            "Vespiquen",
            "Pachirisu",
            "Buizel",
            "Floatzel",
            "Cherubi",
            "Cherrim",
            "Shellos",
            "Gastrodon",
            "Ambipom",
            "Drifloon",
            "Drifblim",
            "Buneary",
            "Lopunny",
            "Mismagius",
            "Honchkrow",
            "Glameow",
            "Purugly",
            "Chingling",
            "Stunky",
            "Skuntank",
            "Bronzor",
            "Bronzong",
            "Bonsly",
            "MimeJr",
            "Happiny",
            "Chatot",
            "Spiritomb",
            "Gible",
            "Gabite",
            "Garchomp",
            "Munchlax",
            "Riolu",
            "Lucario",
            "Hippopotas",
            "Hippowdon",
            "Skorupi",
            "Drapion",
            "Croagunk",
            "Toxicroak",
            "Carnivine",
            "Finneon",
            "Lumineon",
            "Mantyke",
            "Snover",
            "Abomasnow",
            "Weavile",
            "Magnezone",
            "Lickilicky",
            "Rhyperior",
            "Tangrowth",
            "Electivire",
            "Magmortar",
            "Togekiss",
            "Yanmega",
            "Leafeon",
            "Glaceon",
            "Gliscor",
            "Mamoswine",
            "PorygonZ",
            "Gallade",
            "Probopass",
            "Dusknoir",
            "Froslass",
            "Rotom",
            "Uxie",
            "Mesprit",
            "Azelf",
            "Dialga",
            "Palkia",
            "Heatran",
            "Regigigas",
            "Giratina",
            "Cresselia",
            "Phione",
            "Manaphy",
            "Darkrai",
            "Shaymin",
            "Arceus",
            "Victini",
            "Snivy",
            "Servine",
            "Serperior",
            "Tepig",
            "Pignite",
            "Emboar",
            "Oshawott",
            "Dewott",
            "Samurott",
            "Patrat",
            "Watchog",
            "Lillipup",
            "Herdier",
            "Stoutland",
            "Purrloin",
            "Liepard",
            "Pansage",
            "Simisage",
            "Pansear",
            "Simisear",
            "Panpour",
            "Simipour",
            "Munna",
            "Musharna",
            "Pidove",
            "Tranquill",
            "Unfezant",
            "Blitzle",
            "Zebstrika",
            "Roggenrola",
            "Boldore",
            "Gigalith",
            "Woobat",
            "Swoobat",
            "Drilbur",
            "Excadrill",
            "Audino",
            "Timburr",
            "Gurdurr",
            "Conkeldurr",
            "Tympole",
            "Palpitoad",
            "Seismitoad",
            "Throh",
            "Sawk",
            "Sewaddle",
            "Swadloon",
            "Leavanny",
            "Venipede",
            "Whirlipede",
            "Scolipede",
            "Cottonee",
            "Whimsicott",
            "Petilil",
            "Lilligant",
            "Basculin",
            "Sandile",
            "Krokorok",
            "Krookodile",
            "Darumaka",
            "Darmanitan",
            "Maractus",
            "Dwebble",
            "Crustle",
            "Scraggy",
            "Scrafty",
            "Sigilyph",
            "Yamask",
            "Cofagrigus",
            "Tirtouga",
            "Carracosta",
            "Archen",
            "Archeops",
            "Trubbish",
            "Garbodor",
            "Zorua",
            "Zoroark",
            "Minccino",
            "Cinccino",
            "Gothita",
            "Gothorita",
            "Gothitelle",
            "Solosis",
            "Duosion",
            "Reuniclus",
            "Ducklett",
            "Swanna",
            "Vanillite",
            "Vanillish",
            "Vanilluxe",
            "Deerling",
            "Sawsbuck",
            "Emolga",
            "Karrablast",
            "Escavalier",
            "Foongus",
            "Amoonguss",
            "Frillish",
            "Jellicent",
            "Alomomola",
            "Joltik",
            "Galvantula",
            "Ferroseed",
            "Ferrothorn",
            "Klink",
            "Klang",
            "Klinklang",
            "Tynamo",
            "Eelektrik",
            "Eelektross",
            "Elgyem",
            "Beheeyem",
            "Litwick",
            "Lampent",
            "Chandelure",
            "Axew",
            "Fraxure",
            "Haxorus",
            "Cubchoo",
            "Beartic",
            "Cryogonal",
            "Shelmet",
            "Accelgor",
            "Stunfisk",
            "Mienfoo",
            "Mienshao",
            "Druddigon",
            "Golett",
            "Golurk",
            "Pawniard",
            "Bisharp",
            "Bouffalant",
            "Rufflet",
            "Braviary",
            "Vullaby",
            "Mandibuzz",
            "Heatmor",
            "Durant",
            "Deino",
            "Zweilous",
            "Hydreigon",
            "Larvesta",
            "Volcarona",
            "Cobalion",
            "Terrakion",
            "Virizion",
            "Tornadus",
            "Thundurus",
            "Reshiram",
            "Zekrom",
            "Landorus",
            "Kyurem",
            "Keldeo",
            "Meloetta",
            "Genesect",
            "Chespin",
            "Quilladin",
            "Chesnaught",
            "Fennekin",
            "Braixen",
            "Delphox",
            "Froakie",
            "Frogadier",
            "Greninja",
            "Bunnelby",
            "Diggersby",
            "Fletchling",
            "Fletchinder",
            "Talonflame",
            "Scatterbug",
            "Spewpa",
            "Vivillon",
            "Litleo",
            "Pyroar",
            "Flabebe",
            "Floette",
            "Florges",
            "Skiddo",
            "Gogoat",
            "Pancham",
            "Pangoro",
            "Furfrou",
            "Espurr",
            "Meowstic",
            "Honedge",
            "Doublade",
            "Aegislash",
            "Spritzee",
            "Aromatisse",
            "Swirlix",
            "Slurpuff",
            "Inkay",
            "Malamar",
            "Binacle",
            "Barbaracle",
            "Skrelp",
            "Dragalge",
            "Clauncher",
            "Clawitzer",
            "Helioptile",
            "Heliolisk",
            "Tyrunt",
            "Tyrantrum",
            "Amaura",
            "Aurorus",
            "Sylveon",
            "Hawlucha",
            "Dedenne",
            "Carbink",
            "Goomy",
            "Sliggoo",
            "Goodra",
            "Klefki",
            "Phantump",
            "Trevenant",
            "Pumpkaboo",
            "Gourgeist",
            "Bergmite",
            "Avalugg",
            "Noibat",
            "Noivern",
            "Xerneas",
            "Yveltal",
            "Zygarde",
            "Diancie",
            "Hoopa",
            "Volcanion",
            "Rowlet",
            "Dartrix",
            "Decidueye",
            "Litten",
            "Torracat",
            "Incineroar",
            "Popplio",
            "Brionne",
            "Primarina",
            "Pikipek",
            "Trumbeak",
            "Toucannon",
            "Yungoos",
            "Gumshoos",
            "Grubbin",
            "Charjabug",
            "Vikavolt",
            "Crabrawler",
            "Crabominable",
            "Oricorio",
            "Cutiefly",
            "Ribombee",
            "Rockruff",
            "Lycanroc",
            "Wishiwashi",
            "Mareanie",
            "Toxapex",
            "Mudbray",
            "Mudsdale",
            "Dewpider",
            "Araquanid",
            "Fomantis",
            "Lurantis",
            "Morelull",
            "Shiinotic",
            "Salandit",
            "Salazzle",
            "Stufful",
            "Bewear",
            "Bounsweet",
            "Steenee",
            "Tsareena",
            "Comfey",
            "Oranguru",
            "Passimian",
            "Wimpod",
            "Golisopod",
            "Sandygast",
            "Palossand",
            "Pyukumuku",
            "TypeNull",
            "Silvally",
            "Minior",
            "Komala",
            "Turtonator",
            "Togedemaru",
            "Mimikyu",
            "Bruxish",
            "Drampa",
            "Dhelmise",
            "Jangmoo",
            "Hakamoo",
            "Kommoo",
            "TapuKoko",
            "TapuLele",
            "TapuBulu",
            "TapuFini",
            "Cosmog",
            "Cosmoem",
            "Solgaleo",
            "Lunala",
            "Nihilego",
            "Buzzwole",
            "Pheromosa",
            "Xurkitree",
            "Celesteela",
            "Kartana",
            "Guzzlord",
            "Necrozma",
            "Magearna",
            "Marshadow",
            "Poipole",
            "Naganadel",
            "Stakataka",
            "Blacephalon",
            "Zeraora"
        };
    }

    extern int pkmnID;

    struct Pokemon {
        vector<string> name;
        vector<int> choiceNo;
    };

    void FindPkmnKB(MenuEntry *entry);

    namespace Gen6 {
        static const vector<string> Forms(int pokeNo) {
            vector<string> options;

            switch (pokeNo) {
                case 3:   // Venusaur
                case 9:   // Blastoise
                case 65:  // Alakazam
                case 94:  // Gengar
                case 115: // Kangaskhan
                case 127: // Pinsir
                case 130: // Gyarados
                case 142: // Aerodactyl
                case 181: // Ampharos
                case 208: // Steelix
                case 212: // Scizor
                case 214: // Heracross
                case 229: // Houndoom
                case 248: // Tyranitar
                case 257: // Blaziken
                case 282: // Gardevoir
                case 303: // Mawile
                case 306: // Aggron
                case 308: // Medicham
                case 310: // Manectric
                case 354: // Banette
                case 359: // Absol
                case 380: // Latias
                case 381: // Latios
                case 445: // Garchomp
                case 448: // Lucario
                case 460: // Abomasnow
                    options = {language("Normal", "Normale", "Normale"), "Mega"};
                    break;

                case 6:   // Charizard
                case 150: // Mewtwo
                    options = {language("Normal", "Normale", "Normale"), "Mega X", "Mega Y"};
                    break;

                case 15:  // Beedrill
                case 18:  // Pidgeot
                case 80:  // Slowbro
                case 254: // Sceptile
                case 260: // Swampert
                case 302: // Sableye
                case 319: // Sharpedo
                case 323: // Camerupt
                case 334: // Altaria
                case 362: // Glalie
                case 373: // Salamence
                case 376: // Metagross
                case 384: // Rayquaza
                case 428: // Lopunny
                case 475: // Gallade
                case 531: // Audino
                case 719: // Diancie
                    options = Helpers::GetVersion<string>({language("Normal", "Normale", "Normale")}, {language("Normal", "Normale", "Normale"), "Mega"});
                    break;

                case 201: // Unown
                    options = {"A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "!", "?"};
                    break;

                case 351: // Castform
                    options = {language("Normal", "Normale", "Normale"), language("Sunny", "Ensoleillée", "Sole"), language("Rainy", "Pluvieuse", "Pioggia"), language("Snowy", "Neigeuse", "Nuvola di Neve")};
                    break;

                case 382: // Kyogre
                case 383: // Groudon
                    options = Helpers::GetVersion<string>({language("Normal", "Normale", "Normale")}, {language("Normal", "Normale", "Normale"), language("Primal", "Primordiale", "Primordiale")});
                    break;

                case 386: // Deoxys
                    options = {language("Normal", "Normale", "Normale"), language("Attack", "Attaque", "Attacco"), language("Defense", "Défense", "Difesa"), language("Speed", "Vitesse", "Velocità")};
                    break;

                case 412: // Burmy
                case 413: // Wormadam
                case 414: // Mothim
                    options = {language("Plant", "Végétale", "Pianta"), language("Sandy", "Sableuse", "Sabbia"), language("Trash", "Déchet", "Scarti")};
                    break;

                case 422: // Shellos
                case 423: // Gastrodon
                    options = {language("East", "Est", "Mare Est"), language("West" , "Ouest", "Mare Ovest")};
                    break;

                case 479: // Rotom
                    options = {language("Normal", "Normale", "Normale"), language("Heat", "Chauffée", "Calore"), language("Wash", "Lavée", "Lavaggio"), language("Frost", "Glacée", "Gelo"), language("Fan", "Hélice", "Vortice"), language("Mow", "Tonte", "Taglio")};
                    break;

                case 487: // Giratina
                    options = {language("Altered", "Altérée", "Alterata"), language("Origin", "Originelle", "Originale")};
                    break;

                case 492: // Shaymin
                    options = {language("Land", "Terrestre", "Terra"), language("Sky", "Céleste", "Cielo")};
                    break;

                case 493: // Arceus
                    options = {language("Normal", "Normale", "Normale"), language("Fighting", "Combat", "Lotta"), language("Flying", "Vol", "Volo"), language("Poison", "Poison", "Veleno"), language("Ground", "Sol", "Terra"), language("Rock", "Roche", "Roccia"), language("Bug", "Insecte", "Coleottero"), language("Ghost", "Spectre", "Spettro"), language("Steel", "Acier", "Acciaio"), language("Fire", "Feu", "Fuoco"), language("Water", "Eau", "Acqua"), language("Grass", "Plante", "Erba"), language("Electric", "Électrique", "Elettro"), language("Psychic", "Psychic", "Psico"), language("Ice", "Glace", "Ghiaccio"), language("Dragon", "Dragon", "Drago"), language("Dark", "Ténèbres", "Buio"), language("Fairy", "Fée", "Folletto")};
                    break;

                case 550: // Basculin
                    options = {language("Red", "Rouge", "Linearossa"), language("Blue", "Bleu", "Lineablu")};
                    break;

                case 555: // Darmanitan
                    options = {"Standard", language("Zen", "Zen", "Stato Zen")};
                    break;

                case 585: // Deerling
                case 586: // Sawsbuck
                    options = {language("Spring", "Printemps", "Primavera"), language("Summer", "Été", "Estate"), language("Autumn", "Automne", "Autunno"), language("Winter", "Hiver", "Inverno")};
                    break;

                case 641: // Tornadus
                case 642: // Thundurus
                case 645: // Landorus
                    options = {language("Incarnate", "Incarnée", "Incarnazione"), language("Therian", "Thériane", "Totem")};
                    break;

                case 646: // Kyurem
                    options = {language("Normal", "Normale", "Normale"), language("White", "Blanc", "Kyurem Bianco"), language("Black", "Noir", "Kyurem Nero")};
                    break;

                case 647: // Keldeo
                    options = {language("Ordinary", "Ordinaire", "Normale"), language("Resolute", "Résolue", "Risoluta")};
                    break;

                case 648: // Meloetta
                    options = {language("Aria", "Chant", "Canto"), language("Pirouette", "Danse", "Danza")};
                    break;

                case 649: // Genesect
                    options = {language("Normal", "Normale", "Senza modulo"), language("Douse", "Éteindre", "Idromodulo"), language("Shock", "Choc", "Voltmodulo"), language("Burn", "Brûler", "Piromodulo"), language("Chill", "Glacer", "Gelomodulo")};
                    break;

                case 664: // Scatterbug
                case 665: // Spewpa
                case 666: // Vivillon
                    options = {language("Icy Snow", "Neige Glacée", "Motivo Nevi Perenni"), language("Polar", "Polaire", "Motivo Nordico"), language("Tundra", "Toundra", "Motivo Manto di Neve"), language("Continental", "Continental", "Motivo Continentale"), language("Garden", "Jardin", "Motivo Prato"), language("Elegant", "Élégant", "Motivo Eleganza"), language("Meadow", "Prairie", "Motivo Giardinfiore"), language("Modern", "Moderne", "Motivo Trendy"), language("Marine", "Marin", "Motivo Marino"), language("Archipelago", "Archipel", "Motivo Arcipelago"), language("High-Plains", "Hautes Plaines", "Motivo Deserto"), language("Sandstorm", "Tempête de Sable", "Motivo Sabbia"), language("River", "Rivière", "Motivo Fluviale"), language("Monsoon", "Mousson", "Motivo Pluviale"), language("Savannah", "Savane", "Motivo Savana"), language("Sun", "Soleil", "Motivo Solare"), language("Ocean", "Océan", "Motivo Oceanico"), language("Jungle", "Jungle", "Motivo Giungla"), language("Fancy", "Chic", "Motivo Sbarazzino"), language("Poké Ball", "Poké Ball", "Motivo Poké Ball")};
                    break;

                case 669: // Flabébé
                case 671: // Florges
                    options = {language("Red", "Rouge", "Fiore Rosso"), language("Yellow", "Jeune", "Fiore Giallo"), language("Orange", "Orange", "Fiore Arancione"), language("Blue", "Bleu", "Fiore Blu"), language("White", "Blanc", "Fiore Bianco")};
                    break;

                case 670: // Floette
                    options = {language("Red", "Rouge", "Fiore Rosso"), language("Yellow", "Jeune", "Fiore Giallo"), language("Orange", "Orange", "Fiore Arancione"), language("Blue", "Bleu", "Fiore Blu"), language("White", "Blanc", "Fiore Bianco"), language("Eternal", "Éternelle", "Fiore Eterno")};
                    break;

                case 676: // Furfrou
                    options = {language("Natural", "Naturel", "Selvatica"), language("Heart", "Coeur", "Taglio Cuore"), language("Star", "Étoile", "Taglio Stella"), language("Diamond", "Diamant", "Taglio Diamante"), language("Deputante", "Débutante", "Taglio Signorina"), language("Matron", "Dame", "Taglio Gentildonna"), language("Dandy", "Dandy", "Taglio Gentiluomo"), language("La Reine", "La Reine", "Taglio Regina"), language("Kabuki", "Kabuki", "Taglio Kabuki"), language("Pharaoh", "Pharaon", "Taglio Faraone")};
                        break;

                case 681: // Aegislash
                    options = {language("Shield", "Bouclier", "Scudo"), language("Blade", "Lame", "Spada")};
                    break;

                case 710: // Pumpkaboo
                case 711: // Gourgeist
                    options = {language("Average", "Moyen", "Normale"), language("Small", "Petit", "Mini"), language("Large", "Grand", "Grande"), language("Super", "Super", "Maxi")};
                    break;

                case 716: // Xerneas
                    options = {language("Neutral", "Neutre", "Modo Relax"), language("Active", "Actif", "Modo Attivo")};
                    break;

                case 720: // Hoopa
                    options = Helpers::GetVersion<string>({language("Confined", "Confiné", "Vincolato")}, {language("Confined", "Confiné", "Vincolato"), language("Unbound", "Détaché", "Libero")});
                    break;

                default:  // All Others
                    options = {language("Normal", "Normale", "Normale")};
                    break;
            }

            return options;
        }
    }

    namespace Gen7 {
        static const vector<string> Forms(int pokeNo) {
            vector<string> options;

            switch (pokeNo) {
                case 3:   // Venusaur
                case 9:   // Blastoise
                case 15:  // Beedrill
                case 18:  // Pidgeot
                case 65:  // Alakazam
                case 80:  // Slowbro
                case 94:  // Gengar
                case 115: // Kangaskhan
                case 127: // Pinsir
                case 130: // Gyarados
                case 142: // Aerodactyl
                case 181: // Ampharos
                case 208: // Steelix
                case 212: // Scizor
                case 214: // Heracross
                case 229: // Houndoom
                case 248: // Tyranitar
                case 254: // Sceptile
                case 257: // Blaziken
                case 260: // Swampert
                case 282: // Gardevoir
                case 302: // Sableye
                case 303: // Mawile
                case 306: // Aggron
                case 308: // Medicham
                case 310: // Manectric
                case 319: // Sharpedo
                case 323: // Camerupt
                case 334: // Altaria
                case 354: // Banette
                case 359: // Absol
                case 362: // Glalie
                case 373: // Salamence
                case 376: // Metagross
                case 380: // Latias
                case 381: // Latios
                case 384: // Rayquaza
                case 428: // Lopunny
                case 445: // Garchomp
                case 448: // Lucario
                case 460: // Abomasnow
                case 475: // Gallade
                case 531: // Audino
                case 719: // Diancie
                    options = {language("Normal", "Normale", "Normale"), "Mega"};
                    break;

                case 6:   // Charizard
                case 150: // Mewtwo
                    options = {language("Normal", "Normale", "Normale"), "Mega X", "Mega Y"};
                    break;

                case 19:  // Rattata
                case 26:  // Raichu
                case 27:  // Sandshrew
                case 28:  // Sandslash
                case 37:  // Vulpix
                case 38:  // Ninetails
                case 50:  // Diglett
                case 51:  // Dugtrio
                case 52:  // Meowth
                case 53:  // Persian
                case 74:  // Geodude
                case 75:  // Graveler
                case 76:  // Golem
                case 88:  // Grimer
                case 89:  // Muk
                case 105: // Exeggutor
                    options = {language("Normal", "Normale", "Normale"), "Alola"};
                    break;

                case 20:  // Raticate
                case 103: // Marowak
                    options = {language("Normal", "Normale", "Normale"), "Alola", language("Totem", "Totémique", "Dominante")};
                    break;

                case 201: // Unown
                    options = {"A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "!", "?"};
                    break;

                case 351: // Castform
                    options = {language("Normal", "Normale", "Normale"), language("Sunny", "Ensoleillée", "Sole"), language("Rainy", "Pluvieuse", "Pioggia"), language("Snowy", "Neigeuse", "Nuvola di Neve")};
                    break;

                case 382: // Kyogre
                case 383: // Groudon
                    options = {language("Normal", "Normale", "Normale"), language("Primal", "Primordiale", "Primordiale")};
                    break;

                case 386: // Deoxys
                    options = {language("Normal", "Normale", "Normale"), language("Attack", "Attaque", "Attacco"), language("Defense", "Défense", "Difesa"), language("Speed", "Vitesse", "Velocità")};
                    break;

                case 412: // Burmy
                case 413: // Wormadam
                case 414: // Mothim
                    options = {language("Plant", "Végétale", "Pianta"), language("Sandy", "Sableuse", "Sabbia"), language("Trash", "Déchet", "Scarti") };
                    break;

                case 422: // Shellos
                case 423: // Gastrodon
                    options = {language("East", "Est", "Mare Est"), language("West" , "Ouest", "Mare Ovest") };
                    break;

                case 479: // Rotom
                    options = {language("Normal", "Normale", "Normale"), language("Heat", "Chauffée", "Calore"), language("Wash", "Lavée", "Lavaggio"), language("Frost", "Glacée", "Gelo"), language("Fan", "Hélice", "Vortice"), language("Mow", "Tonte", "Taglio")};
                    break;

                case 487: // Giratina
                    options = {language("Altered", "Altérée", "Alterata"), language("Origin", "Originelle", "Originale")};
                    break;

                case 492: // Shaymin
                    options = {language("Land", "Terrestre", "Terra"), language("Sky", "Céleste", "Cielo")};
                    break;

                case 493: // Arceus
                case 773: // Silvally
                    options = {language("Normal", "Normale", "Normale"), language("Fighting", "Combat", "Lotta"), language("Flying", "Vol", "Volo"), language("Poison", "Poison", "Veleno"), language("Ground", "Sol", "Terra"), language("Rock", "Roche", "Roccia"), language("Bug", "Insecte", "Coleottero"), language("Ghost", "Spectre", "Spettro"), language("Steel", "Acier", "Acciaio"), language("Fire", "Feu", "Fuoco"), language("Water", "Eau", "Acqua"), language("Grass", "Plante", "Erba"), language("Electric", "Électrique", "Elettro"), language("Psychic", "Psychic", "Psico"), language("Ice", "Glace", "Ghiaccio"), language("Dragon", "Dragon", "Drago"), language("Dark", "Ténèbres", "Buio"), language("Fairy", "Fée", "Folletto")};
                    break;

                case 550: // Basculin
                    options = {language("Red", "Rouge", "Linearossa"), language("Blue", "Bleu", "Lineablu")};
                    break;

                case 555: // Darmanitan
                    options = {"Standard", language("Zen", "Zen", "Stato Zen")};
                    break;

                case 585: // Deerling
                case 586: // Sawsbuck
                    options = {language("Spring", "Printemps", "Primavera"), language("Summer", "Été", "Estate"), language("Autumn", "Automne", "Autunno"), language("Winter", "Hiver", "Inverno")};
                    break;

                case 641: // Tornadus
                case 642: // Thundurus
                case 645: // Landorus
                    options = {language("Incarnate", "Incarnée", "Incarnazione"), language("Therian", "Thériane", "Totem")};
                    break;

                case 646: // Kyurem
                    options = {language("Normal", "Normale", "Normale"), language("White", "Blanc", "Kyurem Bianco"), language("Black", "Noir", "Kyurem Nero")};
                    break;

                case 647: // Keldeo
                    options = {language("Ordinary", "Ordinaire", "Normale"), language("Resolute", "Résolue", "Risoluta")};
                    break;

                case 648: // Meloetta
                    options = {language("Aria", "Chant", "Canto"), language("Pirouette", "Danse", "Danza")};
                    break;

                case 649: // Genesect
                    options = {language("Normal", "Normale", "Senza modulo"), language("Douse", "Éteindre", "Idromodulo"), language("Shock", "Choc", "Voltmodulo"), language("Burn", "Brûler", "Piromodulo"), language("Chill", "Glacer", "Gelomodulo")};
                    break;

                case 658: // Greninja
                    options = {language("Normal", "Normale", "Normale"), "Ash"};
                    break;

                case 664: // Scatterbug
                case 665: // Spewpa
                case 666: // Vivillon
                    options = {language("Icy Snow", "Neige Glacée", "Motivo Nevi Perenni"), language("Polar", "Polaire", "Motivo Nordico"), language("Tundra", "Toundra", "Motivo Manto di Neve"), language("Continental", "Continental", "Motivo Continentale"), language("Garden", "Jardin", "Motivo Prato"), language("Elegant", "Élégant", "Motivo Eleganza"), language("Meadow", "Prairie", "Motivo Giardinfiore"), language("Modern", "Moderne", "Motivo Trendy"), language("Marine", "Marin", "Motivo Marino"), language("Archipelago", "Archipel", "Motivo Arcipelago"), language("High-Plains", "Hautes Plaines", "Motivo Deserto"), language("Sandstorm", "Tempête de Sable", "Motivo Sabbia"), language("River", "Rivière", "Motivo Fluviale"), language("Monsoon", "Mousson", "Motivo Pluviale"), language("Savannah", "Savane", "Motivo Savana"), language("Sun", "Soleil", "Motivo Solare"), language("Ocean", "Océan", "Motivo Oceanico"), language("Jungle", "Jungle", "Motivo Giungla"), language("Fancy", "Chic", "Motivo Sbarazzino"), language("Poké Ball", "Poké Ball", "Motivo Poké Ball")};
                    break;

                case 669: // Flabébé
                case 671: // Florges
                    options = {language("Red", "Rouge", "Fiore Rosso"), language("Yellow", "Jeune", "Fiore Giallo"), language("Orange", "Orange", "Fiore Arancione"), language("Blue", "Bleu", "Fiore Blu"), language("White", "Blanc", "Fiore Bianco")};
                    break;

                case 670: // Floette
                    options = {language("Red", "Rouge", "Fiore Rosso"), language("Yellow", "Jeune", "Fiore Giallo"), language("Orange", "Orange", "Fiore Arancione"), language("Blue", "Bleu", "Fiore Blu"), language("White", "Blanc", "Fiore Bianco"), language("Eternal", "Éternelle", "Fiore Eterno")};
                    break;

                case 676: // Furfrou
                    options = {language("Natural", "Naturel", "Selvatica"), language("Heart", "Coeur", "Taglio Cuore"), language("Star", "Étoile", "Taglio Stella"), language("Diamond", "Diamant", "Taglio Diamante"), language("Deputante", "Débutante", "Taglio Signorina"), language("Matron", "Dame", "Taglio Gentildonna"), language("Dandy", "Dandy", "Taglio Gentiluomo"), language("La Reine", "La Reine", "Taglio Regina"), language("Kabuki", "Kabuki", "Taglio Kabuki"), language("Pharaoh", "Pharaon", "Taglio Faraone")};
                    break;

                case 681: // Aegislash
                    options = {language("Shield", "Bouclier", "Scudo"), language("Blade", "Lame", "Spada")};
                    break;

                case 710: // Pumpkaboo
                case 711: // Gourgeist
                    options = {language("Average", "Moyen", "Normale"), language("Small", "Petit", "Mini"), language("Large", "Grand", "Grande"), language("Super", "Super", "Maxi")};
                    break;

                case 716: // Xerneas
                    options = {language("Neutral", "Neutre", "Modo Relax"), language("Active", "Actif", "Forma Attivo")};
                    break;

                case 718: // Zygarde
                    options = {"50%", "10%", "10%-C", "50%-C", "100%-C"};
                    break;

                case 720: // Hoopa
                    options = {language("Confined", "Confiné", "Vincolato"), language("Unbound", "Détaché", "Libero")};
                    break;

                case 735: // Gumshoos
                case 738: // Vikavolt
                case 743: // Ribombee
                case 752: // Araquanid
                case 754: // Lurantis
                case 758: // Salazzle
                case 777: // Togedemaru
                case 784: // Kommo-o
                    options = {language("Normal", "Normale", "Normale"), language("Totem", "Totémique", "Dominante")};
                    break;

                case 741: // Oricorio
                    options = {language("Red", "Rouge", "Stile Flamenco"), language("Yellow", "Jaune", "Stile Cheerdance"), language("Pink", "Rose", "Stile Hula"), language("Blue" , "Bleu", "Stile Buyō")};
                    break;

                case 745: // Lycanroc
                    options = {language("Midday", "Midi", "Giorno"), language("Midnight", "Minuit", "Notte"), language("Dusk", "Crépuscule", "Crepuscolo")};
                    break;

                case 746: // Wishiwashi
                    options = {language("Normal", "Normale", "Individuale"), language("School", "École", "Banco")};
                    break;

                case 774: // Minior
                    options = {language("Random", "Aléatoire", "Random")};
                    break;

                case 778: // Mimikyu
                    options = {language("Disguised", "Déguisé", "Mascherata"), language("Busted", "Démasqué", "Smascherata")};
                    break;

                case 800: // Necrozma
                    options = Helpers::GetVersion<string>({language("Normal", "Normale", "Normale")}, {language("Normal", "Normale", "Normale"), language("Dawn", "Dawn", "Criniera del Vespro"), language("Dusk", "Crépuscule", "Ali dell'Aurora"), "Ultra"});
                    break;

                case 801: // Magearna
                    options = {language("Normal", "Normale", "Normale"), language("Original", "Originale", "Colore Antico")};
                    break;

                default:  // All Others
                    options = {language("Normal", "Normale", "Normale")};
                    break;
            }

            return options;
        }
    }

    extern const int expTable[100][6];
    static const vector<vector<int>> growthRates = {{10, 11, 12, 13, 14, 15, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 37, 38, 41, 42, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 95, 96, 97, 98, 99, 100, 101, 104, 105, 106, 107, 108, 109, 110, 114, 115, 116, 117, 118, 119, 122, 123, 124, 125, 126, 132, 133, 134, 135, 136, 137, 138, 139, 140, 141, 161, 162, 163, 164, 169, 172, 177, 178, 185, 193, 194, 195, 196, 197, 199, 201, 202, 203, 204, 205, 206, 208, 211, 212, 216, 217, 218, 219, 223, 224, 230, 231, 232, 233, 236, 237, 238, 239, 240, 261, 262, 263, 264, 265, 266, 267, 268, 269, 278, 279, 283, 284, 299, 307, 308, 311, 312, 322, 323, 324, 339, 340, 343, 344, 351, 360, 361, 362, 399, 400, 412, 413, 414, 417, 418, 419, 420, 421, 422, 423, 427, 428, 434, 435, 436, 437, 438, 439, 442, 453, 454, 462, 463, 465, 466, 467, 469, 470, 471, 474, 476, 478, 479, 504, 505, 509, 510, 511, 512, 513, 514, 515, 516, 522, 523, 527, 528, 529, 530, 538, 539, 546, 547, 548, 549, 550, 556, 557, 558, 559, 560, 561, 562, 563, 564, 565, 566, 567, 568, 569, 580, 581, 585, 586, 587, 588, 589, 590, 591, 592, 593, 595, 596, 597, 598, 605, 606, 613, 614, 615, 616, 617, 618, 621, 622, 623, 624, 625, 626, 631, 632, 659, 660, 664, 665, 666, 669, 670, 671, 672, 673, 674, 675, 676, 677, 678, 679, 680, 681, 682, 683, 684, 685, 686, 687, 688, 689, 690, 691, 694, 695, 696, 697, 698, 699, 700, 701, 702, 708, 709, 710, 711, 712, 713, 714, 715, 731, 732, 733, 734, 735, 736, 737, 738, 739, 740, 741, 742, 743, 744, 745, 747, 748, 749, 750, 751, 752, 753, 754, 755, 756, 757, 758, 759, 760, 767, 768, 769, 770, 776, 777, 778, 779, 780, 781}, {290, 291, 292, 313, 333, 334, 335, 345, 346, 347, 348, 349, 350, 366, 367, 368, 408, 409, 410, 411, 456, 457}, {285, 286, 296, 297, 314, 316, 317, 320, 321, 336, 341, 342, 425, 426}, {1, 2, 3, 4, 5, 6, 7, 8, 9, 16, 17, 18, 29, 30, 31, 32, 33, 34, 43, 44, 45, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 74, 75, 76, 92, 93, 94, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 179, 180, 181, 182, 186, 187, 188, 189, 191, 192, 198, 207, 213, 215, 251, 252, 253, 254, 255, 256, 257, 258, 259, 260, 270, 271, 272, 273, 274, 275, 276, 277, 293, 294, 295, 302, 315, 328, 329, 330, 331, 332, 352, 359, 363, 364, 365, 387, 388, 389, 390, 391, 392, 393, 394, 395, 396, 397, 398, 401, 402, 403, 404, 405, 406, 407, 415, 416, 430, 441, 447, 448, 461, 472, 492, 495, 496, 497, 498, 499, 500, 501, 502, 503, 506, 507, 508, 519, 520, 521, 524, 525, 526, 532, 533, 534, 535, 536, 537, 540, 541, 542, 543, 544, 545, 551, 552, 553, 554, 555, 570, 571, 574, 575, 576, 577, 578, 579, 599, 600, 601, 607, 608, 609, 619, 620, 650, 651, 652, 653, 654, 655, 656, 657, 658, 661, 662, 663, 667, 668, 722, 723, 724, 725, 726, 727, 728, 729, 730, 761, 762, 763, 774}, {35, 36, 39, 40, 113, 165, 166, 167, 168, 173, 174, 175, 176, 183, 184, 190, 200, 209, 210, 222, 225, 235, 242, 298, 300, 301, 303, 325, 326, 327, 337, 338, 353, 354, 355, 356, 358, 370, 424, 429, 431, 432, 433, 440, 468, 477, 517, 518, 531, 572, 573, 594, 707, 746, 764, 771}, {58, 59, 72, 73, 90, 91, 102, 103, 111, 112, 120, 121, 127, 128, 129, 130, 131, 142, 143, 144, 145, 146, 147, 148, 149, 150, 170, 171, 214, 220, 221, 226, 227, 228, 229, 234, 241, 243, 244, 245, 246, 247, 248, 249, 250, 280, 281, 282, 287, 288, 289, 304, 305, 306, 309, 310, 318, 319, 357, 369, 371, 372, 373, 374, 375, 376, 377, 378, 379, 380, 381, 382, 383, 384, 385, 386, 443, 444, 445, 446, 449, 450, 451, 452, 455, 458, 459, 460, 464, 473, 475, 480, 481, 482, 483, 484, 485, 486, 487, 488, 489, 490, 491, 493, 494, 582, 583, 584, 602, 603, 604, 610, 611, 612, 627, 628, 629, 630, 633, 634, 635, 636, 637, 638, 639, 640, 641, 642, 643, 644, 645, 646, 647, 648, 649, 692, 693, 703, 704, 705, 706, 716, 717, 718, 719, 720, 721, 765, 766, 772, 773, 775, 782, 783, 784, 785, 786, 787, 788, 789, 790, 791, 792, 793, 794, 795, 796, 797, 798, 799, 800, 801, 802, 803, 804, 805, 806, 807}};;

    namespace English {
        static const vector<string> allNatures = {
            "Hardy",
            "Lonely",
            "Brave",
            "Adamant",
            "Naughty",
            "Bold",
            "Docile",
            "Relaxed",
            "Impish",
            "Lax",
            "Timid",
            "Hasty",
            "Serious",
            "Jolly",
            "Naive",
            "Modest",
            "Mild",
            "Quiet",
            "Bashful",
            "Rash",
            "Calm",
            "Gentle",
            "Sassy",
            "Careful",
            "Quirky"
        };
    }

    namespace French {
        static const vector<string> allNatures = {
            "Hardi",
            "Solo",
            "Brave",
            "Rigide",
            "Mauvais",
            "Assuré",
            "Docile",
            "Relax",
            "Malin",
            "Lâche",
            "Timide",
            "Pressé",
            "Sérieux",
            "Jovial",
            "Naïf",
            "Modeste",
            "Doux",
            "Discret",
            "Pudique",
            "Foufou",
            "Calme",
            "Gentil",
            "Malpoli",
            "Prudent",
            "Bizarre"
        };
    }

    namespace Italian {
        static const vector<string> allNatures = {
            "Ardita",
            "Schiva",
            "Audace",
            "Decisa",
            "Birbona",
            "Sicura",
            "Docile",
            "Placida",
            "Scaltra",
            "Fiacca",
            "Timida",
            "Lesta",
            "Seria",
            "Allegra",
            "Ingenua",
            "Modesta",
            "Mite",
            "Quieta",
            "Ritrosa",
            "Ardente",
            "Calma",
            "Gentile",
            "Vivace",
            "Cauta",
            "Furba"
        };
    }

    static const vector<int> fixedGender = {29, 30, 31, 32, 33, 34, 81, 82, 100, 101, 106, 107, 113, 115, 120, 121, 124, 128, 132, 137, 144, 150, 151, 172, 201, 233, 236, 237, 238, 241, 242, 243, 244, 245, 249, 250, 251, 292, 313, 314, 337, 338, 343, 344, 374, 375, 376, 377, 378, 379, 380, 381, 382, 383, 384, 385, 386, 413, 414, 416, 436, 437, 440, 462, 474, 475, 478, 479, 480, 481, 482, 483, 484, 486, 487, 488, 489, 490, 491, 492, 493, 494, 538, 539, 548, 549, 599, 600, 601, 615, 622, 623, 627, 628, 629, 630, 638, 639, 640, 641, 642, 643, 644, 645, 646, 647, 648, 649, 669, 670, 671, 703, 716, 717, 718, 719, 720, 721, 758, 761, 762, 763, 772, 773, 774, 781, 785, 786, 787, 788, 789, 790, 791, 792, 793, 794, 795, 796, 797, 798, 799, 800, 801, 802, 803, 804, 805, 806, 807};

    void FindAbilityKB(MenuEntry *entry);

    namespace English {
        static const char *allItems[959] = {
            "Master Ball",
            "Ultra Ball",
            "Great Ball",
            "Poké Ball",
            "Safari Ball",
            "Net Ball",
            "Dive Ball",
            "Nest Ball",
            "Repeat Ball",
            "Timer Ball",
            "Luxury Ball",
            "Premier Ball",
            "Dusk Ball",
            "Heal Ball",
            "Quick Ball",
            "Cherish Ball",
            "Potion",
            "Antidote",
            "Burn Heal",
            "Ice Heal",
            "Awakening",
            "Paralyze Heal",
            "Full Restore",
            "Max Potion",
            "Hyper Potion",
            "Super Potion",
            "Full Heal",
            "Revive",
            "Max Revive",
            "Fresh Water",
            "Soda Pop",
            "Lemonade",
            "Moomoo Milk",
            "Energy Powder",
            "Energy Root",
            "Heal Powder",
            "Revival Herb",
            "Ether",
            "Max Ether",
            "Elixir",
            "Max Elixir",
            "Lava Cookie",
            "Berry Juice",
            "Sacred Ash",
            "HP Up",
            "Protein",
            "Iron",
            "Carbos",
            "Calcium",
            "Rare Candy",
            "PP Up",
            "Zinc",
            "PP Max",
            "Old Gateau",
            "Guard Spec.",
            "Dire Hit",
            "X Attack",
            "X Defense",
            "X Speed",
            "X Accuracy",
            "X Sp. Atk",
            "X Sp. Def",
            "Poké Doll",
            "Fluffy Tail",
            "Blue Flute",
            "Yellow Flute",
            "Red Flute",
            "Black Flute",
            "White Flute",
            "Shoal Salt",
            "Shoal Shell",
            "Red Shard",
            "Blue Shard",
            "Yellow Shard",
            "Green Shard",
            "Super Repel",
            "Max Repel",
            "Escape Rope",
            "Repel",
            "Sun Stone",
            "Moon Stone",
            "Fire Stone",
            "Thunder Stone",
            "Water Stone",
            "Leaf Stone",
            "Tiny Mushroom",
            "Big Mushroom",
            "Pearl",
            "Big Pearl",
            "Stardust",
            "Star Piece",
            "Nugget",
            "Heart Scale",
            "Honey",
            "Growth Mulch",
            "Damp Mulch",
            "Stable Mulch",
            "Gooey Mulch",
            "Root Fossil",
            "Claw Fossil",
            "Helix Fossil",
            "Dome Fossil",
            "Old Amber",
            "Armor Fossil",
            "Skull Fossil",
            "Rare Bone",
            "Shiny Stone",
            "Dusk Stone",
            "Dawn Stone",
            "Oval Stone",
            "Odd Keystone",
            "Griseous Orb",
            "Tea",
            "???",
            "Autograph",
            "Douse Drive",
            "Shock Drive",
            "Burn Drive",
            "Chill Drive",
            "???",
            "Pokémon Box Link",
            "Medicine Pocket",
            "TM Case",
            "Candy Jar",
            "Power-Up Pocket",
            "Clothing Trunk",
            "Catching Pocket",
            "Battle Pocket",
            "???",
            "???",
            "???",
            "???",
            "???",
            "Sweet Heart",
            "Adamant Orb",
            "Lustrous Orb",
            "Greet Mail",
            "Favored Mail",
            "RSVP Mail",
            "Thanks Mail",
            "Inquiry Mail",
            "Like Mail",
            "Reply Mail",
            "Bridge Mail S",
            "Bridge Mail D",
            "Bridge Mail T",
            "Bridge Mail V",
            "Bridge Mail M",
            "Cheri Berry",
            "Chesto Berry",
            "Pecha Berry",
            "Rawst Berry",
            "Aspear Berry",
            "Leppa Berry",
            "Oran Berry",
            "Persim Berry",
            "Lum Berry",
            "Sitrus Berry",
            "Figy Berry",
            "Wiki Berry",
            "Mago Berry",
            "Aguav Berry",
            "Iapapa Berry",
            "Razz Berry",
            "Bluk Berry",
            "Nanab Berry",
            "Wepear Berry",
            "Pinap Berry",
            "Pomeg Berry",
            "Kelpsy Berry",
            "Qualot Berry",
            "Hondew Berry",
            "Grepa Berry",
            "Tamato Berry",
            "Cornn Berry",
            "Magost Berry",
            "Rabuta Berry",
            "Nomel Berry",
            "Spelon Berry",
            "Pamtre Berry",
            "Watmel Berry",
            "Durin Berry",
            "Belue Berry",
            "Occa Berry",
            "Passho Berry",
            "Wacan Berry",
            "Rindo Berry",
            "Yache Berry",
            "Chople Berry",
            "Kebia Berry",
            "Shuca Berry",
            "Coba Berry",
            "Payapa Berry",
            "Tanga Berry",
            "Charti Berry",
            "Kasib Berry",
            "Haban Berry",
            "Colbur Berry",
            "Babiri Berry",
            "Chilan Berry",
            "Liechi Berry",
            "Ganlon Berry",
            "Salac Berry",
            "Petaya Berry",
            "Apicot Berry",
            "Lansat Berry",
            "Starf Berry",
            "Enigma Berry",
            "Micle Berry",
            "Custap Berry",
            "Jaboca Berry",
            "Rowap Berry",
            "Bright Powder",
            "White Herb",
            "Macho Brace",
            "Exp. Share",
            "Quick Claw",
            "Soothe Bell",
            "Mental Herb",
            "Choice Band",
            "King’s Rock",
            "Silver Powder",
            "Amulet Coin",
            "Cleanse Tag",
            "Soul Dew",
            "Deep Sea Tooth",
            "Deep Sea Scale",
            "Smoke Ball",
            "Everstone",
            "Focus Band",
            "Lucky Egg",
            "Scope Lens",
            "Metal Coat",
            "Leftovers",
            "Dragon Scale",
            "Light Ball",
            "Soft Sand",
            "Hard Stone",
            "Miracle Seed",
            "Black Glasses",
            "Black Belt",
            "Magnet",
            "Mystic Water",
            "Sharp Beak",
            "Poison Barb",
            "Never-Melt Ice",
            "Spell Tag",
            "Twisted Spoon",
            "Charcoal",
            "Dragon Fang",
            "Silk Scarf",
            "Upgrade",
            "Shell Bell",
            "Sea Incense",
            "Lax Incense",
            "Lucky Punch",
            "Metal Powder",
            "Thick Club",
            "Leek",
            "Red Scarf",
            "Blue Scarf",
            "Pink Scarf",
            "Green Scarf",
            "Yellow Scarf",
            "Wide Lens",
            "Muscle Band",
            "Wise Glasses",
            "Expert Belt",
            "Light Clay",
            "Life Orb",
            "Power Herb",
            "Toxic Orb",
            "Flame Orb",
            "Quick Powder",
            "Focus Sash",
            "Zoom Lens",
            "Metronome",
            "Iron Ball",
            "Lagging Tail",
            "Destiny Knot",
            "Black Sludge",
            "Icy Rock",
            "Smooth Rock",
            "Heat Rock",
            "Damp Rock",
            "Grip Claw",
            "Choice Scarf",
            "Sticky Barb",
            "Power Bracer",
            "Power Belt",
            "Power Lens",
            "Power Band",
            "Power Anklet",
            "Power Weight",
            "Shed Shell",
            "Big Root",
            "Choice Specs",
            "Flame Plate",
            "Splash Plate",
            "Zap Plate",
            "Meadow Plate",
            "Icicle Plate",
            "Fist Plate",
            "Toxic Plate",
            "Earth Plate",
            "Sky Plate",
            "Mind Plate",
            "Insect Plate",
            "Stone Plate",
            "Spooky Plate",
            "Draco Plate",
            "Dread Plate",
            "Iron Plate",
            "Odd Incense",
            "Rock Incense",
            "Full Incense",
            "Wave Incense",
            "Rose Incense",
            "Luck Incense",
            "Pure Incense",
            "Protector",
            "Electirizer",
            "Magmarizer",
            "Dubious Disc",
            "Reaper Cloth",
            "Razor Claw",
            "Razor Fang",
            "TM01",
            "TM02",
            "TM03",
            "TM04",
            "TM05",
            "TM06",
            "TM07",
            "TM08",
            "TM09",
            "TM10",
            "TM11",
            "TM12",
            "TM13",
            "TM14",
            "TM15",
            "TM16",
            "TM17",
            "TM18",
            "TM19",
            "TM20",
            "TM21",
            "TM22",
            "TM23",
            "TM24",
            "TM25",
            "TM26",
            "TM27",
            "TM28",
            "TM29",
            "TM30",
            "TM31",
            "TM32",
            "TM33",
            "TM34",
            "TM35",
            "TM36",
            "TM37",
            "TM38",
            "TM39",
            "TM40",
            "TM41",
            "TM42",
            "TM43",
            "TM44",
            "TM45",
            "TM46",
            "TM47",
            "TM48",
            "TM49",
            "TM50",
            "TM51",
            "TM52",
            "TM53",
            "TM54",
            "TM55",
            "TM56",
            "TM57",
            "TM58",
            "TM59",
            "TM60",
            "TM61",
            "TM62",
            "TM63",
            "TM64",
            "TM65",
            "TM66",
            "TM67",
            "TM68",
            "TM69",
            "TM70",
            "TM71",
            "TM72",
            "TM73",
            "TM74",
            "TM75",
            "TM76",
            "TM77",
            "TM78",
            "TM79",
            "TM80",
            "TM81",
            "TM82",
            "TM83",
            "TM84",
            "TM85",
            "TM86",
            "TM87",
            "TM88",
            "TM89",
            "TM90",
            "TM91",
            "TM92",
            "HM01",
            "HM02",
            "HM03",
            "HM04",
            "HM05",
            "HM06",
            "???",
            "???",
            "Explorer Kit",
            "Loot Sack",
            "Rule Book",
            "Poké Radar",
            "Point Card",
            "Journal",
            "Seal Case",
            "Fashion Case",
            "Seal Bag",
            "Pal Pad",
            "Works Key",
            "Old Charm",
            "Galactic Key",
            "Red Chain",
            "Town Map",
            "Vs. Seeker",
            "Coin Case",
            "Old Rod",
            "Good Rod",
            "Super Rod",
            "Sprayduck",
            "Poffin Case",
            "Bike",
            "Suite Key",
            "Oak’s Letter",
            "Lunar Wing",
            "Member Card",
            "Azure Flute",
            "S.S. Ticket",
            "Contest Pass",
            "Magma Stone",
            "Parcel",
            "Coupon 1",
            "Coupon 2",
            "Coupon 3",
            "Storage Key",
            "Secret Potion",
            "Vs. Recorder",
            "Gracidea",
            "Secret Key",
            "Apricorn Box",
            "Unown Report",
            "Berry Pots",
            "Dowsing Machine",
            "Blue Card",
            "Slowpoke Tail",
            "Clear Bell",
            "Card Key",
            "Basement Key",
            "Squirt Bottle",
            "Red Scale",
            "Lost Item",
            "Pass",
            "Machine Part",
            "Silver Wing",
            "Rainbow Wing",
            "Mystery Egg",
            "Red Apricorn",
            "Blue Apricorn",
            "Yellow Apricorn",
            "Green Apricorn",
            "Pink Apricorn",
            "White Apricorn",
            "Black Apricorn",
            "Fast Ball",
            "Level Ball",
            "Lure Ball",
            "Heavy Ball",
            "Love Ball",
            "Friend Ball",
            "Moon Ball",
            "Sport Ball",
            "Park Ball",
            "Photo Album",
            "GB Sounds",
            "Tidal Bell",
            "Rage Candy Bar",
            "Data Card 01",
            "Data Card 02",
            "Data Card 03",
            "Data Card 04",
            "Data Card 05",
            "Data Card 06",
            "Data Card 07",
            "Data Card 08",
            "Data Card 09",
            "Data Card 10",
            "Data Card 11",
            "Data Card 12",
            "Data Card 13",
            "Data Card 14",
            "Data Card 15",
            "Data Card 16",
            "Data Card 17",
            "Data Card 18",
            "Data Card 19",
            "Data Card 20",
            "Data Card 21",
            "Data Card 22",
            "Data Card 23",
            "Data Card 24",
            "Data Card 25",
            "Data Card 26",
            "Data Card 27",
            "Jade Orb",
            "Lock Capsule",
            "Red Orb",
            "Blue Orb",
            "Enigma Stone",
            "Prism Scale",
            "Eviolite",
            "Float Stone",
            "Rocky Helmet",
            "Air Balloon",
            "Red Card",
            "Ring Target",
            "Binding Band",
            "Absorb Bulb",
            "Cell Battery",
            "Eject Button",
            "Fire Gem",
            "Water Gem",
            "Electric Gem",
            "Grass Gem",
            "Ice Gem",
            "Fighting Gem",
            "Poison Gem",
            "Ground Gem",
            "Flying Gem",
            "Psychic Gem",
            "Bug Gem",
            "Rock Gem",
            "Ghost Gem",
            "Dragon Gem",
            "Dark Gem",
            "Steel Gem",
            "Normal Gem",
            "Health Feather",
            "Muscle Feather",
            "Resist Feather",
            "Genius Feather",
            "Clever Feather",
            "Swift Feather",
            "Pretty Feather",
            "Cover Fossil",
            "Plume Fossil",
            "Liberty Pass",
            "Pass Orb",
            "Dream Ball",
            "Poké Toy",
            "Prop Case",
            "Dragon Skull",
            "Balm Mushroom",
            "Big Nugget",
            "Pearl String",
            "Comet Shard",
            "Relic Copper",
            "Relic Silver",
            "Relic Gold",
            "Relic Vase",
            "Relic Band",
            "Relic Statue",
            "Relic Crown",
            "Casteliacone",
            "Dire Hit 2",
            "X Speed 2",
            "X Sp. Atk 2",
            "X Sp. Def 2",
            "X Defense 2",
            "X Attack 2",
            "X Accuracy 2",
            "X Speed 3",
            "X Sp. Atk 3",
            "X Sp. Def 3",
            "X Defense 3",
            "X Attack 3",
            "X Accuracy 3",
            "X Speed 6",
            "X Sp. Atk 6",
            "X Sp. Def 6",
            "X Defense 6",
            "X Attack 6",
            "X Accuracy 6",
            "Ability Urge",
            "Item Drop",
            "Item Urge",
            "Reset Urge",
            "Dire Hit 3",
            "Light Stone",
            "Dark Stone",
            "TM93",
            "TM94",
            "TM95",
            "Xtransceiver",
            "???",
            "Gram 1",
            "Gram 2",
            "Gram 3",
            "Xtransceiver",
            "Medal Box",
            "DNA Splicers",
            "DNA Splicers",
            "Permit",
            "Oval Charm",
            "Shiny Charm",
            "Plasma Card",
            "Grubby Hanky",
            "Colress Machine",
            "Dropped Item",
            "Dropped Item",
            "Reveal Glass",
            "Weakness Policy",
            "Assault Vest",
            "Holo Caster",
            "Prof’s Letter",
            "Roller Skates",
            "Pixie Plate",
            "Ability Capsule",
            "Whipped Dream",
            "Sachet",
            "Luminous Moss",
            "Snowball",
            "Safety Goggles",
            "Poké Flute",
            "Rich Mulch",
            "Surprise Mulch",
            "Boost Mulch",
            "Amaze Mulch",
            "Gengarite",
            "Gardevoirite",
            "Ampharosite",
            "Venusaurite",
            "Charizardite X",
            "Blastoisinite",
            "Mewtwonite X",
            "Mewtwonite Y",
            "Blazikenite",
            "Medichamite",
            "Houndoominite",
            "Aggronite",
            "Banettite",
            "Tyranitarite",
            "Scizorite",
            "Pinsirite",
            "Aerodactylite",
            "Lucarionite",
            "Abomasite",
            "Kangaskhanite",
            "Gyaradosite",
            "Absolite",
            "Charizardite Y",
            "Alakazite",
            "Heracronite",
            "Mawilite",
            "Manectite",
            "Garchompite",
            "Latiasite",
            "Latiosite",
            "Roseli Berry",
            "Kee Berry",
            "Maranga Berry",
            "Sprinklotad",
            "TM96",
            "TM97",
            "TM98",
            "TM99",
            "TM100",
            "Power Plant Pass",
            "Mega Ring",
            "Intriguing Stone",
            "Common Stone",
            "Discount Coupon",
            "Elevator Key",
            "TMV Pass",
            "Honor of Kalos",
            "Adventure Guide",
            "Strange Souvenir",
            "Lens Case",
            "Makeup Bag",
            "Travel Trunk",
            "Lumiose Galette",
            "Shalour Sable",
            "Jaw Fossil",
            "Sail Fossil",
            "Looker Ticket",
            "Bike",
            "Holo Caster",
            "Fairy Gem",
            "Mega Charm",
            "Mega Glove",
            "Mach Bike",
            "Acro Bike",
            "Wailmer Pail",
            "Devon Parts",
            "Soot Sack",
            "Basement Key",
            "Pokéblock Kit",
            "Letter",
            "Eon Ticket",
            "Scanner",
            "Go-Goggles",
            "Meteorite",
            "Key to Room 1",
            "Key to Room 2",
            "Key to Room 4",
            "Key to Room 6",
            "Storage Key",
            "Devon Scope",
            "S.S. Ticket",
            "HM07",
            "Devon Scuba Gear",
            "Contest Costume",
            "Contest Costume",
            "Magma Suit",
            "Aqua Suit",
            "Pair of Tickets",
            "Mega Bracelet",
            "Mega Pendant",
            "Mega Glasses",
            "Mega Anchor",
            "Mega Stickpin",
            "Mega Tiara",
            "Mega Anklet",
            "Meteorite",
            "Swampertite",
            "Sceptilite",
            "Sablenite",
            "Altarianite",
            "Galladite",
            "Audinite",
            "Metagrossite",
            "Sharpedonite",
            "Slowbronite",
            "Steelixite",
            "Pidgeotite",
            "Glalitite",
            "Diancite",
            "Prison Bottle",
            "Mega Cuff",
            "Cameruptite",
            "Lopunnite",
            "Salamencite",
            "Beedrillite",
            "Meteorite",
            "Meteorite",
            "Key Stone",
            "Meteorite Shard",
            "Eon Flute",
            "Normalium Z",
            "Firium Z",
            "Waterium Z",
            "Electrium Z",
            "Grassium Z",
            "Icium Z",
            "Fightinium Z",
            "Poisonium Z",
            "Groundium Z",
            "Flyinium Z",
            "Psychium Z",
            "Buginium Z",
            "Rockium Z",
            "Ghostium Z",
            "Dragonium Z",
            "Darkinium Z",
            "Steelium Z",
            "Fairium Z",
            "Pikanium Z",
            "Bottle Cap",
            "Gold Bottle Cap",
            "Z-Ring",
            "Decidium Z",
            "Incinium Z",
            "Primarium Z",
            "Tapunium Z",
            "Marshadium Z",
            "Aloraichium Z",
            "Snorlium Z",
            "Eevium Z",
            "Mewnium Z",
            "Normalium Z",
            "Firium Z",
            "Waterium Z",
            "Electrium Z",
            "Grassium Z",
            "Icium Z",
            "Fightinium Z",
            "Poisonium Z",
            "Groundium Z",
            "Flyinium Z",
            "Psychium Z",
            "Buginium Z",
            "Rockium Z",
            "Ghostium Z",
            "Dragonium Z",
            "Darkinium Z",
            "Steelium Z",
            "Fairium Z",
            "Pikanium Z",
            "Decidium Z",
            "Incinium Z",
            "Primarium Z",
            "Tapunium Z",
            "Marshadium Z",
            "Aloraichium Z",
            "Snorlium Z",
            "Eevium Z",
            "Mewnium Z",
            "Pikashunium Z",
            "Pikashunium Z",
            "???",
            "???",
            "???",
            "???",
            "Forage Bag",
            "Fishing Rod",
            "Professor’s Mask",
            "Festival Ticket",
            "Sparkling Stone",
            "Adrenaline Orb",
            "Zygarde Cube",
            "???",
            "Ice Stone",
            "Ride Pager",
            "Beast Ball",
            "Big Malasada",
            "Red Nectar",
            "Yellow Nectar",
            "Pink Nectar",
            "Purple Nectar",
            "Sun Flute",
            "Moon Flute",
            "???",
            "Enigmatic Card",
            "Silver Razz Berry",
            "Golden Razz Berry",
            "Silver Nanab Berry",
            "Golden Nanab Berry",
            "Silver Pinap Berry",
            "Golden Pinap Berry",
            "???",
            "???",
            "???",
            "???",
            "???",
            "Secret Key",
            "S.S. Ticket",
            "Silph Scope",
            "Parcel",
            "Card Key",
            "Gold Teeth",
            "Lift Key",
            "Terrain Extender",
            "Protective Pads",
            "Electric Seed",
            "Psychic Seed",
            "Misty Seed",
            "Grassy Seed",
            "Stretchy Spring",
            "Chalky Stone",
            "Marble",
            "Lone Earring",
            "Beach Glass",
            "Gold Leaf",
            "Silver Leaf",
            "Polished Mud Ball",
            "Tropical Shell",
            "Leaf Letter",
            "Leaf Letter",
            "Small Bouquet",
            "???",
            "???",
            "???",
            "Lure",
            "Super Lure",
            "Max Lure",
            "Pewter Crunchies",
            "Fighting Memory",
            "Flying Memory",
            "Poison Memory",
            "Ground Memory",
            "Rock Memory",
            "Bug Memory",
            "Ghost Memory",
            "Steel Memory",
            "Fire Memory",
            "Water Memory",
            "Grass Memory",
            "Electric Memory",
            "Psychic Memory",
            "Ice Memory",
            "Dragon Memory",
            "Dark Memory",
            "Fairy Memory",
            "Solganium Z",
            "Lunalium Z",
            "Ultranecrozium Z",
            "Mimikium Z",
            "Lycanium Z",
            "Kommonium Z",
            "Solganium Z",
            "Lunalium Z",
            "Ultranecrozium Z",
            "Mimikium Z",
            "Lycanium Z",
            "Kommonium Z",
            "Z-Power Ring",
            "Pink Petal",
            "Orange Petal",
            "Blue Petal",
            "Red Petal",
            "Green Petal",
            "Yellow Petal",
            "Purple Petal",
            "Rainbow Flower",
            "Surge Badge",
            "N-Solarizer",
            "N-Lunarizer",
            "N-Solarizer",
            "N-Lunarizer",
            "Ilima Normalium Z",
            "Left Poké Ball",
            "Roto Hatch",
            "Roto Bargain",
            "Roto Prize Money",
            "Roto Exp. Points",
            "Roto Friendship",
            "Roto Encounter",
            "Roto Stealth",
            "Roto HP Restore",
            "Roto PP Restore",
            "Roto Boost",
            "Roto Catch"
        };
    }

    namespace French {
        static const char *allItems[959] = {
            "Master Ball",
            "Hyper Ball",
            "Super Ball",
            "Poké Ball",
            "Safari Ball",
            "Filet Ball",
            "Scuba Ball",
            "Faiblo Ball",
            "Bis Ball",
            "Chrono Ball",
            "Luxe Ball",
            "Honor Ball",
            "Sombre Ball",
            "Soin Ball",
            "Rapide Ball",
            "Mémoire Ball",
            "Potion",
            "Antidote",
            "Anti-Brûle",
            "Antigel",
            "Réveil",
            "Anti-Para",
            "Guérison",
            "Potion Max",
            "Hyper Potion",
            "Super Potion",
            "Total Soin",
            "Rappel",
            "Rappel Max",
            "Eau Fraîche",
            "Soda Cool",
            "Limonade",
            "Lait Meumeu",
            "Poudrénergie",
            "Racinénergie",
            "Poudre Soin",
            "Herbe Rappel",
            "Huile",
            "Huile Max",
            "Élixir",
            "Élixir Max",
            "Lava Cookie",
            "Jus de Baie",
            "Cendre Sacrée",
            "PV Plus",
            "Protéine",
            "Fer",
            "Carbone",
            "Calcium",
            "Super Bonbon",
            "PP Plus",
            "Zinc",
            "PP Max",
            "Vieux Gâteau",
            "Garde-Stats",
            "Muscle +",
            "Attaque +",
            "Défense +",
            "Vitesse +",
            "Précision +",
            "Atq. Spé. +",
            "Déf. Spé. +",
            "Poké Poupée",
            "Queue Skitty",
            "Flûte Bleue",
            "Flûte Jaune",
            "Flûte Rouge",
            "Flûte Noire",
            "Flûte Blanche",
            "Sel Tréfonds",
            "CoquilleTréfonds",
            "Tesson Rouge",
            "Tesson Bleu",
            "Tesson Jaune",
            "Tesson Vert",
            "Super Repousse",
            "Repousse Max",
            "Corde Sortie",
            "Repousse",
            "Pierre Soleil",
            "Pierre Lune",
            "Pierre Feu",
            "Pierre Foudre",
            "Pierre Eau",
            "Pierre Plante",
            "Petit Champi",
            "Gros Champi",
            "Perle",
            "Grande Perle",
            "Poussière Étoile",
            "Morceau d’Étoile",
            "Pépite",
            "Écaille Cœur",
            "Miel",
            "Fertipousse",
            "Fertihumide",
            "Fertistable",
            "Fertiglu",
            "Fossile Racine",
            "Fossile Griffe",
            "Nautile",
            "Fossile Dôme",
            "Vieil Ambre",
            "Fossile Armure",
            "Fossile Crâne",
            "Os Rare",
            "Pierre Éclat",
            "Pierre Nuit",
            "Pierre Aube",
            "Pierre Ovale",
            "Clé de Voûte",
            "Orbe Platiné",
            "Thé",
            "???",
            "Dédicace de Bob",
            "Module Aqua",
            "Module Choc",
            "Module Pyro",
            "Module Cryo",
            "???",
            "Boîte Pokémon",
            "Trousse de Soins",
            "Boîte CT",
            "Bonbonnière",
            "Poche à Renforts",
            "Malle à Costumes",
            "Poche de Capture",
            "Poche de Combat",
            "???",
            "???",
            "???",
            "???",
            "???",
            "Chococœur",
            "Orbe Adamant",
            "Orbe Perlé",
            "Lettre Salut",
            "Lettre Fan",
            "Lettre Invit",
            "Lettre Merci",
            "Lettre Demande",
            "Lettre Avis",
            "Lettre Réponse",
            "Lettre Pont S",
            "Lettre Pont Y",
            "Lettre Pont F",
            "Lettre Pont H",
            "Lettre Pont I",
            "Baie Ceriz",
            "Baie Maron",
            "Baie Pêcha",
            "Baie Fraive",
            "Baie Willia",
            "Baie Mepo",
            "Baie Oran",
            "Baie Kika",
            "Baie Prine",
            "Baie Sitrus",
            "Baie Figuy",
            "Baie Wiki",
            "Baie Mago",
            "Baie Gowav",
            "Baie Papaya",
            "Baie Framby",
            "Baie Remu",
            "Baie Nanab",
            "Baie Repoi",
            "Baie Nanana",
            "Baie Grena",
            "Baie Alga",
            "Baie Qualot",
            "Baie Lonme",
            "Baie Résin",
            "Baie Tamato",
            "Baie Siam",
            "Baie Mangou",
            "Baie Rabuta",
            "Baie Tronci",
            "Baie Kiwan",
            "Baie Palma",
            "Baie Stekpa",
            "Baie Durin",
            "Baie Myrte",
            "Baie Chocco",
            "Baie Pocpoc",
            "Baie Parma",
            "Baie Ratam",
            "Baie Nanone",
            "Baie Pomroz",
            "Baie Kébia",
            "Baie Jouca",
            "Baie Cobaba",
            "Baie Yapap",
            "Baie Panga",
            "Baie Charti",
            "Baie Sédra",
            "Baie Fraigo",
            "Baie Lampou",
            "Baie Babiri",
            "Baie Zalis",
            "Baie Lichii",
            "Baie Lingan",
            "Baie Sailak",
            "Baie Pitaye",
            "Baie Abriko",
            "Baie Lansat",
            "Baie Frista",
            "Baie Enigma",
            "Baie Micle",
            "Baie Chérim",
            "Baie Jaboca",
            "Baie Pommo",
            "Poudre Claire",
            "Herbe Blanche",
            "Bracelet Macho",
            "Multi Exp",
            "Vive Griffe",
            "Grelot Zen",
            "Herbe Mental",
            "Bandeau Choix",
            "Roche Royale",
            "Poudre Argentée",
            "Pièce Rune",
            "Rune Purifiante",
            "Rosée Âme",
            "Dent Océan",
            "Écaille Océan",
            "Boule Fumée",
            "Pierre Stase",
            "Bandeau",
            "Œuf Chance",
            "Lentilscope",
            "Peau Métal",
            "Restes",
            "Écaille Draco",
            "Balle Lumière",
            "Sable Doux",
            "Pierre Dure",
            "Graine Miracle",
            "Lunettes Noires",
            "Ceinture Noire",
            "Aimant",
            "Eau Mystique",
            "Bec Pointu",
            "Pic Venin",
            "Glace Éternelle",
            "Rune Sort",
            "Cuillère Tordue",
            "Charbon",
            "Croc Dragon",
            "Mouchoir Soie",
            "Améliorator",
            "Grelot Coque",
            "Encens Mer",
            "Encens Doux",
            "Poing Chance",
            "Poudre Métal",
            "Masse Os",
            "Poireau",
            "Foulard Rouge",
            "Foulard Bleu",
            "Foulard Rose",
            "Foulard Vert",
            "Foulard Jaune",
            "Loupe",
            "Bandeau Muscle",
            "Lunettes Sages",
            "Ceinture Pro",
            "Lumargile",
            "Orbe Vie",
            "Herbe Pouvoir",
            "Orbe Toxique",
            "Orbe Flamme",
            "Poudre Vite",
            "Ceinture Force",
            "Lentille Zoom",
            "Métronome",
            "Balle Fer",
            "Ralentiqueue",
            "Nœud Destin",
            "Boue Noire",
            "Roche Glace",
            "Roche Lisse",
            "Roche Chaude",
            "Roche Humide",
            "Accro Griffe",
            "Mouchoir Choix",
            "Piquants",
            "Poignet Pouvoir",
            "Ceinture Pouvoir",
            "Lentille Pouvoir",
            "Bandeau Pouvoir",
            "Chaîne Pouvoir",
            "Poids Pouvoir",
            "Carapace Mue",
            "Grosse Racine",
            "Lunettes Choix",
            "Plaque Flamme",
            "Plaque Hydro",
            "Plaque Volt",
            "Plaque Herbe",
            "Plaque Glace",
            "Plaque Poing",
            "Plaque Toxicité",
            "Plaque Terre",
            "Plaque Ciel",
            "Plaque Esprit",
            "Plaque Insecte",
            "Plaque Roc",
            "Plaque Fantôme",
            "Plaque Draco",
            "Plaque Ombre",
            "Plaque Fer",
            "Encens Bizarre",
            "Encens Roc",
            "Encens Plein",
            "Encens Vague",
            "Encens Fleur",
            "Encens Veine",
            "Encens Pur",
            "Protecteur",
            "Électriseur",
            "Magmariseur",
            "CD Douteux",
            "Tissu Fauche",
            "Griffe Rasoir",
            "Croc Rasoir",
            "CT01",
            "CT02",
            "CT03",
            "CT04",
            "CT05",
            "CT06",
            "CT07",
            "CT08",
            "CT09",
            "CT10",
            "CT11",
            "CT12",
            "CT13",
            "CT14",
            "CT15",
            "CT16",
            "CT17",
            "CT18",
            "CT19",
            "CT20",
            "CT21",
            "CT22",
            "CT23",
            "CT24",
            "CT25",
            "CT26",
            "CT27",
            "CT28",
            "CT29",
            "CT30",
            "CT31",
            "CT32",
            "CT33",
            "CT34",
            "CT35",
            "CT36",
            "CT37",
            "CT38",
            "CT39",
            "CT40",
            "CT41",
            "CT42",
            "CT43",
            "CT44",
            "CT45",
            "CT46",
            "CT47",
            "CT48",
            "CT49",
            "CT50",
            "CT51",
            "CT52",
            "CT53",
            "CT54",
            "CT55",
            "CT56",
            "CT57",
            "CT58",
            "CT59",
            "CT60",
            "CT61",
            "CT62",
            "CT63",
            "CT64",
            "CT65",
            "CT66",
            "CT67",
            "CT68",
            "CT69",
            "CT70",
            "CT71",
            "CT72",
            "CT73",
            "CT74",
            "CT75",
            "CT76",
            "CT77",
            "CT78",
            "CT79",
            "CT80",
            "CT81",
            "CT82",
            "CT83",
            "CT84",
            "CT85",
            "CT86",
            "CT87",
            "CT88",
            "CT89",
            "CT90",
            "CT91",
            "CT92",
            "CS01",
            "CS02",
            "CS03",
            "CS04",
            "CS05",
            "CS06",
            "???",
            "???",
            "Explorakit",
            "Sac Butin",
            "Livre Règles",
            "Poké Radar",
            "Carte à Points",
            "Notes d’Aventure",
            "Boîte à Sceaux",
            "Coffret Mode",
            "Sac Sceaux",
            "Registre Ami",
            "Clé Parc Éolien",
            "Vieux Grigri",
            "Clé Galaxie",
            "Chaîne Rouge",
            "Carte",
            "Cherch’Combat",
            "Boîte Jetons",
            "Canne",
            "Super Canne",
            "Méga Canne",
            "Kwakarrosoir",
            "Boîte à Poffins",
            "Bicyclette",
            "Clé de Chambre",
            "Lettre Chen",
            "Plume Lune",
            "Carte Membre",
            "Flûte Azur",
            "Passe Bateau",
            "Passe Concours",
            "Pierre Magma",
            "Colis",
            "Bon 1",
            "Bon 2",
            "Bon 3",
            "Clé du Hangar",
            "Remède Secret",
            "Magnéto VS",
            "Gracidée",
            "Clé Secrète",
            "Boîte Noigrume",
            "Carnet Zarbi",
            "Plante-Baies",
            "Cherch’Objet",
            "Carte Bleue",
            "Queue Ramoloss",
            "Glas Transparent",
            "Carte Magnétique",
            "Clé Sous-Sol",
            "Carapuce à O",
            "Écaille Rouge",
            "Objet perdu",
            "Passe Train",
            "Partie Machine",
            "Argent’Aile",
            "Arc-en-Ci’Aile",
            "Œuf Mystère",
            "Noigrume Rouge",
            "Noigrume Bleu",
            "Noigrume Jaune",
            "Noigrume Vert",
            "Noigrume Rose",
            "Noigrume Blanc",
            "Noigrume Noir",
            "Speed Ball",
            "Niveau Ball",
            "Appât Ball",
            "Masse Ball",
            "Love Ball",
            "Copain Ball",
            "Lune Ball",
            "Compét’Ball",
            "Parc Ball",
            "Album Photo",
            "Lecteur GB",
            "Glas Tempête",
            "Bonbon Rage",
            "Carte Mémo01",
            "Carte Mémo02",
            "Carte Mémo03",
            "Carte Mémo04",
            "Carte Mémo05",
            "Carte Mémo06",
            "Carte Mémo07",
            "Carte Mémo08",
            "Carte Mémo09",
            "Carte Mémo10",
            "Carte Mémo11",
            "Carte Mémo12",
            "Carte Mémo13",
            "Carte Mémo14",
            "Carte Mémo15",
            "Carte Mémo16",
            "Carte Mémo17",
            "Carte Mémo18",
            "Carte Mémo19",
            "Carte Mémo20",
            "Carte Mémo21",
            "Carte Mémo22",
            "Carte Mémo23",
            "Carte Mémo24",
            "Carte Mémo25",
            "Carte Mémo26",
            "Carte Mémo27",
            "Orbe Vert",
            "Poké Écrin",
            "Gemme Rouge",
            "Gemme Bleue",
            "Mystécristal",
            "Bel’Écaille",
            "Évoluroc",
            "Pierrallégée",
            "Casque Brut",
            "Ballon",
            "Carton Rouge",
            "Point de Mire",
            "Bande Étreinte",
            "Bulbe",
            "Pile",
            "Bouton Fuite",
            "Joyau Feu",
            "Joyau Eau",
            "Joyau Électrik",
            "Joyau Plante",
            "Joyau Glace",
            "Joyau Combat",
            "Joyau Poison",
            "Joyau Sol",
            "Joyau Vol",
            "Joyau Psy",
            "Joyau Insecte",
            "Joyau Roche",
            "Joyau Spectre",
            "Joyau Dragon",
            "Joyau Ténèbres",
            "Joyau Acier",
            "Joyau Normal",
            "Plume Santé",
            "Plume Force",
            "Plume Armure",
            "Plume Esprit",
            "Plume Mental",
            "Plume Sprint",
            "Jolie Plume",
            "Fossile Plaque",
            "Fossile Plume",
            "Passe Liberté",
            "Offrisphère",
            "Rêve Ball",
            "Poké Plumet",
            "Boîte Parure",
            "Crâne Dragon",
            "Champi Suave",
            "Maxi Pépite",
            "Perle Triple",
            "Morceau Comète",
            "Vieux Sou",
            "Vieil Écu",
            "Vieux Ducat",
            "Vieux Vase",
            "Vieux Bijou",
            "Vieux Santon",
            "Vieux Tortil",
            "Glace Volute",
            "Muscle 2",
            "Vitesse 2",
            "Atq. Spé. 2",
            "Déf. Spé. 2",
            "Défense 2",
            "Attaque 2",
            "Précision 2",
            "Vitesse 3",
            "Atq. Spé. 3",
            "Déf. Spé. 3",
            "Défense 3",
            "Attaque 3",
            "Précision 3",
            "Vitesse 6",
            "Atq. Spé. 6",
            "Déf. Spé. 6",
            "Défense 6",
            "Attaque 6",
            "Précision 6",
            "Appel Talent",
            "Jette Objet",
            "Appel Objet",
            "Réamorçage",
            "Muscle 3",
            "Galet Blanc",
            "Galet Noir",
            "CT93",
            "CT94",
            "CT95",
            "Vokit",
            "???",
            "Courrier 1",
            "Courrier 2",
            "Courrier 3",
            "Vokit",
            "Boîte Médailles",
            "Pointeau ADN",
            "Pointeau ADN",
            "Permis",
            "Charme Ovale",
            "Charme Chroma",
            "Carte Plasma",
            "Mouchoir Sale",
            "Nikodule",
            "Objet Trouvé",
            "Objet Trouvé",
            "Miroir Sacré",
            "Vulné-Assurance",
            "Veste de Combat",
            "Holokit",
            "Lettre du Prof",
            "Rollers",
            "Plaque Pixie",
            "Pilule Talent",
            "Chantibonbon",
            "Sachet Senteur",
            "Lichen Lumineux",
            "Boule de Neige",
            "Lunettes Filtre",
            "Poké Flûte",
            "Fertibondance",
            "Fertistantané",
            "Fertibérance",
            "Fertiprodige",
            "Ectoplasmite",
            "Gardevoirite",
            "Pharampite",
            "Florizarrite",
            "Dracaufite X",
            "Tortankite",
            "Mewtwoïte X",
            "Mewtwoïte Y",
            "Braségalite",
            "Charminite",
            "Démolossite",
            "Galekingite",
            "Branettite",
            "Tyranocivite",
            "Cizayoxite",
            "Scarabruite",
            "Ptéraïte",
            "Lucarite",
            "Blizzarite",
            "Kangourexite",
            "Léviatorite",
            "Absolite",
            "Dracaufite Y",
            "Alakazamite",
            "Scarhinoïte",
            "Mysdibulite",
            "Élecsprintite",
            "Carchacrokite",
            "Latiasite",
            "Latiosite",
            "Baie Selro",
            "Baie Éka",
            "Baie Rangma",
            "Nénurrosoir",
            "CT96",
            "CT97",
            "CT98",
            "CT99",
            "CT100",
            "Passe Centrale",
            "Méga-Anneau",
            "Pierre Insolite",
            "Pierre Ordinaire",
            "Bon Réduction",
            "Clé Ascenseur",
            "Passe TMV",
            "Insigne de Kalos",
            "ABC Aventure",
            "Bibelot Bizarre",
            "Boîte Lentilles",
            "Trousse Beauté",
            "Malle Penderie",
            "Galette Illumis",
            "Sablé Yantreizh",
            "Fossile Mâchoire",
            "Fossile Nageoire",
            "Ticket Beladonis",
            "Bicyclette",
            "Holokit",
            "Joyau Fée",
            "Méga-Charme",
            "Méga-Gant",
            "Vélo de Course",
            "Vélo Cross",
            "Wailmerrosoir",
            "Pack Devon",
            "Sac à Suie",
            "Clé Sous-Sol",
            "Kit Pokébloc",
            "Lettre à Pierre",
            "Passe Éon",
            "Scanner",
            "Lunettes Sable",
            "Météorite",
            "Clé Salle 1",
            "Clé Salle 2",
            "Clé Salle 4",
            "Clé Salle 6",
            "Clé du Hangar",
            "Devon Scope",
            "Passe Bateau",
            "CS07",
            "Plongeur Devon",
            "Costume Live",
            "Robe Live",
            "Scaph. Magma",
            "Scaphandre Aqua",
            "Ticket Duo",
            "Méga-Bracelet",
            "Méga-Pendentif",
            "Méga-Lunettes",
            "Méga-Ancre",
            "Méga-Pin’s",
            "Méga-Tiare",
            "Méga-Grève",
            "Météorite",
            "Laggronite",
            "Jungkite",
            "Ténéfixite",
            "Altarite",
            "Gallamite",
            "Nanméouïte",
            "Métalossite",
            "Sharpedite",
            "Flagadossite",
            "Steelixite",
            "Roucarnagite",
            "Oniglalite",
            "Diancite",
            "Vase Scellé",
            "Méga-Manchette",
            "Caméruptite",
            "Lockpinite",
            "Drattakite",
            "Dardargnite",
            "Météorite",
            "Météorite",
            "Gemme Sésame",
            "Éclat Météorite",
            "Flûte Éon",
            "Normazélite",
            "Pyrozélite",
            "Aquazélite",
            "Voltazélite",
            "Florazélite",
            "Cryozélite",
            "Combazélite",
            "Toxizélite",
            "Terrazélite",
            "Aérozélite",
            "Psychézélite",
            "Insectozélite",
            "Rocazélite",
            "Spectrozélite",
            "Dracozélite",
            "Ténébrozélite",
            "Métallozélite",
            "Nymphézélite",
            "Pikazélite",
            "Capsule d’Argent",
            "Capsule d’Or",
            "Bracelet Z",
            "Archézélite",
            "Félinozélite",
            "Oratozélite",
            "Tokozélite",
            "Marshadozélite",
            "Aloraïzélite",
            "Ronflézélite",
            "Évolizélite",
            "Mewzélite",
            "Normazélite",
            "Pyrozélite",
            "Aquazélite",
            "Voltazélite",
            "Florazélite",
            "Cryozélite",
            "Combazélite",
            "Toxizélite",
            "Terrazélite",
            "Aérozélite",
            "Psychézélite",
            "Insectozélite",
            "Rocazélite",
            "Spectrozélite",
            "Dracozélite",
            "Ténébrozélite",
            "Métallozélite",
            "Nymphézélite",
            "Pikazélite",
            "Archézélite",
            "Félinozélite",
            "Oratozélite",
            "Tokozélite",
            "Marshadozélite",
            "Aloraïzélite",
            "Ronflézélite",
            "Évolizélite",
            "Mewzélite",
            "Pikachazélite",
            "Pikachazélite",
            "???",
            "???",
            "???",
            "???",
            "Sac Ingrédients",
            "Canne à Pêche",
            "Masque du Prof",
            "Festicket",
            "Gemme Lumière",
            "Orbe Frousse",
            "Boîte Zygarde",
            "???",
            "Pierre Glace",
            "Appel-Monture",
            "Ultra Ball",
            "Malasada Maxi",
            "Nectar Rouge",
            "Nectar Jaune",
            "Nectar Rose",
            "Nectar Mauve",
            "Flûte du Soleil",
            "Flûte de la Lune",
            "???",
            "Message Mystère",
            "Baie Framby argentée",
            "Baie Framby dorée",
            "Baie Nanab argentée",
            "Baie Nanab dorée",
            "Baie Nanana argentée",
            "Baie Nanana dorée",
            "???",
            "???",
            "???",
            "???",
            "???",
            "Clé Secrète",
            "Passe Bateau",
            "Scope Sylphe",
            "Colis",
            "Carte Magnétique",
            "Dentier en Or",
            "Clé Ascenseur",
            "Champ’Duit",
            "Pare-Effet",
            "Graine Électrik",
            "Graine Psychique",
            "Graine Brume",
            "Graine Herbe",
            "Ressort Détendu",
            "Craie",
            "Bille",
            "Boucle d’Oreille",
            "Galet de Verre",
            "Feuille Dorée",
            "Feuille Argentée",
            "Boulette de Boue",
            "Coquille du Sud",
            "Lettre Végétale",
            "Lettre Végétale",
            "Petit Bouquet",
            "???",
            "???",
            "???",
            "Parfum",
            "Super Parfum",
            "Parfum Max",
            "Crok’Argenta",
            "ROM Combat",
            "ROM Vol",
            "ROM Poison",
            "ROM Sol",
            "ROM Roche",
            "ROM Insecte",
            "ROM Spectre",
            "ROM Acier",
            "ROM Feu",
            "ROM Eau",
            "ROM Plante",
            "ROM Électrik",
            "ROM Psy",
            "ROM Glace",
            "ROM Dragon",
            "ROM Ténèbres",
            "ROM Fée",
            "Solgazélite",
            "Lunazélite",
            "Ultranécrozélite",
            "Mimiquizélite",
            "Lougarozélite",
            "Ékaïzélite",
            "Solgazélite",
            "Lunazélite",
            "Ultranécrozélite",
            "Mimiquizélite",
            "Lougarozélite",
            "Ékaïzélite",
            "Super Bracelet Z",
            "Pétale Rose",
            "Pétale Orange",
            "Pétale Bleu",
            "Pétale Rouge",
            "Pétale Vert",
            "Pétale Jaune",
            "Pétale Violet",
            "Fleur 7 Couleurs",
            "Fulguro-Badge",
            "Necrosol",
            "Necroluna",
            "Necrosol",
            "Necroluna",
            "Cristal Z Althéo",
            "Poké Ball donnée",
            "Moti-Couveuse",
            "Moti-Promo",
            "Moti-Magot",
            "Moti-Exp",
            "Moti-Cœur",
            "Moti-Appât",
            "Moti-Camouflage",
            "Moti-Récup’ PV",
            "Moti-Récup’ PP",
            "Moti-Soutien",
            "Moti-Capture"
        };
    }

    namespace Italian {
        static const char *allItems[959] = {
            "Master Ball",
            "Ultra Ball",
            "Mega Ball",
            "Poké Ball",
            "Safari Ball",
            "Rete Ball",
            "Sub Ball",
            "Minor Ball",
            "Bis Ball",
            "Timer Ball",
            "Chic Ball",
            "Premier Ball",
            "Scuro Ball",
            "Cura Ball",
            "Velox Ball",
            "Pregio Ball",
            "Pozione",
            "Antidoto",
            "Antiscottatura",
            "Antigelo",
            "Sveglia",
            "Antiparalisi",
            "Ricarica totale",
            "Pozione max",
            "Iperpozione",
            "Superpozione",
            "Cura totale",
            "Revitalizzante",
            "Revitalizzante max",
            "Acqua fresca",
            "Gassosa",
            "Lemonsucco",
            "Latte Mumu",
            "Polvenergia",
            "Radicenergia",
            "Polvocura",
            "Vitalerba",
            "Etere",
            "Etere max",
            "Elisir",
            "Elisir max",
            "Lavottino",
            "Succo di bacca",
            "Cenere magica",
            "PS-su",
            "Proteina",
            "Ferro",
            "Carburante",
            "Calcio",
            "Caramella rara",
            "PP-su",
            "Zinco",
            "PP-max",
            "Dolce gateau",
            "Superguardia",
            "Supercolpo",
            "Attacco X",
            "Difesa X",
            "Velocità X",
            "Precisione X",
            "Attacco Speciale X",
            "Difesa Speciale X",
            "Pokébambola",
            "Coda Skitty",
            "Flauto blu",
            "Flauto giallo",
            "Flauto rosso",
            "Flauto nero",
            "Flauto bianco",
            "Sale ondoso",
            "Gusciondoso",
            "Coccio rosso",
            "Coccio blu",
            "Coccio giallo",
            "Coccio verde",
            "Superrepellente",
            "Repellente max",
            "Fune di fuga",
            "Repellente",
            "Pietrasolare",
            "Pietralunare",
            "Pietrafocaia",
            "Pietratuono",
            "Pietraidrica",
            "Pietrafoglia",
            "Minifungo",
            "Grande fungo",
            "Perla",
            "Grande perla",
            "Polvostella",
            "Pezzo stella",
            "Pepita",
            "Squama cuore",
            "Miele",
            "Fertilrapido",
            "Fertilidro",
            "Fertilsaldo",
            "Fertilcolla",
            "Radifossile",
            "Fossilunghia",
            "Helixfossile",
            "Domofossile",
            "Ambra antica",
            "Fossilscudo",
            "Fossilcranio",
            "Osso raro",
            "Pietrabrillo",
            "Neropietra",
            "Pietralbore",
            "Pietraovale",
            "Roccianima",
            "Grigiosfera",
            "Tè",
            "???",
            "Autografo",
            "Idromodulo",
            "Voltmodulo",
            "Piromodulo",
            "Gelomodulo",
            "???",
            "Box Pokémon",
            "Tasca rimedi",
            "Porta MT",
            "Portacaramelle",
            "Tasca potenziam.",
            "Valigia vestiti",
            "Tasca cattura",
            "Tasca lotta",
            "???",
            "???",
            "???",
            "???",
            "???",
            "Dolcecuore",
            "Adamasfera",
            "Splendisfera",
            "Messaggio Inizio",
            "Messaggio TVB",
            "Messaggio Invito",
            "Messaggio Grazie",
            "Messaggio Chiedi",
            "Messaggio Consiglio",
            "Messaggio Risposta",
            "Messaggio Ponte F",
            "Messaggio Ponte L",
            "Messaggio Ponte P",
            "Messaggio Ponte V",
            "Messaggio Ponte M",
            "Baccaliegia",
            "Baccastagna",
            "Baccapesca",
            "Baccafrago",
            "Baccaperina",
            "Baccamela",
            "Baccarancia",
            "Baccaki",
            "Baccaprugna",
            "Baccacedro",
            "Baccafico",
            "Baccakiwi",
            "Baccamango",
            "Baccaguava",
            "Baccapaia",
            "Baccalampon",
            "Baccamora",
            "Baccabana",
            "Baccapera",
            "Baccananas",
            "Baccagrana",
            "Baccalga",
            "Baccaloquat",
            "Baccamelon",
            "Baccauva",
            "Baccamodoro",
            "Baccavena",
            "Baccagostan",
            "Baccambutan",
            "Baccalemon",
            "Baccamelos",
            "Baccapalma",
            "Baccacomero",
            "Baccadurian",
            "Baccartillo",
            "Baccacao",
            "Baccapasflo",
            "Baccaparmen",
            "Baccarindo",
            "Baccamoya",
            "Baccarosmel",
            "Baccakebia",
            "Baccanaca",
            "Baccababa",
            "Baccapayapa",
            "Baccaitan",
            "Baccaciofo",
            "Baccacitrus",
            "Baccahaban",
            "Baccaxan",
            "Baccababiri",
            "Baccacinlan",
            "Baccalici",
            "Baccalongan",
            "Baccasalak",
            "Baccapitaya",
            "Baccacocca",
            "Baccalangsa",
            "Baccambola",
            "Baccaenigma",
            "Baccaracolo",
            "Baccacrela",
            "Baccajaba",
            "Baccaroam",
            "Luminpolvere",
            "Erbachiara",
            "Crescicappa",
            "Condividi esperienza",
            "Rapidartiglio",
            "Calmanella",
            "Mentalerba",
            "Bendascelta",
            "Roccia di re",
            "Argenpolvere",
            "Monetamuleto",
            "Velopuro",
            "Cuorugiada",
            "Dente abissi",
            "Squamabissi",
            "Palla fumo",
            "Pietrastante",
            "Bandana",
            "Fortunuovo",
            "Mirino",
            "Metalcopertura",
            "Avanzi",
            "Squama drago",
            "Elettropalla",
            "Sabbia soffice",
            "Pietradura",
            "Miracolseme",
            "Occhialineri",
            "Cintura nera",
            "Calamita",
            "Acqua magica",
            "Beccaffilato",
            "Velenaculeo",
            "Gelomai",
            "Spettrotarga",
            "Cucchiaio torto",
            "Carbonella",
            "Dente di drago",
            "Sciarpa seta",
            "Upgrade",
            "Conchinella",
            "Marearoma",
            "Distraroma",
            "Fortunpugno",
            "Metalpolvere",
            "Osso spesso",
            "Porro",
            "Fascia rossa",
            "Fascia blu",
            "Fascia rosa",
            "Fascia verde",
            "Fascia gialla",
            "Grandelente",
            "Muscolbanda",
            "Saviocchiali",
            "Abilcintura",
            "Creta luce",
            "Assorbisfera",
            "Vigorerba",
            "Tossicsfera",
            "Fiammosfera",
            "Velopolvere",
            "Focalnastro",
            "Zoomlente",
            "Plessimetro",
            "Ferropalla",
            "Rallentocoda",
            "Destincomune",
            "Fangopece",
            "Rocciafredda",
            "Roccialiscia",
            "Rocciacalda",
            "Rocciaumida",
            "Presartiglio",
            "Stolascelta",
            "Vischiopunta",
            "Vigorcerchio",
            "Vigorfascia",
            "Vigorlente",
            "Vigorbanda",
            "Vigorgliera",
            "Vigorpeso",
            "Disfoguscio",
            "Granradice",
            "Lentiscelta",
            "Lastrarogo",
            "Lastraidro",
            "Lastrasaetta",
            "Lastraprato",
            "Lastragelo",
            "Lastrapugno",
            "Lastrafiele",
            "Lastrageo",
            "Lastracielo",
            "Lastramente",
            "Lastrabaco",
            "Lastrapietra",
            "Lastratetra",
            "Lastradrakon",
            "Lastratimore",
            "Lastraferro",
            "Bizzoaroma",
            "Roccioaroma",
            "Gonfioaroma",
            "Ondaroma",
            "Rosaroma",
            "Fortunaroma",
            "Puroaroma",
            "Copertura",
            "Elettritore",
            "Magmatore",
            "Dubbiodisco",
            "Terrorpanno",
            "Affilartiglio",
            "Affilodente",
            "MT01",
            "MT02",
            "MT03",
            "MT04",
            "MT05",
            "MT06",
            "MT07",
            "MT08",
            "MT09",
            "MT10",
            "MT11",
            "MT12",
            "MT13",
            "MT14",
            "MT15",
            "MT16",
            "MT17",
            "MT18",
            "MT19",
            "MT20",
            "MT21",
            "MT22",
            "MT23",
            "MT24",
            "MT25",
            "MT26",
            "MT27",
            "MT28",
            "MT29",
            "MT30",
            "MT31",
            "MT32",
            "MT33",
            "MT34",
            "MT35",
            "MT36",
            "MT37",
            "MT38",
            "MT39",
            "MT40",
            "MT41",
            "MT42",
            "MT43",
            "MT44",
            "MT45",
            "MT46",
            "MT47",
            "MT48",
            "MT49",
            "MT50",
            "MT51",
            "MT52",
            "MT53",
            "MT54",
            "MT55",
            "MT56",
            "MT57",
            "MT58",
            "MT59",
            "MT60",
            "MT61",
            "MT62",
            "MT63",
            "MT64",
            "MT65",
            "MT66",
            "MT67",
            "MT68",
            "MT69",
            "MT70",
            "MT71",
            "MT72",
            "MT73",
            "MT74",
            "MT75",
            "MT76",
            "MT77",
            "MT78",
            "MT79",
            "MT80",
            "MT81",
            "MT82",
            "MT83",
            "MT84",
            "MT85",
            "MT86",
            "MT87",
            "MT88",
            "MT89",
            "MT90",
            "MT91",
            "MT92",
            "MN01",
            "MN02",
            "MN03",
            "MN04",
            "MN05",
            "MN06",
            "???",
            "???",
            "Esplorokit",
            "Bottinosacca",
            "Libro regole",
            "Poké Radar",
            "Scheda punti",
            "Note di viaggio",
            "Portabolli",
            "Scatola chic",
            "Bollosacca",
            "Blocco amici",
            "Chiave impianto",
            "Amuleto antico",
            "Chiave Galassia",
            "Catena rossa",
            "Mappa città",
            "Cercasfide",
            "Salvadanaio",
            "Canna da pesca usata",
            "Canna da pesca buona",
            "Canna da pesca super",
            "Sprayduck",
            "Portapoffin",
            "Bicicletta",
            "Chiave suite",
            "Lettera Oak",
            "Piumalunare",
            "Scheda soci",
            "Flauto cielo",
            "Biglietto nave",
            "Tessera Gare",
            "Magmapietra",
            "Pacco",
            "Coupon 1",
            "Coupon 2",
            "Coupon 3",
            "Chiave magazzino",
            "Rimedio segreto",
            "Registradati",
            "Gracidea",
            "Chiave segreta",
            "Ghicobox",
            "Registro Unown",
            "Piantabacche",
            "Ricerca strumenti",
            "Carta blu",
            "Coda Slowpoke",
            "Campana chiara",
            "Apriporta",
            "Chiave sotterr.",
            "Annaffiatoio",
            "Squama rossa",
            "Strumento perso",
            "Superpass",
            "Pezzo di macchinario",
            "Ala d’argento",
            "Ala d’iride",
            "Uovo mistero",
            "Ghicocca rossa",
            "Ghicocca blu",
            "Ghicocca gialla",
            "Ghicocca verde",
            "Ghicocca rosa",
            "Ghicocca bianca",
            "Ghicocca nera",
            "Rapid Ball",
            "Level Ball",
            "Esca Ball",
            "Peso Ball",
            "Love Ball",
            "Friend Ball",
            "Luna Ball",
            "Gara Ball",
            "Parco Ball",
            "Album",
            "Lettore GB",
            "Campana onda",
            "Iramella",
            "Scheda dati 01",
            "Scheda dati 02",
            "Scheda dati 03",
            "Scheda dati 04",
            "Scheda dati 05",
            "Scheda dati 06",
            "Scheda dati 07",
            "Scheda dati 08",
            "Scheda dati 09",
            "Scheda dati 10",
            "Scheda dati 11",
            "Scheda dati 12",
            "Scheda dati 13",
            "Scheda dati 14",
            "Scheda dati 15",
            "Scheda dati 16",
            "Scheda dati 17",
            "Scheda dati 18",
            "Scheda dati 19",
            "Scheda dati 20",
            "Scheda dati 21",
            "Scheda dati 22",
            "Scheda dati 23",
            "Scheda dati 24",
            "Scheda dati 25",
            "Scheda dati 26",
            "Scheda dati 27",
            "Sfera verde",
            "Capsula scrigno",
            "Gemma rossa",
            "Gemma blu",
            "Misticristal",
            "Squama bella",
            "Evolcondensa",
            "Pietralieve",
            "Bitorzolelmo",
            "Palloncino",
            "Cartelrosso",
            "Facilsaglio",
            "Legafascia",
            "Bulbo",
            "Ricaripila",
            "Pulsantefuga",
            "Bijoufuoco",
            "Bijouacqua",
            "Bijouelettro",
            "Bijouerba",
            "Bijoughiaccio",
            "Bijoulotta",
            "Bijouveleno",
            "Bijouterra",
            "Bijouvolante",
            "Bijoupsico",
            "Bijoucoleottero",
            "Bijouroccia",
            "Bijouspettro",
            "Bijoudrago",
            "Bijoubuio",
            "Bijouacciaio",
            "Bijounormale",
            "Piumsalute",
            "Piumpotenza",
            "Piumtutela",
            "Piumingegno",
            "Piumintuito",
            "Piumreazione",
            "Piumabella",
            "Fossiltappo",
            "Fossilpiuma",
            "Liberticket",
            "Passabilia",
            "Dream Ball",
            "Pokégingillo",
            "Portagadget",
            "Teschio",
            "Profumfungo",
            "Granpepita",
            "Trittiperla",
            "Pezzo cometa",
            "Soldantico",
            "Ducatantico",
            "Doblonantico",
            "Vasantico",
            "Bracciantico",
            "Statuantica",
            "Coronantica",
            "Conostropoli",
            "Supercolpo 2",
            "Velocità X-2",
            "Attacco Speciale X-2",
            "Difesa Speciale X-2",
            "Difesa X-2",
            "Attacco X-2",
            "Precisione X-2",
            "Velocità X-3",
            "Attacco Speciale X-3",
            "Difesa Speciale X-3",
            "Difesa X-3",
            "Attacco X-3",
            "Precisione X-3",
            "Velocità X-6",
            "Attacco Speciale X-6",
            "Difesa Speciale X-6",
            "Difesa X-6",
            "Attacco X-6",
            "Precisione X-6",
            "Chiamabilità",
            "Lascioggetto",
            "Chiamoggetto",
            "Ripristino",
            "Supercolpo 3",
            "Chiarolite",
            "Scurolite",
            "MT93",
            "MT94",
            "MT95",
            "Interpoké",
            "???",
            "Missiva 1",
            "Missiva 2",
            "Missiva 3",
            "Interpoké",
            "Box premi",
            "Cuneo DNA",
            "Cuneo DNA",
            "Permesso",
            "Ovamuleto",
            "Cromamuleto",
            "Carta Plasma",
            "Pezza sporca",
            "Acrocongegno",
            "Oggetto perso",
            "Oggetto perso",
            "Verispecchio",
            "Vulneropolizza",
            "Corpetto assalto",
            "Holovox",
            "Lettera del Prof",
            "Pattini",
            "Lastraspiritello",
            "Capsula abilità",
            "Dolcespuma",
            "Bustina aromi",
            "Muschioluce",
            "Palla di neve",
            "Visierantisabbia",
            "Pokéflauto",
            "Fertilflorido",
            "Fertilsorpresa",
            "Fertilcopioso",
            "Fertilprodigio",
            "Gengarite",
            "Gardevoirite",
            "Ampharosite",
            "Venusaurite",
            "Charizardite X",
            "Blastoisite",
            "Mewtwoite X",
            "Mewtwoite Y",
            "Blazikenite",
            "Medichamite",
            "Houndoomite",
            "Aggronite",
            "Banettite",
            "Tyranitarite",
            "Scizorite",
            "Pinsirite",
            "Aerodactylite",
            "Lucarite",
            "Abomasnowite",
            "Kangaskhanite",
            "Gyaradosite",
            "Absolite",
            "Charizardite Y",
            "Alakazamite",
            "Heracrossite",
            "Mawilite",
            "Manectricite",
            "Garchompite",
            "Latiasite",
            "Latiosite",
            "Baccarcadè",
            "Baccalighia",
            "Baccapane",
            "Irrigalotad",
            "MT96",
            "MT97",
            "MT98",
            "MT99",
            "MT100",
            "Pass centrale",
            "Megacerchio",
            "Sasso suggestivo",
            "Sasso qualsiasi",
            "Buono sconto",
            "Chiave ascensore",
            "Pass TMV",
            "Emblema di Kalos",
            "Guida avventura",
            "Strano ninnolo",
            "Portalenti",
            "Trousse",
            "Baule per abiti",
            "Pan di Lumi",
            "Yantafrollino",
            "Fossilmascella",
            "Fossilpinna",
            "Carta Bellocchio",
            "Bicicletta",
            "Holovox",
            "Bijoufolletto",
            "Megaciondolo",
            "Megaguanto",
            "Bici da corsa",
            "Bici da cross",
            "Vaso Wailmer",
            "Merce Devon",
            "Sacco cenere",
            "Chiave sotterr.",
            "Kit Pokémelle",
            "Lettera",
            "Biglietto Eone",
            "Scanner",
            "Occhialoni",
            "Meteorite",
            "Chiave stanza 1",
            "Chiave stanza 2",
            "Chiave stanza 4",
            "Chiave stanza 6",
            "Chiave magazzino",
            "Devonscopio",
            "Biglietto nave",
            "MN07",
            "Maschera Devon",
            "Costume Live",
            "Vestito Live",
            "Tuta Magma",
            "Tuta Idro",
            "Biglietto doppio",
            "Megabracciale",
            "Megapendente",
            "Megaocchiali",
            "Megaancora",
            "Megaspilla",
            "Megadiadema",
            "Megagambale",
            "Meteorite",
            "Swampertite",
            "Sceptilite",
            "Sableyite",
            "Altarite",
            "Galladite",
            "Audinite",
            "Metagrossite",
            "Sharpedite",
            "Slowbroite",
            "Steelixite",
            "Pidgeotite",
            "Glalite",
            "Diancite",
            "Vaso del vincolo",
            "Megapolsiera",
            "Cameruptite",
            "Lopunnite",
            "Salamencite",
            "Beedrillite",
            "Meteorite",
            "Meteorite",
            "Pietrachiave",
            "Framm. meteorite",
            "Flauto Eone",
            "Normium Z",
            "Pirium Z",
            "Idrium Z",
            "Electrium Z",
            "Herbium Z",
            "Glacium Z",
            "Luctium Z",
            "Venenium Z",
            "Terrium Z",
            "Volantium Z",
            "Psichium Z",
            "Insectium Z",
            "Petrium Z",
            "Spectrium Z",
            "Draconium Z",
            "Obscurium Z",
            "Metallium Z",
            "Follectium Z",
            "Pikacium Z",
            "Tappo d’argento",
            "Tappo d’oro",
            "Cerchio Z",
            "Deciduenium Z",
            "Incineronium Z",
            "Primarinium Z",
            "Tapium Z",
            "Marshadium Z",
            "Aloraicium Z",
            "Snorlactium Z",
            "Eevium Z",
            "Mewnium Z",
            "Normium Z",
            "Pirium Z",
            "Idrium Z",
            "Electrium Z",
            "Herbium Z",
            "Glacium Z",
            "Luctium Z",
            "Venenium Z",
            "Terrium Z",
            "Volantium Z",
            "Psichium Z",
            "Insectium Z",
            "Petrium Z",
            "Spectrium Z",
            "Draconium Z",
            "Obscurium Z",
            "Metallium Z",
            "Follectium Z",
            "Pikacium Z",
            "Deciduenium Z",
            "Incineronium Z",
            "Primarinium Z",
            "Tapium Z",
            "Marshadium Z",
            "Aloraicium Z",
            "Snorlactium Z",
            "Eevium Z",
            "Mewnium Z",
            "Ashpikacium Z",
            "Ashpikacium Z",
            "???",
            "???",
            "???",
            "???",
            "Portaingredienti",
            "Canna da pesca",
            "Maschera del Prof",
            "Festicket",
            "Pietra lucente",
            "Fifasfera",
            "Teca Zygarde",
            "???",
            "Pietragelo",
            "Chiamapassaggio",
            "UC Ball",
            "Malasada maxi",
            "Nettare rosso",
            "Nettare giallo",
            "Nettare rosa",
            "Nettare viola",
            "Flauto solare",
            "Flauto lunare",
            "???",
            "Lettera segreta",
            "Baccalampon argentata",
            "Baccalampon dorata",
            "Baccabana argentata",
            "Baccabana dorata",
            "Baccananas argentata",
            "Baccananas dorata",
            "???",
            "???",
            "???",
            "???",
            "???",
            "Chiave segreta",
            "Biglietto nave",
            "Spettrosonda",
            "Pacco",
            "Apriporta",
            "Denti d’oro",
            "Chiave ascensore",
            "Fissacampo",
            "Smorzaurti",
            "Elettroseme",
            "Psicoseme",
            "Nebbiaseme",
            "Erbaseme",
            "Molla elastica",
            "Gessetto",
            "Biglia",
            "Orecchino",
            "Vetro marino",
            "Fogliadoro",
            "Fogliargento",
            "Pallina di fango",
            "Tropiconchiglia",
            "Foglialettera",
            "Foglialettera",
            "Bouquet",
            "???",
            "???",
            "???",
            "Profumo invito",
            "Superprofumo",
            "Profumo max",
            "Plumbeosalatini",
            "ROM Lotta",
            "ROM Volante",
            "ROM Veleno",
            "ROM Terra",
            "ROM Roccia",
            "ROM Coleottero",
            "ROM Spettro",
            "ROM Acciaio",
            "ROM Fuoco",
            "ROM Acqua",
            "ROM Erba",
            "ROM Elettro",
            "ROM Psico",
            "ROM Ghiaccio",
            "ROM Drago",
            "ROM Buio",
            "ROM Folletto",
            "Solgaleium Z",
            "Lunalium Z",
            "Ultranecrozium Z",
            "Mimikyum Z",
            "Lycanrochium Z",
            "Kommonium Z",
            "Solgaleium Z",
            "Lunalium Z",
            "Ultranecrozium Z",
            "Mimikyum Z",
            "Lycanrochium Z",
            "Kommonium Z",
            "Supercerchio Z",
            "Petalo rosa",
            "Petalo arancione",
            "Petalo azzurro",
            "Petalo rosso",
            "Petalo verde",
            "Petalo giallo",
            "Petalo violetto",
            "Fiore arcobaleno",
            "Medaglia Tonante",
            "Necrosolix",
            "Necrolunix",
            "Necrosolix",
            "Necrolunix",
            "Normium Z Liam",
            "Poké Ball altrui",
            "Cova’n’roll",
            "Sconto’n’roll",
            "Soldi’n’roll",
            "Esp’n’roll",
            "Affetto’n’roll",
            "Incontra’n’roll",
            "Repelle’n’roll",
            "PS’n’roll",
            "PP’n’roll",
            "Stat’n’roll",
            "Acchiappa’n’roll"
        };
    }

    extern int heldItemID;

    struct HeldItem {
        vector<string> name;
        vector<int> choiceNo;
    };

    void FindItemKB(MenuEntry *entry);

    namespace English {
        static const char *allAbilities[233] = {
            "Stench",
            "Drizzle",
            "Speed Boost",
            "Battle Armor",
            "Sturdy",
            "Damp",
            "Limber",
            "Sand Veil",
            "Static",
            "Volt Absorb",
            "Water Absorb",
            "Oblivious",
            "Cloud Nine",
            "Compound Eyes",
            "Insomnia",
            "Color Change",
            "Immunity",
            "Flash Fire",
            "Shield Dust",
            "Own Tempo",
            "Suction Cups",
            "Intimidate",
            "Shadow Tag",
            "Rough Skin",
            "Wonder Guard",
            "Levitate",
            "Effect Spore",
            "Synchronize",
            "Clear Body",
            "Natural Cure",
            "Lightning Rod",
            "Serene Grace",
            "Swift Swim",
            "Chlorophyll",
            "Illuminate",
            "Trace",
            "Huge Power",
            "Poison Point",
            "Inner Focus",
            "Magma Armor",
            "Water Veil",
            "Magnet Pull",
            "Soundproof",
            "Rain Dish",
            "Sand Stream",
            "Pressure",
            "Thick Fat",
            "Early Bird",
            "Flame Body",
            "Run Away",
            "Keen Eye",
            "Hyper Cutter",
            "Pickup",
            "Truant",
            "Hustle",
            "Cute Charm",
            "Plus",
            "Minus",
            "Forecast",
            "Sticky Hold",
            "Shed Skin",
            "Guts",
            "Marvel Scale",
            "Liquid Ooze",
            "Overgrow",
            "Blaze",
            "Torrent",
            "Swarm",
            "Rock Head",
            "Drought",
            "Arena Trap",
            "Vital Spirit",
            "White Smoke",
            "Pure Power",
            "Shell Armor",
            "Air Lock",
            "Tangled Feet",
            "Motor Drive",
            "Rivalry",
            "Steadfast",
            "Snow Cloak",
            "Gluttony",
            "Anger Point",
            "Unburden",
            "Heatproof",
            "Simple",
            "Dry Skin",
            "Download",
            "Iron Fist",
            "Poison Heal",
            "Adaptability",
            "Skill Link",
            "Hydration",
            "Solar Power",
            "Quick Feet",
            "Normalize",
            "Sniper",
            "Magic Guard",
            "No Guard",
            "Stall",
            "Technician",
            "Leaf Guard",
            "Klutz",
            "Mold Breaker",
            "Super Luck",
            "Aftermath",
            "Anticipation",
            "Forewarn",
            "Unaware",
            "Tinted Lens",
            "Filter",
            "Slow Start",
            "Scrappy",
            "Storm Drain",
            "Ice Body",
            "Solid Rock",
            "Snow Warning",
            "Honey Gather",
            "Frisk",
            "Reckless",
            "Multitype",
            "Flower Gift",
            "Bad Dreams",
            "Pickpocket",
            "Sheer Force",
            "Contrary",
            "Unnerve",
            "Defiant",
            "Defeatist",
            "Cursed Body",
            "Healer",
            "Friend Guard",
            "Weak Armor",
            "Heavy Metal",
            "Light Metal",
            "Multiscale",
            "Toxic Boost",
            "Flare Boost",
            "Harvest",
            "Telepathy",
            "Moody",
            "Overcoat",
            "Poison Touch",
            "Regenerator",
            "Big Pecks",
            "Sand Rush",
            "Wonder Skin",
            "Analytic",
            "Illusion",
            "Imposter",
            "Infiltrator",
            "Mummy",
            "Moxie",
            "Justified",
            "Rattled",
            "Magic Bounce",
            "Sap Sipper",
            "Prankster",
            "Sand Force",
            "Iron Barbs",
            "Zen Mode",
            "Victory Star",
            "Turboblaze",
            "Teravolt",
            "Aroma Veil",
            "Flower Veil",
            "Cheek Pouch",
            "Protean",
            "Fur Coat",
            "Magician",
            "Bulletproof",
            "Competitive",
            "Strong Jaw",
            "Refrigerate",
            "Sweet Veil",
            "Stance Change",
            "Gale Wings",
            "Mega Launcher",
            "Grass Pelt",
            "Symbiosis",
            "Tough Claws",
            "Pixilate",
            "Gooey",
            "Aerilate",
            "Parental Bond",
            "Dark Aura",
            "Fairy Aura",
            "Aura Break",
            "Primordial Sea",
            "Desolate Land",
            "Delta Stream",
            "Stamina",
            "Wimp Out",
            "Emergency Exit",
            "Water Compaction",
            "Merciless",
            "Shields Down",
            "Stakeout",
            "Water Bubble",
            "Steelworker",
            "Berserk",
            "Slush Rush",
            "Long Reach",
            "Liquid Voice",
            "Triage",
            "Galvanize",
            "Surge Surfer",
            "Schooling",
            "Disguise",
            "Battle Bond",
            "Power Construct",
            "Corrosion",
            "Comatose",
            "Queenly Majesty",
            "Innards Out",
            "Dancer",
            "Battery",
            "Fluffy",
            "Dazzling",
            "Soul-Heart",
            "Tangling Hair",
            "Receiver",
            "Power of Alchemy",
            "Beast Boost",
            "RKS System",
            "Electric Surge",
            "Psychic Surge",
            "Misty Surge",
            "Grassy Surge",
            "Full Metal Body",
            "Shadow Shield",
            "Prism Armor",
            "Neuroforce"
        };
    }

    namespace French {
        static const char *allAbilities[233] = {
            "Puanteur",
            "Crachin",
            "Turbo",
            "Armurbaston",
            "Fermeté",
            "Moiteur",
            "Échauffement",
            "Voile Sable",
            "Statik",
            "Absorbe-Volt",
            "Absorbe-Eau",
            "Benêt",
            "Ciel Gris",
            "Œil Composé",
            "Insomnia",
            "Homochromie",
            "Vaccin",
            "Torche",
            "Écran Poudre",
            "Tempo Perso",
            "Ventouse",
            "Intimidation",
            "Marque Ombre",
            "Peau Dure",
            "Garde Mystik",
            "Lévitation",
            "Pose Spore",
            "Synchro",
            "Corps Sain",
            "Médic Nature",
            "Paratonnerre",
            "Sérénité",
            "Glissade",
            "Chlorophylle",
            "Lumiattirance",
            "Calque",
            "Coloforce",
            "Point Poison",
            "Attention",
            "Armumagma",
            "Ignifu-Voile",
            "Magnépiège",
            "Anti-Bruit",
            "Cuvette",
            "Sable Volant",
            "Pression",
            "Isograisse",
            "Matinal",
            "Corps Ardent",
            "Fuite",
            "Regard Vif",
            "Hyper Cutter",
            "Ramassage",
            "Absentéisme",
            "Agitation",
            "Joli Sourire",
            "Plus",
            "Moins",
            "Météo",
            "Glu",
            "Mue",
            "Cran",
            "Écaille Spéciale",
            "Suintement",
            "Engrais",
            "Brasier",
            "Torrent",
            "Essaim",
            "Tête de Roc",
            "Sécheresse",
            "Piège Sable",
            "Esprit Vital",
            "Écran Fumée",
            "Force Pure",
            "Coque Armure",
            "Air Lock",
            "Pieds Confus",
            "Motorisé",
            "Rivalité",
            "Impassible",
            "Rideau Neige",
            "Gloutonnerie",
            "Colérique",
            "Délestage",
            "Ignifugé",
            "Simple",
            "Peau Sèche",
            "Télécharge",
            "Poing de Fer",
            "Soin Poison",
            "Adaptabilité",
            "Multi-Coups",
            "Hydratation",
            "Force Soleil",
            "Pied Véloce",
            "Normalise",
            "Sniper",
            "Garde Magik",
            "Annule Garde",
            "Frein",
            "Technicien",
            "Feuille Garde",
            "Maladresse",
            "Brise Moule",
            "Chanceux",
            "Boom Final",
            "Anticipation",
            "Prédiction",
            "Inconscient",
            "Lentiteintée",
            "Filtre",
            "Début Calme",
            "Querelleur",
            "Lavabo",
            "Corps Gel",
            "Solide Roc",
            "Alerte Neige",
            "Cherche Miel",
            "Fouille",
            "Téméraire",
            "Multi-Type",
            "Don Floral",
            "Mauvais Rêve",
            "Pickpocket",
            "Sans Limite",
            "Contestation",
            "Tension",
            "Acharné",
            "Défaitiste",
            "Corps Maudit",
            "Cœur Soin",
            "Garde-Ami",
            "Armurouillée",
            "Heavy Metal",
            "Light Metal",
            "Multiécaille",
            "Rage Poison",
            "Rage Brûlure",
            "Récolte",
            "Télépathe",
            "Lunatique",
            "Envelocape",
            "Toxitouche",
            "Régé-Force",
            "Cœur de Coq",
            "Baigne Sable",
            "Peau Miracle",
            "Analyste",
            "Illusion",
            "Imposteur",
            "Infiltration",
            "Momie",
            "Impudence",
            "Cœur Noble",
            "Phobique",
            "Miroir Magik",
            "Herbivore",
            "Farceur",
            "Force Sable",
            "Épine de Fer",
            "Mode Transe",
            "Victorieux",
            "Turbo Brasier",
            "Téra-Voltage",
            "Aroma-Voile",
            "Flora-Voile",
            "Bajoues",
            "Protéen",
            "Toison Épaisse",
            "Magicien",
            "Pare-Balles",
            "Battant",
            "Prognathe",
            "Peau Gelée",
            "Gluco-Voile",
            "Déclic Tactique",
            "Ailes Bourrasque",
            "Méga Blaster",
            "Toison Herbue",
            "Symbiose",
            "Griffe Dure",
            "Peau Féérique",
            "Poisseux",
            "Peau Céleste",
            "Amour Filial",
            "Aura Ténébreuse",
            "Aura Féérique",
            "Aura Inversée",
            "Mer Primaire",
            "Terre Finale",
            "Souffle Delta",
            "Endurance",
            "Escampette",
            "Repli Tactique",
            "Sable Humide",
            "Cruauté",
            "Bouclier-Carcan",
            "Filature",
            "Aquabulle",
            "Expert Acier",
            "Folle Furie",
            "Chasse-Neige",
            "Longue Portée",
            "Hydrata-Son",
            "Prioguérison",
            "Peau Électrique",
            "Surf Caudal",
            "Banc",
            "Fantômasque",
            "Synergie",
            "Rassemblement",
            "Corrosion",
            "Hypersommeil",
            "Prestance Royale",
            "Expuls’Organes",
            "Danseuse",
            "Batterie",
            "Boule de Poils",
            "Corps Coloré",
            "Animacœur",
            "Mèche Rebelle",
            "Receveur",
            "Osmose",
            "Boost Chimère",
            "Système Alpha",
            "Créa-Élec",
            "Créa-Psy",
            "Créa-Brume",
            "Créa-Herbe",
            "Métallo-Garde",
            "Spectro-Bouclier",
            "Prisme-Armure",
            "Cérébro-Force"
        };
    }

    namespace Italian {
        static const char *allAbilities[233] = {
            "Tanfo",
            "Piovischio",
            "Acceleratore",
            "Lottascudo",
            "Vigore",
            "Umidità",
            "Scioltezza",
            "Sabbiavelo",
            "Statico",
            "Assorbivolt",
            "Assorbacqua",
            "Indifferenza",
            "Antimeteo",
            "Insettocchi",
            "Insonnia",
            "Cambiacolore",
            "Immunità",
            "Fuocardore",
            "Polvoscudo",
            "Mente Locale",
            "Ventose",
            "Prepotenza",
            "Pedinombra",
            "Cartavetro",
            "Magidifesa",
            "Levitazione",
            "Spargispora",
            "Sincronismo",
            "Corpochiaro",
            "Alternacura",
            "Parafulmine",
            "Leggiadro",
            "Nuotovelox",
            "Clorofilla",
            "Risplendi",
            "Traccia",
            "Macroforza",
            "Velenopunte",
            "Forza Interiore",
            "Magmascudo",
            "Idrovelo",
            "Magnetismo",
            "Antisuono",
            "Copripioggia",
            "Sabbiafiume",
            "Pressione",
            "Grassospesso",
            "Sveglialampo",
            "Corpodifuoco",
            "Fugafacile",
            "Sguardofermo",
            "Ipertaglio",
            "Raccolta",
            "Pigrone",
            "Tuttafretta",
            "Incantevole",
            "Più",
            "Meno",
            "Previsioni",
            "Antifurto",
            "Muta",
            "Dentistretti",
            "Pelledura",
            "Melma",
            "Erbaiuto",
            "Aiutofuoco",
            "Acquaiuto",
            "Aiutinsetto",
            "Testadura",
            "Siccità",
            "Trappoarena",
            "Spiritovivo",
            "Fumochiaro",
            "Forzapura",
            "Guscioscudo",
            "Riparo",
            "Intricopiedi",
            "Elettrorapid",
            "Antagonismo",
            "Cuordeciso",
            "Mantelneve",
            "Voracità",
            "Grancollera",
            "Agiltecnica",
            "Antifuoco",
            "Disinvoltura",
            "Pellearsa",
            "Download",
            "Ferropugno",
            "Velencura",
            "Adattabilità",
            "Abillegame",
            "Idratazione",
            "Solarpotere",
            "Piedisvelti",
            "Normalità",
            "Cecchino",
            "Magicscudo",
            "Nullodifesa",
            "Rallentatore",
            "Tecnico",
            "Fogliamanto",
            "Impaccio",
            "Rompiforma",
            "Supersorte",
            "Scoppio",
            "Presagio",
            "Premonizione",
            "Imprudenza",
            "Lentifumé",
            "Filtro",
            "Lentoinizio",
            "Nervisaldi",
            "Acquascolo",
            "Corpogelo",
            "Solidroccia",
            "Scendineve",
            "Mielincetta",
            "Indagine",
            "Temerarietà",
            "Multitipo",
            "Regalfiore",
            "Sogniamari",
            "Arraffalesto",
            "Forzabruta",
            "Inversione",
            "Agitazione",
            "Agonismo",
            "Sconforto",
            "Corpofunesto",
            "Curacuore",
            "Amicoscudo",
            "Sottilguscio",
            "Metalpesante",
            "Metalleggero",
            "Multisquame",
            "Velenimpeto",
            "Bruciaimpeto",
            "Coglibacche",
            "Telepatia",
            "Altalena",
            "Copricapo",
            "Velentocco",
            "Rigenergia",
            "Pettinfuori",
            "Remasabbia",
            "Splendicute",
            "Ponderazione",
            "Illusione",
            "Sosia",
            "Intrapasso",
            "Mummia",
            "Arroganza",
            "Giustizia",
            "Paura",
            "Magispecchio",
            "Mangiaerba",
            "Burla",
            "Silicoforza",
            "Spineferrate",
            "Stato Zen",
            "Vittorstella",
            "Piroturbina",
            "Teravolt",
            "Aromavelo",
            "Fiorvelo",
            "Guancegonfie",
            "Mutatipo",
            "Foltopelo",
            "Prestigiatore",
            "Antiproiettile",
            "Tenacia",
            "Ferromascella",
            "Pellegelo",
            "Dolcevelo",
            "Accendilotta",
            "Aliraffica",
            "Megalancio",
            "Peloderba",
            "Simbiosi",
            "Unghiedure",
            "Pellefolletto",
            "Viscosità",
            "Pellecielo",
            "Amorefiliale",
            "Auratetra",
            "Aurafolletto",
            "Frangiaura",
            "Mare Primordiale",
            "Terra Estrema",
            "Flusso Delta",
            "Sopportazione",
            "Fuggifuggi",
            "Passoindietro",
            "Idrorinforzo",
            "Spietatezza",
            "Scudosoglia",
            "Sorveglianza",
            "Bolladacqua",
            "Tempracciaio",
            "Furore",
            "Spalaneve",
            "Distacco",
            "Idrovoce",
            "Primacura",
            "Pellelettro",
            "Codasurf",
            "Banco",
            "Fantasmanto",
            "Morfosintonia",
            "Sciamefusione",
            "Corrosione",
            "Sonno Assoluto",
            "Regalità",
            "Espellinterno",
            "Sincrodanza",
            "Batteria",
            "Morbidone",
            "Corposgargiante",
            "Cuoreanima",
            "Boccolidoro",
            "Ricezione",
            "Forza Chimica",
            "Ultraboost",
            "Sistema Primevo",
            "Elettrogenesi",
            "Psicogenesi",
            "Nebbiogenesi",
            "Erbogenesi",
            "Metalprotezione",
            "Spettroguardia",
            "Scudoprisma",
            "Cerebroforza"
        };
    }

    extern int abilityID;

    struct Ability {
        vector<string> name;
        vector<int> choiceNo;
    };

    struct Origins {
        const char *name;
        int choiceNo;
        int generationFrom;
    };

    namespace English {
        static const Origins allOrigins[30] = {
            {"Sun", 30, 7},
            {"Moon", 31, 7},
            {"Ultra Sun", 32, 7},
            {"Ultra Moon", 33, 7},
            {"X", 24, 6},
            {"Y", 25, 6},
            {"Omega Ruby", 27, 6},
            {"Alpha Sapphire", 26, 6},
            {"Black", 21, 5},
            {"White", 20, 5},
            {"Black 2", 23, 5},
            {"White 2", 22, 5},
            {"Diamond", 10, 4},
            {"Pearl", 11, 4},
            {"Platinum", 12, 4},
            {"HeatGold", 7, 4},
            {"SoulSilver", 8, 4},
            {"Ruby", 2, 3},
            {"Sapphire", 1, 3},
            {"Emerald", 3, 3},
            {"FireRed", 4, 2},
            {"LeafGreen", 5, 2},
            {"Colosseum/XD", 15, 3},
            {"Gold", 39, 2},
            {"Silver", 40, 2},
            {"Crystal", 41, 2},
            {"Red", 35, 1},
            {"Blue [INT]/Green [JP]", 36, 1},
            {"Blue [JP]", 37, 1},
            {"Yellow", 38, 1}
        };
    }

    namespace French {
        static const Origins allOrigins[30] = {
            {"Soleil", 30, 7},
            {"Lune", 31, 7},
            {"Ultra-Soleil", 32, 7},
            {"Ultra-Lune", 33, 7},
            {"X", 24, 6},
            {"Y", 25, 6},
            {"Rubis Oméga", 27, 6},
            {"Saphir Alpha", 26, 6},
            {"Noire", 21, 5},
            {"Blanche", 20, 5},
            {"Noire 2", 23, 5},
            {"Blanche 2", 22, 5},
            {"Diamant", 10, 4},
            {"Perle", 11, 4},
            {"Platine", 12, 4},
            {"Or HeartGold", 7, 4},
            {"Argent SoulSilver", 8, 4},
            {"Rubis", 2, 3},
            {"Saphir", 1, 3},
            {"Émeraude", 3, 3},
            {"Rouge Feu", 4, 2},
            {"Vert Feuille", 5, 2},
            {"Colosseum/XD", 15, 3},
            {"Or", 39, 2},
            {"Argent", 40, 2},
            {"Cristal", 41, 2},
            {"Rouge", 35, 1},
            {"Bleue [INT]/Vert [JP]", 36, 1},
            {"Bleue [JP]", 37, 1},
            {"Jaune", 38, 1}
        };
    }

    namespace Italian {
        static const Origins allOrigins[30] = {
            {"Sole", 30, 7},
            {"Luna", 31, 7},
            {"Ultra Sole", 32, 7},
            {"Ultra Luna", 33, 7},
            {"X", 24, 6},
            {"Y", 25, 6},
            {"Rubino Omega", 27, 6},
            {"Zaffiro Alpha", 26, 6},
            {"Nero", 21, 5},
            {"Bianco", 20, 5},
            {"Nero 2", 23, 5},
            {"Bianco 2", 22, 5},
            {"Diamante", 10, 4},
            {"Perla", 11, 4},
            {"Platino", 12, 4},
            {"HeatGold", 7, 4},
            {"SoulSilver", 8, 4},
            {"Rubino", 2, 3},
            {"Zaffiro", 1, 3},
            {"Smeraldo", 3, 3},
            {"Rosso Fuoco", 4, 2},
            {"Verde Foglia", 5, 2},
            {"Colosseum/XD", 15, 3},
            {"Oro", 39, 2},
            {"Argento", 40, 2},
            {"Cristallo", 41, 2},
            {"Rosso", 35, 1},
            {"Blu [INT]/Verde [JP]", 36, 1},
            {"Blu [JP]", 37, 1},
            {"Giallo", 38, 1}
        };
    }

    struct Geograph {
        int id;
        const char *name;
    };

    namespace English {
        static const Geograph allCountries[122] = {
            {1, "Japan"},
            {8, "Anguilla"},
            {9, "Antigua"},
            {10, "Argentina"},
            {11, "Aruba"},
            {12, "Bahamas"},
            {13, "Barbados"},
            {14, "Belize"},
            {15, "Bolivia"},
            {16, "Brazil"},
            {17, "British Virgin Islands"},
            {18, "Canada"},
            {19, "Cayman Islands"},
            {20, "Chile"},
            {21, "Colombia"},
            {22, "Costa Rica"},
            {23, "Dominica"},
            {24, "Dominican Republic"},
            {25, "Ecuador"},
            {26, "El Salvador"},
            {27, "French Guiana"},
            {28, "Grenada"},
            {29, "Guadeloupe"},
            {30, "Guatemala"},
            {31, "Guyana"},
            {32, "Haiti"},
            {33, "Hounduras"},
            {34, "Jamaica"},
            {35, "Martinique"},
            {36, "Mexico"},
            {37, "Monstserrat"},
            {38, "Netherlands Antilles"},
            {39, "Nicaragua"},
            {40, "Panama"},
            {41, "Paraguay"},
            {42, "Peru"},
            {43, "St. Kitts"},
            {44, "St. Lucia"},
            {45, "St. Vincent & Grenadines"},
            {46, "Suriname"},
            {47, "Trinidad and Tobago"},
            {48, "Turks and Caicos Islands"},
            {49, "United States"},
            {50, "Uruguay"},
            {51, "US Virgin Islands"},
            {52, "Venezuela"},
            {64, "Albania"},
            {65, "Australia"},
            {66, "Austria"},
            {67, "Belgium"},
            {68, "Bosnia and Herzegovina"},
            {69, "Botswana"},
            {70, "Bulgaria"},
            {71, "Croatia"},
            {72, "Cyprus"},
            {73, "Czech Republic"},
            {74, "Denmark"},
            {75, "Estonia"},
            {76, "Finland"},
            {77, "France"},
            {78, "Germany"},
            {79, "Greece"},
            {80, "Hungary"},
            {81, "Iceland"},
            {82, "Ireland"},
            {83, "Italy"},
            {84, "Latvia"},
            {85, "Lesotho"},
            {86, "Liechtenstein"},
            {87, "Lithuania"},
            {88, "Luxembourg"},
            {89, "Macedonia"},
            {90, "Malta"},
            {91, "Montengro"},
            {92, "Mozambique"},
            {93, "Namibia"},
            {94, "Netherlands"},
            {95, "New Zealand"},
            {96, "Norway"},
            {97, "Poland"},
            {98, "Portugal"},
            {99, "Romania"},
            {100, "Russia"},
            {101, "Serbia nad Ksovo"},
            {102, "Slovakia"},
            {103, "Slovenia"},
            {104, "South Africa"},
            {105, "Span"},
            {106, "Swaziland"},
            {107, "Sweden"},
            {108, "Switzerland"},
            {109, "Turkey"},
            {110, "United Kingdom"},
            {111, "Zambia"},
            {112, "Zimbabwe"},
            {113, "Azerbaijan"},
            {114, "Mauritania"},
            {115, "Mali"},
            {116, "Niger"},
            {117, "Chaud"},
            {118, "Sudan"},
            {119, "Eritrea"},
            {120, "Dijibouti"},
            {121, "Somalia"},
            {122, "Andorra"},
            {123, "Gibraltar"},
            {124, "Guernsey"},
            {125, "Isle of Man"},
            {126, "Jersey"},
            {127, "Monaco"},
            {128, "Taiwan"},
            {136, "South Korea"},
            {144, "Hong Kong"},
            {153, "Singapore"},
            {156, "Malayasia"},
            {160, "China"},
            {168, "U.A.E."},
            {169, "India"},
            {174, "Saudi Arabia"},
            {184, "San Marino"},
            {185, "Vatican City"},
            {186, "Bermuda"}
        };
    }

    namespace French {
        static const Geograph allCountries[122] = {
            {1, "Japon"},
            {8, "Anguilla"},
            {9, "Antigua"},
            {10, "Argentine"},
            {11, "Aruba"},
            {12, "Bahamas"},
            {13, "Barbade"},
            {14, "Belize"},
            {15, "Bolivie"},
            {16, "Brésil"},
            {17, "Îles Vierges britanniques"},
            {18, "Canada"},
            {19, "Îles Caïmans"},
            {20, "Chili"},
            {21, "Colombie"},
            {22, "Costa Rica"},
            {23, "Dominique"},
            {24, "République dominicaine"},
            {25, "Équateur"},
            {26, "El Salvador"},
            {27, "Guyane française"},
            {28, "Grenade"},
            {29, "Guadeloupe"},
            {30, "Guatemala"},
            {31, "Guyana"},
            {32, "Haïti"},
            {33, "Honduras"},
            {34, "Jamaïque"},
            {35, "Martinique"},
            {36, "Mexique"},
            {37, "Montserrat"},
            {38, "Antilles néerlandaises"},
            {39, "Nicaragua"},
            {40, "Panama"},
            {41, "Paraguay"},
            {42, "Pérou"},
            {43, "Saint-Kitts"},
            {44, "Sainte-Lucie"},
            {45, "Saint-Vincent-et-les Grenadines"},
            {46, "Suriname"},
            {47, "Trinité-et-Tobago"},
            {48, "Îles Turques-et-Caïques"},
            {49, "États-Unis"},
            {50, "Uruguay"},
            {51, "Îles Vierges américaines"},
            {52, "Venezuela"},
            {64, "Albanie"},
            {65, "Australie"},
            {66, "Autriche"},
            {67, "Belgique"},
            {68, "Bosnie-Herzégovine"},
            {69, "Botswana"},
            {70, "Bulgarie"},
            {71, "Croatie"},
            {72, "Chypre"},
            {73, "République tchèque"},
            {74, "Danemark"},
            {75, "Estonie"},
            {76, "Finlande"},
            {77, "France"},
            {78, "Allemagne"},
            {79, "Grèce"},
            {80, "Hongrie"},
            {81, "Islande"},
            {82, "Irlande"},
            {83, "Italie"},
            {84, "Lettonie"},
            {85, "Lesotho"},
            {86, "Liechtenstein"},
            {87, "Lituanie"},
            {88, "Luxembourg"},
            {89, "Macédoine"},
            {90, "Malte"},
            {91, "Monténégro"},
            {92, "Mozambique"},
            {93, "Namibie"},
            {94, "Pays-Bas"},
            {95, "Nouvelle-Zélande"},
            {96, "Norvège"},
            {97, "Pologne"},
            {98, "Portugal"},
            {99, "Roumanie"},
            {100, "Russie"},
            {101, "Serbie et Kosovo"},
            {102, "Slovaquie"},
            {103, "Slovénie"},
            {104, "Afrique du Sud"},
            {105, "Espagne"},
            {106, "Swaziland"},
            {107, "Suède"},
            {108, "Suisse"},
            {109, "Turquie"},
            {110, "Royaume-Uni"},
            {111, "Zambie"},
            {112, "Zimbabwe"},
            {113, "Azerbaïdjan"},
            {114, "Mauritanie"},
            {115, "Mali"},
            {116, "Niger"},
            {117, "Tchad"},
            {118, "Soudan"},
            {119, "Érythrée"},
            {120, "Djibouti"},
            {121, "Somalie"},
            {122, "Andorre"},
            {123, "Gibraltar"},
            {124, "Guernesey"},
            {125, "Île de Man"},
            {126, "Jersey"},
            {127, "Monaco"},
            {128, "Taïwan"},
            {136, "Corée du Sud"},
            {144, "Hong Kong"},
            {153, "Singapour"},
            {156, "Malaisie"},
            {160, "Chine"},
            {168, "Émirats arabes unis"},
            {169, "Inde"},
            {174, "Arabie saoudite"},
            {184, "Saint-Marin"},
            {185, "Cité du Vatican"},
            {186, "Bermudes"}
        };
    }

    namespace Italian {
        static const Geograph allCountries[122] = {
            {1, "Giappone"},
            {8, "Anguilla"},
            {9, "Antigua"},
            {10, "Argentina"},
            {11, "Aruba"},
            {12, "Bahamas"},
            {13, "Barbados"},
            {14, "Belize"},
            {15, "Bolivia"},
            {16, "Brasile"},
            {17, "Isole Vergini britanniche"},
            {18, "Canada"},
            {19, "Isole Cayman"},
            {20, "Cile"},
            {21, "Colombia"},
            {22, "Costa Rica"},
            {23, "Dominica"},
            {24, "Repubblica Dominicana"},
            {25, "Ecuador"},
            {26, "El Salvador"},
            {27, "Guyana francese"},
            {28, "Grenada"},
            {29, "Guadalupa"},
            {30, "Guatemala"},
            {31, "Guyana"},
            {32, "Haiti"},
            {33, "Hounduras"},
            {34, "Jamaica"},
            {35, "Martinica"},
            {36, "Messico"},
            {37, "Monstserrat"},
            {38, "Antille Olandesi"},
            {39, "Nicaragua"},
            {40, "Panama"},
            {41, "Paraguay"},
            {42, "Peru"},
            {43, "San Cristoforo"},
            {44, "Santa Lucia"},
            {45, "San Vincenzo e Grenadine"},
            {46, "Repubblica del Suriname"},
            {47, "Trinidad e Tobago"},
            {48, "Turks e Caicos"},
            {49, "Stati Uniti"},
            {50, "Uruguay"},
            {51, "Isole Vergini Americane"},
            {52, "Venezuela"},
            {64, "Albania"},
            {65, "Australia"},
            {66, "Austria"},
            {67, "Belgio"},
            {68, "Bosnia ed Erzegovina"},
            {69, "Botswana"},
            {70, "Bulgaria"},
            {71, "Croazia"},
            {72, "Cipro"},
            {73, "Repubblica Ceca"},
            {74, "Danimarca"},
            {75, "Estonia"},
            {76, "Finlandia"},
            {77, "Francia"},
            {78, "Germania"},
            {79, "Grecia"},
            {80, "Hungary"},
            {81, "Islanda"},
            {82, "Irlanda"},
            {83, "Italia"},
            {84, "Lettonia"},
            {85, "Lesotho"},
            {86, "Liechtenstein"},
            {87, "Lituania"},
            {88, "Lussemburgo"},
            {89, "Macedonia"},
            {90, "Malta"},
            {91, "Montengro"},
            {92, "Mozambico"},
            {93, "Namibia"},
            {94, "Paesi Bassi"},
            {95, "Nuova Zelanda"},
            {96, "Norvegia"},
            {97, "Polonia"},
            {98, "Portogallo"},
            {99, "Romania"},
            {100, "Russia"},
            {101, "Serbi del Kosovo"},
            {102, "Slovakia"},
            {103, "Slovenia"},
            {104, "Sud Africa"},
            {105, "Spagna"},
            {106, "eSwatini"},
            {107, "Svezia"},
            {108, "Svizzera"},
            {109, "Turchia"},
            {110, "Regno Unito"},
            {111, "Zambia"},
            {112, "Zimbabwe"},
            {113, "Azerbaijan"},
            {114, "Mauritania"},
            {115, "Mali"},
            {116, "Niger"},
            {117, "Chaud"},
            {118, "Sudan"},
            {119, "Eritrea"},
            {120, "Dijibouti"},
            {121, "Somalia"},
            {122, "Andorra"},
            {123, "Gibraltar"},
            {124, "Guernsey"},
            {125, "Isola di Man"},
            {126, "Jersey"},
            {127, "Monaco"},
            {128, "Taiwan"},
            {136, "Corea del Sud"},
            {144, "Hong Kong"},
            {153, "Singapore"},
            {156, "Malesia"},
            {160, "Cina"},
            {168, "Emirati Arabi Uniti"},
            {169, "India"},
            {174, "Arabia Saudita"},
            {184, "San Marino"},
            {185, "Città del Vaticano"},
            {186, "Bermuda"}
        };
    }

    struct Locations {
        int choiceNo;
        const char* name;
    };

    namespace English {
        static const Locations allLocs6[97] = {
            {2, "Mystery Zone"},
            {4, "Faraway Place"},
            {6, "Vaniville Town"},
            {8, "Route 1"},
            {9, "Vaniville Pathway"},
            {10, "Aquacorde Town"},
            {12, "Route 2"},
            {13, "Avance Trail"},
            {14, "Santalune Forest"},
            {16, "Route 3"},
            {17, "Ouvert Way"},
            {18, "Santalune City"},
            {20, "Route 4"},
            {21, "Parterre Way"},
            {22, "Lumiose City"},
            {24, "Prism Tower"},
            {26, "Lysandre Labs"},
            {28, "Route 5"},
            {29, "Versant Road"},
            {30, "Camphrier Town"},
            {32, "Shabboneau Castle"},
            {34, "Route 6"},
            {35, "Palais Lane"},
            {36, "Parfum Palace"},
            {38, "Route 7"},
            {39, "Rivière Walk"},
            {40, "Cyllage City"},
            {42, "Route 8"},
            {43, "Muraille Coast"},
            {44, "Ambrette Town"},
            {46, "Route 9"},
            {47, "Spikes Passage"},
            {48, "Battle Chateau"},
            {50, "Route 10"},
            {51, "Menhir Trail"},
            {52, "Geosenge Town"},
            {54, "Route 11"},
            {55, "Miroir Way"},
            {56, "Reflection Cave"},
            {58, "Shalour City"},
            {60, "Tower of Mastery"},
            {62, "Route 12"},
            {63, "Fourrage Road"},
            {64, "Coumarine City"},
            {66, "Route 13"},
            {67, "Lumiose Badlands"},
            {68, "Route 14"},
            {69, "Laverre Nature Trail"},
            {70, "Laverre City"},
            {72, "Poké Ball Factory"},
            {74, "Route 15"},
            {75, "Brun Way"},
            {76, "Dendemille Town"},
            {78, "Route 16"},
            {79, "Mélancolie Path"},
            {82, "Frost Cavern"},
            {84, "Route 17"},
            {85, "Mamoswine Road"},
            {86, "Anistar City"},
            {88, "Route 18"},
            {89, "Vallée Étroite Way"},
            {90, "Couriway Town"},
            {92, "Route 19"},
            {93, "Grande Vallée Way"},
            {94, "Snowbelle City"},
            {96, "Route 20"},
            {97, "Winding Woods"},
            {98, "Pokémon Village"},
            {100, "Route 21"},
            {101, "Dernière Way"},
            {102, "Route 22"},
            {103, "Détourner Way"},
            {104, "Victory Road"},
            {106, "Pokémon League"},
            {108, "Kiloude City"},
            {110, "Battle Maison"},
            {112, "Azure Bay"},
            {132, "Glittering Cave"},
            {134, "Connecting Cave"},
            {135, "Zubat Roost"},
            {136, "Kalos Power Plant"},
            {138, "Team Flare Secret HQ"},
            {140, "Terminus Cave"},
            {142, "Lost Hotel"},
            {144, "Chamber of Emptiness"},
            {146, "Sea Spirit’s Den"},
            {148, "Friend Safari"},
            {150, "Blazing Chamber"},
            {152, "Flood Chamber"},
            {154, "Ironworks Chamber"},
            {156, "Dragonmark Chamber"},
            {158, "Radiant Chamber"},
            {160, "Pokémon League Gate"},
            {162, "Lumiose Station"},
            {164, "Kiloude Station"},
            {166, "Ambrette Aquarium"},
            {168, "Unknown Dungeon"}
        };

        static const Locations allLocs6b[92] = {
            {170, "Littleroot Town"},
            {172, "Oldale Town"},
            {174, "Dewford Town"},
            {176, "Lavaridge Town"},
            {178, "Fallarbor Town"},
            {180, "Verdanturf Town"},
            {182, "Pacifidlog Town"},
            {184, "Petalburg City"},
            {186, "Slateport City"},
            {188, "Mauville City"},
            {190, "Rustboro City"},
            {192, "Fortree City"},
            {194, "Lilycove City"},
            {196, "Mossdeep City"},
            {198, "Sootopolis City"},
            {200, "Ever Grande City"},
            {202, "Pokémon League"},
            {204, "Route 101"},
            {206, "Route 102"},
            {208, "Route 103"},
            {210, "Route 104"},
            {212, "Route 105"},
            {214, "Route 106"},
            {216, "Route 107"},
            {218, "Route 108"},
            {220, "Route 109"},
            {222, "Route 110"},
            {224, "Route 111"},
            {226, "Route 112"},
            {228, "Route 113"},
            {230, "Route 114"},
            {232, "Route 115"},
            {234, "Route 116"},
            {236, "Route 117"},
            {238, "Route 118"},
            {240, "Route 119"},
            {242, "Route 120"},
            {244, "Route 121"},
            {246, "Route 122"},
            {248, "Route 123"},
            {250, "Route 124"},
            {252, "Route 125"},
            {254, "Route 126"},
            {256, "Route 127"},
            {258, "Route 128"},
            {260, "Route 129"},
            {262, "Route 130"},
            {264, "Route 131"},
            {266, "Route 132"},
            {268, "Route 133"},
            {270, "Route 134"},
            {272, "Meteor Falls"},
            {274, "Rusturf Tunnel"},
            {278, "Desert Ruins"},
            {280, "Granite Cave"},
            {282, "Petalburg Woods"},
            {284, "Mt. Chimney"},
            {286, "Jagged Pass"},
            {288, "Fiery Path"},
            {290, "Mt. Pyre"},
            {292, "Team Aqua Hideout"},
            {294, "Seafloor Cavern"},
            {296, "Cave of Origin"},
            {298, "Victory Road"},
            {300, "Shoal Cave"},
            {302, "New Mauville"},
            {304, "Sea Mauville"},
            {306, "Island Cave"},
            {308, "Ancient Tomb"},
            {310, "Sealed Chamber"},
            {312, "Scorched Slab"},
            {314, "Team Magma Hideout"},
            {316, "Sky Pillar"},
            {318, "Battle Resort"},
            {320, "Southern Island"},
            {322, "S.S. Tidal"},
            {324, "Safari Zone"},
            {326, "Mirage Forest"},
            {328, "Mirage Cave"},
            {330, "Mirage Island"},
            {332, "Mirage Mountain"},
            {334, "Trackless Forest"},
            {336, "Pathless Plain"},
            {338, "Nameless Cavern"},
            {340, "Fabled Cave"},
            {342, "Gnarled Den"},
            {344, "Crescent Isle"},
            {346, "Secret Islet"},
            {348, "Soaring in the sky"},
            {350, "Secret Shore"},
            {352, "Secret Meadow"},
            {354, "Secret Base"}
        };
    }

    namespace French {
        static const Locations allLocs6[97] = {
            {2, "Zone Mystère"},
            {4, "Lieu Lointain"},
            {6, "Bourg Croquis"},
            {8, "Route 1"},
            {9, "Sentier de Bourg Croquis"},
            {10, "Quarellis"},
            {12, "Route 2"},
            {13, "Chemin d'Avance"},
            {14, "Forêt de Neuvartault"},
            {16, "Route 3"},
            {17, "Chemin Ouvert"},
            {18, "Ville Illumis"},
            {20, "Route 4"},
            {21, "Chemin des Roches"},
            {22, "Luminalia"},
            {24, "Tour Prismatique"},
            {26, "Laboratoire Lysandre"},
            {28, "Route 5"},
            {29, "Chemin Versant"},
            {30, "Fort-Vanitas"},
            {32, "Château de Shabboneau"},
            {34, "Route 6"},
            {35, "Allée du Palais"},
            {36, "Palais Chaydeuvre"},
            {38, "Route 7"},
            {39, "Promenade des Rives"},
            {40, "Yantreizh"},
            {42, "Route 8"},
            {43, "Côte des Murailles"},
            {44, "Port Tempères"},
            {46, "Route 9"},
            {47, "Voie de l'Éclat"},
            {48, "Château de Combat"},
            {50, "Route 10"},
            {51, "Chemin Mégalithique"},
            {52, "Batisques"},
            {54, "Route 11"},
            {55, "Chemin Miroir"},
            {56, "Grotte Miroitante"},
            {58, "City-Luminalia"},
            {60, "Tour Maîtrise"},
            {62, "Route 12"},
            {63, "Chemin Fourrage"},
            {64, "Port Tempères"},
            {66, "Route 13"},
            {67, "Terres Sauvages de Luminalia"},
            {68, "Route 14"},
            {69, "Chemin des Lys"},
            {70, "Romant-sous-Bois"},
            {72, "Usine de Poké Balls"},
            {74, "Route 15"},
            {75, "Chemin Broussailleux"},
            {76, "Fort-Vanitas"},
            {78, "Route 16"},
            {79, "Chemin de la Mélancolie"},
            {82, "Caverne Gelée"},
            {84, "Route 17"},
            {85, "Route Mammochon"},
            {86, "Joliberges"},
            {88, "Route 18"},
            {89, "Chemin Vallée Étroite"},
            {90, "Vallée Étroite"},
            {92, "Route 19"},
            {93, "Chemin Grande Vallée"},
            {94, "Auffrac-les-Congères"},
            {96, "Route 20"},
            {97, "Bois de la Délivrance"},
            {98, "Village Pokémon"},
            {100, "Route 21"},
            {101, "Chemin Final"},
            {102, "Route 22"},
            {103, "Chemin Détour"},
            {104, "Route Victoire"},
            {106, "Ligue Pokémon"},
            {108, "Vaguelone"},
            {110, "Château de Combat"},
            {112, "Baie Azur"},
            {132, "Grotte Éclatante"},
            {134, "Grotte Relif"},
            {135, "Toit des Nosféralto"},
            {136, "Centrale de Kalos"},
            {138, "QG de la Team Flare"},
            {140, "Grotte Coda"},
            {142, "Hôtel Désolation"},
            {144, "Chambre du Néant"},
            {146, "Grotte de l'Esprit"},
            {148, "Safari des Amis"},
            {150, "Chambre Ardent"},
            {152, "Chambre Inondée"},
            {154, "Chambre des Forges"},
            {156, "Chambre Marquée"},
            {158, "Chambre Radieuse"},
            {160, "Porte de la Ligue Pokémon"},
            {162, "Gare de Luminalia"},
            {164, "Gare de Vaguelone"},
            {166, "Aquarium de Port Tempères"},
            {168, "Grotte Inconnue"}
        };

        static const Locations allLocs6b[92] = {
            {170, "Bourg-en-Vol"},
            {172, "Clémenti-Ville"},
            {174, "Vermilava"},
            {176, "Vergazon"},
            {178, "Village Myokara"},
            {180, "Mérouville"},
            {182, "Atalanopolis"},
            {184, "Clémenti-ville"},
            {186, "Poivressel"},
            {188, "Algatia"},
            {190, "Roche-sur-Gliffe"},
            {192, "Cimetronelle"},
            {194, "Nénucrique"},
            {196, "Algatia"},
            {198, "Atalanopolis"},
            {200, "Vermilava"},
            {202, "Ligue Pokémon"},
            {204, "Route 101"},
            {206, "Route 102"},
            {208, "Route 103"},
            {210, "Route 104"},
            {212, "Route 105"},
            {214, "Route 106"},
            {216, "Route 107"},
            {218, "Route 108"},
            {220, "Route 109"},
            {222, "Route 110"},
            {224, "Route 111"},
            {226, "Route 112"},
            {228, "Route 113"},
            {230, "Route 114"},
            {232, "Route 115"},
            {234, "Route 116"},
            {236, "Route 117"},
            {238, "Route 118"},
            {240, "Route 119"},
            {242, "Route 120"},
            {244, "Route 121"},
            {246, "Route 122"},
            {248, "Route 123"},
            {250, "Route 124"},
            {252, "Route 125"},
            {254, "Route 126"},
            {256, "Route 127"},
            {258, "Route 128"},
            {260, "Route 129"},
            {262, "Route 130"},
            {264, "Route 131"},
            {266, "Route 132"},
            {268, "Route 133"},
            {270, "Route 134"},
            {272, "Grotte Métamo"},
            {274, "Tunnel Mérazon"},
            {278, "Ruines Désert"},
            {280, "Caverne Granite"},
            {282, "Bois Clémenti"},
            {284, "Chemin Ardent"},
            {286, "Chemin Rocheux"},
            {288, "Voie Étroite"},
            {290, "Mont Mémoria"},
            {292, "Planque Team Aqua"},
            {294, "Caverne Fondmer"},
            {296, "Caverne Origine"},
            {298, "Route Victoire"},
            {300, "Grotte Étage"},
            {302, "Manoir Lavand"},
            {304, "Épave"},
            {306, "Grotte Insulaire"},
            {308, "Tombeau Antique"},
            {310, "Chambre Verrouillée"},
            {312, "Ruines Anciennes"},
            {314, "Planque Team Magma"},
            {316, "Pilier Céleste"},
            {318, "Atoll de Combat"},
            {320, "Île du Sud"},
            {322, "S.S. Tidal"},
            {324, "Zone de Safari"},
            {326, "Forêt Mirage"},
            {328, "Grotte Mirage"},
            {330, "Île Mirage"},
            {332, "Mont Mirage"},
            {334, "Forêt Impénétrable"},
            {336, "Plaine Indéfinie"},
            {338, "Caverne Sans Nom"},
            {340, "Grotte Oubliée"},
            {342, "Tanière Tortue"},
            {344, "Îlot Croissant"},
            {346, "Îlot Secret"},
            {348, "Planant dans le ciel"},
            {350, "Bord Secret"},
            {352, "Méandres Secrets"},
            {354, "Base Secrète"}
        };
    }

    namespace Italian {
        static const Locations allLocs6[97] = {
            {2, "Zona Misteriosa"},
            {4, "Luogo remoto "},
            {6, "Borgo Bozzetto"},
            {8, "Percorso 1"},
            {9, "Vicolo Bozzetto "},
            {10, "Rio Acquerello"},
            {12, "Percorso 2"},
            {13, "Via Progresso"},
            {14, "Bosco Novartopoli"},
            {16, "Percorso 3"},
            {17, "Via Aperta"},
            {18, "Novartopoli"},
            {20, "Percorso 4"},
            {21, "Fontana delle Perle"},
            {22, "Luminopoli"},
            {24, "Torre Prisma "},
            {26, "Laboratori Elisio"},
            {28, "Percorso 5"},
            {29, "Via Versante"},
            {30, "Castel Vanità"},
            {32, "Maniero Sottotono"},
            {34, "Percorso 6"},
            {35, "Boulevard Palazzo"},
            {36, "Reggia Aurea"},
            {38, "Percorso 7"},
            {39, "Via Fiume"},
            {40, "Altoripoli"},
            {42, "Percorso 8"},
            {43, "Muraglia Costiera"},
            {44, "Petroglifari"},
            {46, "Percorso 9"},
            {47, "Sentiero Punzoni"},
            {48, "Castello Lotta"},
            {50, "Percorso 10"},
            {51, "Strada dei Menhir"},
            {52, "Cromleburgo"},
            {54, "Percorso 11"},
            {55, "Via dei Riflessi"},
            {56, "Grotta dei Riflessi"},
            {58, "Yantaropoli"},
            {60, "Torre Maestra"},
            {62, "Percorso 12"},
            {63, "Via dei Pascoli"},
            {64, "Temperopoli"},
            {66, "Percorso 13"},
            {67, "Landa di Luminopoli"},
            {68, "Percorso 14"},
            {69, "Sentiero Romantopoli"},
            {70, "Romantopoli"},
            {72, "Fabbrica Poké Ball"},
            {74, "Percorso 15"},
            {75, "Via Fogliebrune"},
            {76, "Frescovilla"},
            {78, "Percorso 16"},
            {79, "Via Malinconia"},
            {82, "Caverna Gelata"},
            {84, "Percorso 17"},
            {85, "Passo Mamoswine"},
            {86, "Fluxopoli"},
            {88, "Percorso 18"},
            {89, "Via Valle Stretta"},
            {90, "Ponte Mosaico"},
            {92, "Percorso 19"},
            {93, "Via Valle Larga"},
            {94, "Fractalopoli"},
            {96, "Percorso 20"},
            {97, "Bosco Passoperso"},
            {98, "Valle dei Pokémon"},
            {100, "Percorso 21"},
            {101, "Via Ultima"},
            {102, "Percorso 22"},
            {103, "Via Detour"},
            {104, "Via Vittoria"},
            {106, "Lega Pokémon"},
            {108, "Batikopoli"},
            {110, "Villa Lotta"},
            {112, "Baia Azzurra"},
            {132, "Grotta dei Bagliori"},
            {134, "Grotta Trait d’Union"},
            {135, "Tana degli Zubat"},
            {136, "Centrale di Kalos"},
            {138, "Covo del Team Flare"},
            {140, "Grotta Climax"},
            {142, "Albergo Diroccato"},
            {144, "Stanza Vacua"},
            {146, "Antro Talassico"},
            {148, "Safari Amici"},
            {150, "Sala delle Fiamme"},
            {152, "Sala delle Chiuse"},
            {154, "Sala del Metallo"},
            {156, "Sala del Dragone"},
            {158, "Sala della Luce"},
            {160, "Varco Lega Pokémon"},
            {162, "Stazione Luminopoli"},
            {164, "Stazione Batikopoli"},
            {166, "Acquario"},
            {168, "Grotta Ignota"}
        };

        static const Locations allLocs6b[92] = {
            {170, "Albanova"},
            {172, "Solarosa"},
            {174, "Bluruvia"},
            {176, "Cuordilava"},
            {178, "Brunifoglia"},
            {180, "Mentania"},
            {182, "Orocea"},
            {184, "Petalipoli"},
            {186, "Porto Selcepoli"},
            {188, "Ciclamipoli"},
            {190, "Ferrugipoli"},
            {192, "Forestopoli"},
            {194, "Porto Alghepoli"},
            {196, "Verdeazzupoli"},
            {198, "Ceneride"},
            {200, "Iridopoli"},
            {202, "Lega Pokémon"},
            {204, "Percorso 101"},
            {206, "Percorso 102"},
            {208, "Percorso 103"},
            {210, "Percorso 104"},
            {212, "Percorso 105"},
            {214, "Percorso 106"},
            {216, "Percorso 107"},
            {218, "Percorso 108"},
            {220, "Percorso 109"},
            {222, "Percorso 110"},
            {224, "Percorso 111"},
            {226, "Percorso 112"},
            {228, "Percorso 113"},
            {230, "Percorso 114"},
            {232, "Percorso 115"},
            {234, "Percorso 116"},
            {236, "Percorso 117"},
            {238, "Percorso 118"},
            {240, "Percorso 119"},
            {242, "Percorso 120"},
            {244, "Percorso 121"},
            {246, "Percorso 122"},
            {248, "Percorso 123"},
            {250, "Percorso 124"},
            {252, "Percorso 125"},
            {254, "Percorso 126"},
            {256, "Percorso 127"},
            {258, "Percorso 128"},
            {260, "Percorso 129"},
            {262, "Percorso 130"},
            {264, "Percorso 131"},
            {266, "Percorso 132"},
            {268, "Percorso 133"},
            {270, "Percorso 134"},
            {272, "Cascate Meteora"},
            {274, "Tunnel Menferro"},
            {278, "Rovine Sabbiose"},
            {280, "Grotta Pietrosa"},
            {282, "Bosco Petalo"},
            {284, "Monte Camino"},
            {286, "Passo Selvaggio"},
            {288, "Cammino Ardente"},
            {290, "Monte Pira"},
            {292, "Rifugio Idro"},
            {294, "Antro Abissale"},
            {296, "Grotta dei Tempi"},
            {298, "Via Vittoria"},
            {300, "Grotta Ondosa"},
            {302, "Ciclanova"},
            {304, "Ciclamare"},
            {306, "Grotta Insulare"},
            {308, "Tomba Antica"},
            {310, "Sala Incisa"},
            {312, "Grottino Solare"},
            {314, "Rifugio Magma"},
            {316, "Torre dei Cieli"},
            {318, "Resort Lotta"},
            {320, "Isola Remota"},
            {322, "Motonave Marea"},
            {324, "Zona Safari"},
            {326, "Selva Miraggio"},
            {328, "Grotta Miraggio"},
            {330, "Isola Miraggio"},
            {332, "Monte Miraggio"},
            {334, "Foresta Vergine"},
            {336, "Piana Senza Nome"},
            {338, "Caverna Ignota"},
            {340, "Grotta Sfuggente"},
            {342, "Fossa Informe"},
            {344, "Isola Arcodiluna"},
            {346, "Isolotto Segreto"},
            {348, "Ipersfera"},
            {350, "Baia Segreta"},
            {352, "Valle Segreta"},
            {354, "Base Segreta"}
        };
    }

    struct Balls {
        int choiceNo;
        const char *name;
        int generationFrom;
    };

    namespace English {
        static const Balls allBalls[26] = {
            {4, "Poké Ball", 3},
            {3, "Great Ball", 3},
            {2, "Ultra Ball", 3},
            {26, "Beast Ball", 7},
            {16, "Cherish Ball", 4},
            {7, "Dive Ball", 3},
            {25, "Dream Ball", 5},
            {13, "Dusk Ball", 4},
            {17, "Fast Ball", 4},
            {22, "Friend Ball", 4},
            {14, "Heal Ball", 4},
            {20, "Heavy Ball", 4},
            {18, "Level Ball", 4},
            {21, "Love Ball", 4},
            {19, "Lure Ball", 4},
            {11, "Luxury Ball", 3},
            {1, "Master Ball", 3},
            {23, "Moon Ball", 4},
            {8, "Nest Ball", 3},
            {6, "Net Ball", 3},
            {12, "Premier Ball", 3},
            {15, "Quick Ball", 4},
            {9, "Repeat Ball", 3},
            {5, "Safari Ball", 3},
            {24, "Sport Ball", 4},
            {10, "Timer Ball", 3}
        };
    }

    namespace French {
        static const Balls allBalls[26] = {
            {4, "Poké Ball", 3},
            {3, "Super Ball", 3},
            {2, "Hyper Ball", 3},
            {26, "Safari Ball", 7},
            {16, "Mémoire Ball", 4},
            {7, "Scuba Ball", 3},
            {25, "Songe Ball", 5},
            {13, "Sombre Ball", 4},
            {17, "Vif Ball", 4},
            {22, "Copain Ball", 4},
            {14, "Soin Ball", 4},
            {20, "Masse Ball", 4},
            {18, "Niveau Ball", 4},
            {21, "Love Ball", 4},
            {19, "Appât Ball", 4},
            {11, "Luxe Ball", 3},
            {1, "Master Ball", 3},
            {23, "Lune Ball", 4},
            {8, "Nid Ball", 3},
            {6, "Filet Ball", 3},
            {12, "Honor Ball", 3},
            {15, "Chrono Ball", 4},
            {9, "Échos Ball", 3},
            {5, "Speed Ball", 3},
            {24, "Sport Ball", 4},
            {10, "Temps Ball", 3}
        };
    }

    namespace Italian {
        static const Balls allBalls[26] = {
            {4, "Poké Ball", 3},
            {3, "Mega Ball", 3},
            {2, "Ultra Ball", 3},
            {26, "UC Ball", 7},
            {16, "Pregio Ball", 4},
            {7, "Sub Ball", 3},
            {25, "Dream Ball", 5},
            {13, "Scuro Ball", 4},
            {17, "Rapid Ball", 4},
            {22, "Friend Ball", 4},
            {14, "Cura Ball", 4},
            {20, "Peso Ball", 4},
            {18, "Level Ball", 4},
            {21, "Love Ball", 4},
            {19, "Esca Ball", 4},
            {11, "Chic Ball", 3},
            {1, "Master Ball", 3},
            {23, "Luna Ball", 4},
            {8, "Minor  Ball", 3},
            {6, "Rete Ball", 3},
            {12, "Premier Ball", 3},
            {15, "Velox Ball", 4},
            {9, "Bis Ball", 3},
            {5, "Safari Ball", 3},
            {24, "Gara Ball", 4},
            {10, "Timer Ball", 3}
        };
    }

    namespace English {
        static const char *allMoves[728] = {
            "Pound",
            "Karate Chop",
            "Double Slap",
            "Comet Punch",
            "Mega Punch",
            "Pay Day",
            "Fire Punch",
            "Ice Punch",
            "Thunder Punch",
            "Scratch",
            "Vise Grip",
            "Guillotine",
            "Razor Wind",
            "Swords Dance",
            "Cut",
            "Gust",
            "Wing Attack",
            "Whirlwind",
            "Fly",
            "Bind",
            "Slam",
            "Vine Whip",
            "Stomp",
            "Double Kick",
            "Mega Kick",
            "Jump Kick",
            "Rolling Kick",
            "Sand Attack",
            "Headbutt",
            "Horn Attack",
            "Fury Attack",
            "Horn Drill",
            "Tackle",
            "Body Slam",
            "Wrap",
            "Take Down",
            "Thrash",
            "Double-Edge",
            "Tail Whip",
            "Poison Sting",
            "Twineedle",
            "Pin Missile",
            "Leer",
            "Bite",
            "Growl",
            "Roar",
            "Sing",
            "Supersonic",
            "Sonic Boom",
            "Disable",
            "Acid",
            "Ember",
            "Flamethrower",
            "Mist",
            "Water Gun",
            "Hydro Pump",
            "Surf",
            "Ice Beam",
            "Blizzard",
            "Psybeam",
            "Bubble Beam",
            "Aurora Beam",
            "Hyper Beam",
            "Peck",
            "Drill Peck",
            "Submission",
            "Low Kick",
            "Counter",
            "Seismic Toss",
            "Strength",
            "Absorb",
            "Mega Drain",
            "Leech Seed",
            "Growth",
            "Razor Leaf",
            "Solar Beam",
            "Poison Powder",
            "Stun Spore",
            "Sleep Powder",
            "Petal Dance",
            "String Shot",
            "Dragon Rage",
            "Fire Spin",
            "Thunder Shock",
            "Thunderbolt",
            "Thunder Wave",
            "Thunder",
            "Rock Throw",
            "Earthquake",
            "Fissure",
            "Dig",
            "Toxic",
            "Confusion",
            "Psychic",
            "Hypnosis",
            "Meditate",
            "Agility",
            "Quick Attack",
            "Rage",
            "Teleport",
            "Night Shade",
            "Mimic",
            "Screech",
            "Double Team",
            "Recover",
            "Harden",
            "Minimize",
            "Smokescreen",
            "Confuse Ray",
            "Withdraw",
            "Defense Curl",
            "Barrier",
            "Light Screen",
            "Haze",
            "Reflect",
            "Focus Energy",
            "Bide",
            "Metronome",
            "Mirror Move",
            "Self-Destruct",
            "Egg Bomb",
            "Lick",
            "Smog",
            "Sludge",
            "Bone Club",
            "Fire Blast",
            "Waterfall",
            "Clamp",
            "Swift",
            "Skull Bash",
            "Spike Cannon",
            "Constrict",
            "Amnesia",
            "Kinesis",
            "Soft-Boiled",
            "High Jump Kick",
            "Glare",
            "Dream Eater",
            "Poison Gas",
            "Barrage",
            "Leech Life",
            "Lovely Kiss",
            "Sky Attack",
            "Transform",
            "Bubble",
            "Dizzy Punch",
            "Spore",
            "Flash",
            "Psywave",
            "Splash",
            "Acid Armor",
            "Crabhammer",
            "Explosion",
            "Fury Swipes",
            "Bonemerang",
            "Rest",
            "Rock Slide",
            "Hyper Fang",
            "Sharpen",
            "Conversion",
            "Tri Attack",
            "Super Fang",
            "Slash",
            "Substitute",
            "Struggle",
            "Sketch",
            "Triple Kick",
            "Thief",
            "Spider Web",
            "Mind Reader",
            "Nightmare",
            "Flame Wheel",
            "Snore",
            "Curse",
            "Flail",
            "Conversion 2",
            "Aeroblast",
            "Cotton Spore",
            "Reversal",
            "Spite",
            "Powder Snow",
            "Protect",
            "Mach Punch",
            "Scary Face",
            "Feint Attack",
            "Sweet Kiss",
            "Belly Drum",
            "Sludge Bomb",
            "Mud-Slap",
            "Octazooka",
            "Spikes",
            "Zap Cannon",
            "Foresight",
            "Destiny Bond",
            "Perish Song",
            "Icy Wind",
            "Detect",
            "Bone Rush",
            "Lock-On",
            "Outrage",
            "Sandstorm",
            "Giga Drain",
            "Endure",
            "Charm",
            "Rollout",
            "False Swipe",
            "Swagger",
            "Milk Drink",
            "Spark",
            "Fury Cutter",
            "Steel Wing",
            "Mean Look",
            "Attract",
            "Sleep Talk",
            "Heal Bell",
            "Return",
            "Present",
            "Frustration",
            "Safeguard",
            "Pain Split",
            "Sacred Fire",
            "Magnitude",
            "Dynamic Punch",
            "Megahorn",
            "Dragon Breath",
            "Baton Pass",
            "Encore",
            "Pursuit",
            "Rapid Spin",
            "Sweet Scent",
            "Iron Tail",
            "Metal Claw",
            "Vital Throw",
            "Morning Sun",
            "Synthesis",
            "Moonlight",
            "Hidden Power",
            "Cross Chop",
            "Twister",
            "Rain Dance",
            "Sunny Day",
            "Crunch",
            "Mirror Coat",
            "Psych Up",
            "Extreme Speed",
            "Ancient Power",
            "Shadow Ball",
            "Future Sight",
            "Rock Smash",
            "Whirlpool",
            "Beat Up",
            "Fake Out",
            "Uproar",
            "Stockpile",
            "Spit Up",
            "Swallow",
            "Heat Wave",
            "Hail",
            "Torment",
            "Flatter",
            "Will-O-Wisp",
            "Memento",
            "Facade",
            "Focus Punch",
            "Smelling Salts",
            "Follow Me",
            "Nature Power",
            "Charge",
            "Taunt",
            "Helping Hand",
            "Trick",
            "Role Play",
            "Wish",
            "Assist",
            "Ingrain",
            "Superpower",
            "Magic Coat",
            "Recycle",
            "Revenge",
            "Brick Break",
            "Yawn",
            "Knock Off",
            "Endeavor",
            "Eruption",
            "Skill Swap",
            "Imprison",
            "Refresh",
            "Grudge",
            "Snatch",
            "Secret Power",
            "Dive",
            "Arm Thrust",
            "Camouflage",
            "Tail Glow",
            "Luster Purge",
            "Mist Ball",
            "Feather Dance",
            "Teeter Dance",
            "Blaze Kick",
            "Mud Sport",
            "Ice Ball",
            "Needle Arm",
            "Slack Off",
            "Hyper Voice",
            "Poison Fang",
            "Crush Claw",
            "Blast Burn",
            "Hydro Cannon",
            "Meteor Mash",
            "Astonish",
            "Weather Ball",
            "Aromatherapy",
            "Fake Tears",
            "Air Cutter",
            "Overheat",
            "Odor Sleuth",
            "Rock Tomb",
            "Silver Wind",
            "Metal Sound",
            "Grass Whistle",
            "Tickle",
            "Cosmic Power",
            "Water Spout",
            "Signal Beam",
            "Shadow Punch",
            "Extrasensory",
            "Sky Uppercut",
            "Sand Tomb",
            "Sheer Cold",
            "Muddy Water",
            "Bullet Seed",
            "Aerial Ace",
            "Icicle Spear",
            "Iron Defense",
            "Block",
            "Howl",
            "Dragon Claw",
            "Frenzy Plant",
            "Bulk Up",
            "Bounce",
            "Mud Shot",
            "Poison Tail",
            "Covet",
            "Volt Tackle",
            "Magical Leaf",
            "Water Sport",
            "Calm Mind",
            "Leaf Blade",
            "Dragon Dance",
            "Rock Blast",
            "Shock Wave",
            "Water Pulse",
            "Doom Desire",
            "Psycho Boost",
            "Roost",
            "Gravity",
            "Miracle Eye",
            "Wake-Up Slap",
            "Hammer Arm",
            "Gyro Ball",
            "Healing Wish",
            "Brine",
            "Natural Gift",
            "Feint",
            "Pluck",
            "Tailwind",
            "Acupressure",
            "Metal Burst",
            "U-turn",
            "Close Combat",
            "Payback",
            "Assurance",
            "Embargo",
            "Fling",
            "Psycho Shift",
            "Trump Card",
            "Heal Block",
            "Wring Out",
            "Power Trick",
            "Gastro Acid",
            "Lucky Chant",
            "Me First",
            "Copycat",
            "Power Swap",
            "Guard Swap",
            "Punishment",
            "Last Resort",
            "Worry Seed",
            "Sucker Punch",
            "Toxic Spikes",
            "Heart Swap",
            "Aqua Ring",
            "Magnet Rise",
            "Flare Blitz",
            "Force Palm",
            "Aura Sphere",
            "Rock Polish",
            "Poison Jab",
            "Dark Pulse",
            "Night Slash",
            "Aqua Tail",
            "Seed Bomb",
            "Air Slash",
            "X-Scissor",
            "Bug Buzz",
            "Dragon Pulse",
            "Dragon Rush",
            "Power Gem",
            "Drain Punch",
            "Vacuum Wave",
            "Focus Blast",
            "Energy Ball",
            "Brave Bird",
            "Earth Power",
            "Switcheroo",
            "Giga Impact",
            "Nasty Plot",
            "Bullet Punch",
            "Avalanche",
            "Ice Shard",
            "Shadow Claw",
            "Thunder Fang",
            "Ice Fang",
            "Fire Fang",
            "Shadow Sneak",
            "Mud Bomb",
            "Psycho Cut",
            "Zen Headbutt",
            "Mirror Shot",
            "Flash Cannon",
            "Rock Climb",
            "Defog",
            "Trick Room",
            "Draco Meteor",
            "Discharge",
            "Lava Plume",
            "Leaf Storm",
            "Power Whip",
            "Rock Wrecker",
            "Cross Poison",
            "Gunk Shot",
            "Iron Head",
            "Magnet Bomb",
            "Stone Edge",
            "Captivate",
            "Stealth Rock",
            "Grass Knot",
            "Chatter",
            "Judgment",
            "Bug Bite",
            "Charge Beam",
            "Wood Hammer",
            "Aqua Jet",
            "Attack Order",
            "Defend Order",
            "Heal Order",
            "Head Smash",
            "Double Hit",
            "Roar of Time",
            "Spacial Rend",
            "Lunar Dance",
            "Crush Grip",
            "Magma Storm",
            "Dark Void",
            "Seed Flare",
            "Ominous Wind",
            "Shadow Force",
            "Hone Claws",
            "Wide Guard",
            "Guard Split",
            "Power Split",
            "Wonder Room",
            "Psyshock",
            "Venoshock",
            "Autotomize",
            "Rage Powder",
            "Telekinesis",
            "Magic Room",
            "Smack Down",
            "Storm Throw",
            "Flame Burst",
            "Sludge Wave",
            "Quiver Dance",
            "Heavy Slam",
            "Synchronoise",
            "Electro Ball",
            "Soak",
            "Flame Charge",
            "Coil",
            "Low Sweep",
            "Acid Spray",
            "Foul Play",
            "Simple Beam",
            "Entrainment",
            "After You",
            "Round",
            "Echoed Voice",
            "Chip Away",
            "Clear Smog",
            "Stored Power",
            "Quick Guard",
            "Ally Switch",
            "Scald",
            "Shell Smash",
            "Heal Pulse",
            "Hex",
            "Sky Drop",
            "Shift Gear",
            "Circle Throw",
            "Incinerate",
            "Quash",
            "Acrobatics",
            "Reflect Type",
            "Retaliate",
            "Final Gambit",
            "Bestow",
            "Inferno",
            "Water Pledge",
            "Fire Pledge",
            "Grass Pledge",
            "Volt Switch",
            "Struggle Bug",
            "Bulldoze",
            "Frost Breath",
            "Dragon Tail",
            "Work Up",
            "Electroweb",
            "Wild Charge",
            "Drill Run",
            "Dual Chop",
            "Heart Stamp",
            "Horn Leech",
            "Sacred Sword",
            "Razor Shell",
            "Heat Crash",
            "Leaf Tornado",
            "Steamroller",
            "Cotton Guard",
            "Night Daze",
            "Psystrike",
            "Tail Slap",
            "Hurricane",
            "Head Charge",
            "Gear Grind",
            "Searing Shot",
            "Techno Blast",
            "Relic Song",
            "Secret Sword",
            "Glaciate",
            "Bolt Strike",
            "Blue Flare",
            "Fiery Dance",
            "Freeze Shock",
            "Ice Burn",
            "Snarl",
            "Icicle Crash",
            "V-create",
            "Fusion Flare",
            "Fusion Bolt",
            "Flying Press",
            "Mat Block",
            "Belch",
            "Rototiller",
            "Sticky Web",
            "Fell Stinger",
            "Phantom Force",
            "Trick-or-Treat",
            "Noble Roar",
            "Ion Deluge",
            "Parabolic Charge",
            "Forest's Curse",
            "Petal Blizzard",
            "Freeze-Dry",
            "Disarming Voice",
            "Parting Shot",
            "Topsy-Turvy",
            "Draining Kiss",
            "Crafty Shield",
            "Flower Shield",
            "Grassy Terrain",
            "Misty Terrain",
            "Electrify",
            "Play Rough",
            "Fairy Wind",
            "Moonblast",
            "Boomburst",
            "Fairy Lock",
            "King's Shield",
            "Play Nice",
            "Confide",
            "Diamond Storm",
            "Steam Eruption",
            "Hyperspace Hole",
            "Water Shuriken",
            "Mystical Fire",
            "Spiky Shield",
            "Aromatic Mist",
            "Eerie Impulse",
            "Venom Drench",
            "Powder",
            "Geomancy",
            "Magnetic Flux",
            "Happy Hour",
            "Electric Terrain",
            "Dazzling Gleam",
            "Celebrate",
            "Hold Hands",
            "Baby-Doll Eyes",
            "Nuzzle",
            "Hold Back",
            "Infestation",
            "Power-Up Punch",
            "Oblivion Wing",
            "Thousand Arrows",
            "Thousand Waves",
            "Land's Wrath",
            "Light of Ruin",
            "Origin Pulse",
            "Precipice Blades",
            "Dragon Ascent",
            "Hyperspace Fury",
            "Breakneck Blitz P",
            "Breakneck Blitz S",
            "All Out Pummeling P",
            "All Out Pummeling S",
            "Supersonic Skystrike P",
            "Supersonic Skystrike S",
            "Acid Downpour P",
            "Acid Downpour S",
            "Tectonic Rage P",
            "Tectonic Rage S",
            "Continental Crush P",
            "Continental Crush S",
            "Savage Spin Out P",
            "Savage Spin Out S",
            "Never Ending Nightmare P",
            "Never Ending Nightmare S",
            "Corkscrew Crash P",
            "Corkscrew Crash S",
            "Inferno Overdrive P",
            "Inferno Overdrive S",
            "Hydro Vortex P",
            "Hydro Vortex S",
            "Bloom Doom P",
            "Bloom Doom S",
            "Gigavolt Havoc P",
            "Gigavolt Havoc S",
            "Shattered Psyche P",
            "Shattered Psyche S",
            "Subzero Slammer P",
            "Subzero Slammer S",
            "Devastating Drake P",
            "Devastating Drake S",
            "Black Hole Eclipse P",
            "Black Hole Eclipse S",
            "Twinkle Tackle P",
            "Twinkle Tackle S",
            "Catastropika",
            "Shore Up",
            "First Impression",
            "Baneful Bunker",
            "Spirit Shackle",
            "Darkest Lariat",
            "Sparkling Aria",
            "Ice Hammer",
            "Floral Healing",
            "High Horsepower",
            "Strength Sap",
            "Solar Blade",
            "Leafage",
            "Spotlight",
            "Toxic Thread",
            "Laser Focus",
            "Gear Up",
            "Throat Chop",
            "Pollen Puff",
            "Anchor Shot",
            "Psychic Terrain",
            "Lunge",
            "Fire Lash",
            "Power Trip",
            "Burn Up",
            "Speed Swap",
            "Smart Strike",
            "Purify",
            "Revelation Dance",
            "Core Enforcer",
            "Trop Kick",
            "Instruct",
            "Beak Blast",
            "Clanging Scales",
            "Dragon Hammer",
            "Brutal Swing",
            "Aurora Veil",
            "Sinister Arrow Raid",
            "Malicious Moonsault",
            "Oceanic Operetta",
            "Guardian of Alola",
            "Soul Stealing 7 Star Strike",
            "Stoked Sparksurfer",
            "Pulverizing Pancake",
            "Extreme Evoboost",
            "Genesis Supernova",
            "Shell Trap",
            "Fleur Cannon",
            "Psychic Fangs",
            "Stomping Tantrum",
            "Shadow Bone",
            "Accelerock",
            "Liquidation",
            "Prismatic Laser",
            "Spectral Thief",
            "Sunsteel Strike",
            "Moongeist Beam",
            "Tearful Look",
            "Zing Zap",
            "Natures Madness",
            "Multi Attack",
            "Ten M Volt Thunderbolt",
            "Mind Blown",
            "Plasma Fists",
            "Photon Geyser",
            "Light That Burns the Sky",
            "Searing Sunraze Smash",
            "Menacing Moonraze Maelstrom",
            "Lets Snuggle Forever",
            "Splintered Stormshards",
            "Clangorous Soulblaze"
        };
    }

    namespace French {
        static const char *allMoves[728] = {
            "Écras’Face",
            "Poing Karaté",
            "Torgnoles",
            "Poing Comète",
            "Ultimapoing",
            "Jackpot",
            "Poing Feu",
            "Poing Glace",
            "Poing Éclair",
            "Griffe",
            "Force Poigne",
            "Guillotine",
            "Coupe-Vent",
            "Danse Lames",
            "Coupe",
            "Tornade",
            "Cru-Ailes",
            "Cyclone",
            "Vol",
            "Étreinte",
            "Souplesse",
            "Fouet Lianes",
            "Écrasement",
            "Double Pied",
            "Ultimawashi",
            "Pied Sauté",
            "Mawashi Geri",
            "Jet de Sable",
            "Coup d’Boule",
            "Koud’Korne",
            "Furie",
            "Empal’Korne",
            "Charge",
            "Plaquage",
            "Ligotage",
            "Bélier",
            "Mania",
            "Damoclès",
            "Mimi-Queue",
            "Dard-Venin",
            "Double Dard",
            "Dard-Nuée",
            "Groz’Yeux",
            "Morsure",
            "Rugissement",
            "Hurlement",
            "Berceuse",
            "Ultrason",
            "Sonic Boom",
            "Entrave",
            "Acide",
            "Flammèche",
            "Lance-Flammes",
            "Brume",
            "Pistolet à O",
            "Hydrocanon",
            "Surf",
            "Laser Glace",
            "Blizzard",
            "Rafale Psy",
            "Bulles d’O",
            "Onde Boréale",
            "Ultralaser",
            "Picpic",
            "Bec Vrille",
            "Sacrifice",
            "Balayage",
            "Riposte",
            "Frappe Atlas",
            "Force",
            "Vole-Vie",
            "Méga-Sangsue",
            "Vampigraine",
            "Croissance",
            "Tranch’Herbe",
            "Lance-Soleil",
            "Poudre Toxik",
            "Para-Spore",
            "Poudre Dodo",
            "Danse Fleurs",
            "Sécrétion",
            "Draco-Rage",
            "Danse Flammes",
            "Éclair",
            "Tonnerre",
            "Cage Éclair",
            "Fatal-Foudre",
            "Jet-Pierres",
            "Séisme",
            "Abîme",
            "Tunnel",
            "Toxik",
            "Choc Mental",
            "Psyko",
            "Hypnose",
            "Yoga",
            "Hâte",
            "Vive-Attaque",
            "Frénésie",
            "Téléport",
            "Ombre Nocturne",
            "Copie",
            "Grincement",
            "Reflet",
            "Soin",
            "Armure",
            "Lilliput",
            "Brouillard",
            "Onde Folie",
            "Repli",
            "Boul’Armure",
            "Bouclier",
            "Mur Lumière",
            "Buée Noire",
            "Protection",
            "Puissance",
            "Patience",
            "Métronome",
            "Mimique",
            "Destruction",
            "Bombe Œuf",
            "Léchouille",
            "Purédpois",
            "Détritus",
            "Massd’Os",
            "Déflagration",
            "Cascade",
            "Claquoir",
            "Météores",
            "Coud’Krâne",
            "Picanon",
            "Constriction",
            "Amnésie",
            "Télékinésie",
            "E-Coque",
            "Pied Voltige",
            "Regard Médusant",
            "Dévorêve",
            "Gaz Toxik",
            "Pilonnage",
            "Vampirisme",
            "Grobisou",
            "Piqué",
            "Morphing",
            "Écume",
            "Uppercut",
            "Spore",
            "Flash",
            "Vague Psy",
            "Trempette",
            "Acidarmure",
            "Pince-Masse",
            "Explosion",
            "Combo-Griffe",
            "Osmerang",
            "Repos",
            "Éboulement",
            "Croc de Mort",
            "Affûtage",
            "Conversion",
            "Triplattaque",
            "Croc Fatal",
            "Tranche",
            "Clonage",
            "Lutte",
            "Gribouille",
            "Triple Pied",
            "Larcin",
            "Toile",
            "Lire-Esprit",
            "Cauchemar",
            "Roue de Feu",
            "Ronflement",
            "Malédiction",
            "Gigotage",
            "Conversion 2",
            "Aéroblast",
            "Spore Coton",
            "Contre",
            "Dépit",
            "Poudreuse",
            "Abri",
            "Mach Punch",
            "Grimace",
            "Feinte",
            "Doux Baiser",
            "Cognobidon",
            "Bombe Beurk",
            "Coud’Boue",
            "Octazooka",
            "Picots",
            "Élecanon",
            "Clairvoyance",
            "Lien du Destin",
            "Requiem",
            "Vent Glace",
            "Détection",
            "Charge Os",
            "Verrouillage",
            "Colère",
            "Tempête de Sable",
            "Giga-Sangsue",
            "Ténacité",
            "Charme",
            "Roulade",
            "Faux-Chage",
            "Vantardise",
            "Lait à Boire",
            "Étincelle",
            "Taillade",
            "Ailes d’Acier",
            "Regard Noir",
            "Attraction",
            "Blabla Dodo",
            "Glas de Soin",
            "Retour",
            "Cadeau",
            "Frustration",
            "Rune Protect",
            "Balance",
            "Feu Sacré",
            "Ampleur",
            "Dynamo-Poing",
            "Mégacorne",
            "Draco-Souffle",
            "Relais",
            "Encore",
            "Poursuite",
            "Tour Rapide",
            "Doux Parfum",
            "Queue de Fer",
            "Griffe Acier",
            "Corps Perdu",
            "Aurore",
            "Synthèse",
            "Rayon Lune",
            "Puissance Cachée",
            "Coup Croix",
            "Ouragan",
            "Danse Pluie",
            "Zénith",
            "Mâchouille",
            "Voile Miroir",
            "Boost",
            "Vitesse Extrême",
            "Pouvoir Antique",
            "Ball’Ombre",
            "Prescience",
            "Éclate-Roc",
            "Siphon",
            "Baston",
            "Bluff",
            "Brouhaha",
            "Stockage",
            "Relâche",
            "Avale",
            "Canicule",
            "Grêle",
            "Tourmente",
            "Flatterie",
            "Feu Follet",
            "Souvenir",
            "Façade",
            "Mitra-Poing",
            "Stimulant",
            "Par Ici",
            "Force Nature",
            "Chargeur",
            "Provoc",
            "Coup d’Main",
            "Tour de Magie",
            "Imitation",
            "Vœu",
            "Assistance",
            "Racines",
            "Surpuissance",
            "Reflet Magik",
            "Recyclage",
            "Vendetta",
            "Casse-Brique",
            "Bâillement",
            "Sabotage",
            "Effort",
            "Éruption",
            "Échange",
            "Possessif",
            "Régénération",
            "Rancune",
            "Saisie",
            "Force Cachée",
            "Plongée",
            "Cogne",
            "Camouflage",
            "Lumi-Queue",
            "Lumi-Éclat",
            "Ball’Brume",
            "Danse Plumes",
            "Danse Folle",
            "Pied Brûleur",
            "Lance-Boue",
            "Ball’Glace",
            "Poing Dard",
            "Paresse",
            "Mégaphone",
            "Crochet Venin",
            "Éclate Griffe",
            "Rafale Feu",
            "Hydroblast",
            "Poing Météore",
            "Étonnement",
            "Ball’Météo",
            "Aromathérapie",
            "Croco Larme",
            "Tranch’Air",
            "Surchauffe",
            "Flair",
            "Tomberoche",
            "Vent Argenté",
            "Strido-Son",
            "Siffl’Herbe",
            "Chatouille",
            "Force Cosmique",
            "Giclédo",
            "Rayon Signal",
            "Poing Ombre",
            "Extrasenseur",
            "Stratopercut",
            "Tourbi-Sable",
            "Glaciation",
            "Ocroupi",
            "Balle Graine",
            "Aéropique",
            "Stalactite",
            "Mur de Fer",
            "Barrage",
            "Grondement",
            "Draco-Griffe",
            "Végé-Attaque",
            "Gonflette",
            "Rebond",
            "Tir de Boue",
            "Queue-Poison",
            "Implore",
            "Électacle",
            "Feuille Magik",
            "Tourniquet",
            "Plénitude",
            "Lame Feuille",
            "Danse Draco",
            "Boule Roc",
            "Onde de Choc",
            "Vibraqua",
            "Vœu Destructeur",
            "Psycho-Boost",
            "Atterrissage",
            "Gravité",
            "Œil Miracle",
            "Réveil Forcé",
            "Marto-Poing",
            "Gyroballe",
            "Vœu Soin",
            "Saumure",
            "Don Naturel",
            "Ruse",
            "Picore",
            "Vent Arrière",
            "Acupression",
            "Fulmifer",
            "Demi-Tour",
            "Close Combat",
            "Représailles",
            "Assurance",
            "Embargo",
            "Dégommage",
            "Échange Psy",
            "Atout",
            "Anti-Soin",
            "Essorage",
            "Astuce Force",
            "Suc Digestif",
            "Air Veinard",
            "Moi d’Abord",
            "Photocopie",
            "Permuforce",
            "Permugarde",
            "Punition",
            "Dernier Recours",
            "Soucigraine",
            "Coup Bas",
            "Pics Toxik",
            "Permucœur",
            "Anneau Hydro",
            "Vol Magnétik",
            "Boutefeu",
            "Forte-Paume",
            "Aurasphère",
            "Poliroche",
            "Direct Toxik",
            "Vibrobscur",
            "Tranche-Nuit",
            "Hydro-Queue",
            "Canon Graine",
            "Lame d’Air",
            "Plaie Croix",
            "Bourdon",
            "Draco-Choc",
            "Draco-Charge",
            "Rayon Gemme",
            "Vampi-Poing",
            "Onde Vide",
            "Exploforce",
            "Éco-Sphère",
            "Rapace",
            "Telluriforce",
            "Passe-Passe",
            "Giga Impact",
            "Machination",
            "Pisto-Poing",
            "Avalanche",
            "Éclats Glace",
            "Griffe Ombre",
            "Crocs Éclair",
            "Crocs Givre",
            "Crocs Feu",
            "Ombre Portée",
            "Boue-Bombe",
            "Coupe Psycho",
            "Psykoud’Boul",
            "Miroi-Tir",
            "Luminocanon",
            "Escalade",
            "Anti-Brume",
            "Distorsion",
            "Draco-Météore",
            "Coup d’Jus",
            "Ébullilave",
            "Tempête Verte",
            "Mégafouet",
            "Roc-Boulet",
            "Poison Croix",
            "Détricanon",
            "Tête de Fer",
            "Bombe Aimant",
            "Lame de Roc",
            "Séduction",
            "Piège de Roc",
            "Nœud Herbe",
            "Babil",
            "Jugement",
            "Piqûre",
            "Rayon Chargé",
            "Martobois",
            "Aqua-Jet",
            "Appel Attaque",
            "Appel Défense",
            "Appel Soins",
            "Fracass’Tête",
            "Coup Double",
            "Hurle-Temps",
            "Spatio-Rift",
            "Danse Lune",
            "Presse",
            "Vortex Magma",
            "Trou Noir",
            "Fulmigraine",
            "Vent Mauvais",
            "Revenant",
            "Aiguisage",
            "Garde Large",
            "Partage Garde",
            "Partage Force",
            "Zone Étrange",
            "Choc Psy",
            "Choc Venin",
            "Allègement",
            "Poudre Fureur",
            "Lévikinésie",
            "Zone Magique",
            "Anti-Air",
            "Yama Arashi",
            "Rebondifeu",
            "Cradovague",
            "Papillodanse",
            "Tacle Lourd",
            "Synchropeine",
            "Boule Élek",
            "Détrempage",
            "Nitrocharge",
            "Enroulement",
            "Balayette",
            "Bombe Acide",
            "Tricherie",
            "Rayon Simple",
            "Ten-Danse",
            "Après Vous",
            "Chant Canon",
            "Écho",
            "Attrition",
            "Bain de Smog",
            "Force Ajoutée",
            "Prévention",
            "Interversion",
            "Ébullition",
            "Exuviation",
            "Vibra Soin",
            "Châtiment",
            "Chute Libre",
            "Change-Vitesse",
            "Projection",
            "Calcination",
            "À la Queue",
            "Acrobatie",
            "Copie-Type",
            "Vengeance",
            "Tout ou Rien",
            "Passe-Cadeau",
            "Feu d’Enfer",
            "Aire d’Eau",
            "Aire de Feu",
            "Aire d’Herbe",
            "Change-Éclair",
            "Survinsecte",
            "Piétisol",
            "Souffle Glacé",
            "Draco-Queue",
            "Rengorgement",
            "Toile Élek",
            "Éclair Fou",
            "Tunnelier",
            "Double Baffe",
            "Crève-Cœur",
            "Encornebois",
            "Lame Sainte",
            "Coqui-Lame",
            "Tacle Feu",
            "Phytomixeur",
            "Bulldoboule",
            "Cotogarde",
            "Explonuit",
            "Frappe Psy",
            "Plumo-Queue",
            "Vent Violent",
            "Peignée",
            "Lancécrou",
            "Incendie",
            "Techno-Buster",
            "Chant Antique",
            "Lame Ointe",
            "Ère Glaciaire",
            "Charge Foudre",
            "Flamme Bleue",
            "Danse du Feu",
            "Éclair Gelé",
            "Feu Glacé",
            "Aboiement",
            "Chute Glace",
            "Coup Victoire",
            "Flamme Croix",
            "Éclair Croix",
            "Flying Press",
            "Tatamigaeshi",
            "Éructation",
            "Fertilisation",
            "Toile Gluante",
            "Dard Mortel",
            "Hantise",
            "Halloween",
            "Râle Mâle",
            "Déluge Plasmique",
            "Parabocharge",
            "Maléfice Sylvain",
            "Tempête Florale",
            "Lyophilisation",
            "Voix Enjôleuse",
            "Dernier Mot",
            "Renversement",
            "Vampibaiser",
            "Vigilance",
            "Garde Florale",
            "Champ Herbu",
            "Champ Brumeux",
            "Électrisation",
            "Câlinerie",
            "Vent Féérique",
            "Pouvoir Lunaire",
            "Bang Sonique",
            "Verrou Enchanté",
            "Bouclier Royal",
            "Camaraderie",
            "Confidence",
            "Orage Adamantin",
            "Jet de Vapeur",
            "TrouDimensionnel",
            "Sheauriken",
            "Feu Ensorcelé",
            "Pico-Défense",
            "Brume Capiteuse",
            "Ondes Étranges",
            "Piège de Venin",
            "Nuée de Poudre",
            "Géo-Contrôle",
            "Magné-Contrôle",
            "Étrennes",
            "Champ Électrifié",
            "Éclat Magique",
            "Célébration",
            "Mains Jointes",
            "Regard Touchant",
            "Frotte-Frimousse",
            "Retenue",
            "Harcèlement",
            "Poing Boost",
            "Mort’Ailes",
            "Myria-Flèches",
            "Myria-Vagues",
            "Force Chtonienne",
            "Lumière du Néant",
            "Onde Originelle",
            "Lame Pangéenne",
            "Draco-Ascension",
            "Furie Dimension",
            "Turbo-Charge Bulldozer",
            "Turbo-Charge Bulldozer",
            "Combo Hyper-Furie",
            "Combo Hyper-Furie",
            "Piqué Supersonique",
            "Piqué Supersonique",
            "Déluge Causti-Toxique",
            "Déluge Causti-Toxique",
            "Éruption Géo-Sismique",
            "Éruption Géo-Sismique",
            "Apocalypse Gigalithique",
            "Apocalypse Gigalithique",
            "Cocon Fatal",
            "Cocon Fatal",
            "Appel des Ombres Éternelles",
            "Appel des Ombres Éternelles",
            "Vrille Maximum",
            "Vrille Maximum",
            "Pyro-Explosion Cataclysmique",
            "Pyro-Explosion Cataclysmique",
            "Super Tourbillon Abyssal",
            "Super Tourbillon Abyssal",
            "Pétalexplosion Éblouissante",
            "Pétalexplosion Éblouissante",
            "Fulguro-Lance Gigavolt",
            "Fulguro-Lance Gigavolt",
            "Psycho-Pulvérisation EX",
            "Psycho-Pulvérisation EX",
            "Laser Cryogénique",
            "Laser Cryogénique",
            "Chaos Draconique",
            "Chaos Draconique",
            "Trou Noir des Ombres",
            "Trou Noir des Ombres",
            "Impact Choupinova",
            "Impact Choupinova",
            "Pikachute Foudroyante",
            "Amass’Sable",
            "Escarmouche",
            "Blockhaus",
            "Tisse Ombre",
            "Dark Lariat",
            "Aria de l’Écume",
            "Marteau de Glace",
            "Soin Floral",
            "Cavalerie Lourde",
            "Vole-Force",
            "Lame Solaire",
            "Feuillage",
            "Projecteur",
            "Fil Toxique",
            "Affilage",
            "Engrenage",
            "Exécu-Son",
            "Boule Pollen",
            "Ancrage",
            "Champ Psychique",
            "Furie-Bond",
            "Fouet de Feu",
            "Arrogance",
            "Flamme Ultime",
            "Permuvitesse",
            "Estocorne",
            "Purification",
            "Danse Éveil",
            "Sanction Suprême",
            "Botte Sucrette",
            "Sommation",
            "Bec-Canon",
            "Vibrécaille",
            "Draco-Marteau",
            "Centrifugifle",
            "Voile Aurore",
            "Fureur des Plumes Spectrales",
            "Dark Body Press",
            "Symphonie des Ondines",
            "Colère du Gardien d’Alola",
            "Fauche-Âme des Sept Étoiles",
            "Électro-Surf Survolté",
            "Gare au Ronflex",
            "Neuf pour Un",
            "Supernova Originelle",
            "Carapiège",
            "Canon Floral",
            "Psycho-Croc",
            "Trépignement",
            "Os Ombre",
            "Vif Roc",
            "Aqua-Brèche",
            "Laser Prisme",
            "Clepto-Mânes",
            "Choc Météore",
            "Rayon Spectral",
            "Larme à l’Œil",
            "Électrikipik",
            "Ire de la Nature",
            "Coup Varia-Type",
            "Giga-Tonnerre",
            "Caboche-Kaboum",
            "Plasma Punch",
            "Photo-Geyser",
            "Apocalypsis Luminis",
            "Hélio-Choc Dévastateur",
            "Rayons Séléno-Explosifs",
            "Patati-Patattrape",
            "Hurlement des Roches-Lames",
            "Dracacophonie Flamboyante"
        };
    }

    namespace Italian {
        static const char *allMoves[728] = {
            "Botta",
            "Colpokarate",
            "Doppiasberla",
            "Cometapugno",
            "Megapugno",
            "Giornopaga",
            "Fuocopugno",
            "Gelopugno",
            "Tuonopugno",
            "Graffio",
            "Presa",
            "Ghigliottina",
            "Ventagliente",
            "Danzaspada",
            "Taglio",
            "Raffica",
            "Attacco d’Ala",
            "Turbine",
            "Volo",
            "Legatutto",
            "Schianto",
            "Frustata",
            "Pestone",
            "Doppiocalcio",
            "Megacalcio",
            "Calciosalto",
            "Calciorullo",
            "Turbosabbia",
            "Bottintesta",
            "Incornata",
            "Furia",
            "Perforcorno",
            "Azione",
            "Corposcontro",
            "Avvolgibotta",
            "Riduttore",
            "Colpo",
            "Sdoppiatore",
            "Colpocoda",
            "Velenospina",
            "Doppio Ago",
            "Missilspillo",
            "Fulmisguardo",
            "Morso",
            "Ruggito",
            "Boato",
            "Canto",
            "Supersuono",
            "Sonicboom",
            "Inibitore",
            "Acido",
            "Braciere",
            "Lanciafiamme",
            "Nebbia",
            "Pistolacqua",
            "Idropompa",
            "Surf",
            "Geloraggio",
            "Bora",
            "Psicoraggio",
            "Bollaraggio",
            "Raggiaurora",
            "Iper Raggio",
            "Beccata",
            "Perforbecco",
            "Sottomissione",
            "Colpo Basso",
            "Contrattacco",
            "Movim. Sismico",
            "Forza",
            "Assorbimento",
            "Megassorbimento",
            "Parassiseme",
            "Crescita",
            "Foglielama",
            "Solarraggio",
            "Velenpolvere",
            "Paralizzante",
            "Sonnifero",
            "Petalodanza",
            "Millebave",
            "Ira di Drago",
            "Turbofuoco",
            "Tuonoshock",
            "Fulmine",
            "Tuononda",
            "Tuono",
            "Sassata",
            "Terremoto",
            "Abisso",
            "Fossa",
            "Tossina",
            "Confusione",
            "Psichico",
            "Ipnosi",
            "Meditazione",
            "Agilità",
            "Attacco Rapido",
            "Ira",
            "Teletrasporto",
            "Ombra Notturna",
            "Mimica",
            "Stridio",
            "Doppioteam",
            "Ripresa",
            "Rafforzatore",
            "Minimizzato",
            "Muro di Fumo",
            "Stordiraggio",
            "Ritirata",
            "Ricciolscudo",
            "Barriera",
            "Schermoluce",
            "Nube",
            "Riflesso",
            "Focalenergia",
            "Pazienza",
            "Metronomo",
            "Speculmossa",
            "Autodistruzione",
            "Uovobomba",
            "Leccata",
            "Smog",
            "Fango",
            "Ossoclava",
            "Fuocobomba",
            "Cascata",
            "Tenaglia",
            "Comete",
            "Capocciata",
            "Sparalance",
            "Limitazione",
            "Amnesia",
            "Cinèsi",
            "Covauova",
            "Calcinvolo",
            "Sguardo Feroce",
            "Mangiasogni",
            "Velenogas",
            "Sferattacco",
            "Sanguisuga",
            "Demonbacio",
            "Aeroattacco",
            "Trasformazione",
            "Bolla",
            "Stordipugno",
            "Spora",
            "Flash",
            "Psiconda",
            "Splash",
            "Scudo Acido",
            "Martellata",
            "Esplosione",
            "Sfuriate",
            "Ossomerang",
            "Riposo",
            "Frana",
            "Iperzanna",
            "Affilatore",
            "Conversione",
            "Tripletta",
            "Superzanna",
            "Lacerazione",
            "Sostituto",
            "Scontro",
            "Schizzo",
            "Triplocalcio",
            "Furto",
            "Ragnatela",
            "Leggimente",
            "Incubo",
            "Ruotafuoco",
            "Russare",
            "Maledizione",
            "Flagello",
            "Conversione2",
            "Aerocolpo",
            "Cotonspora",
            "Contropiede",
            "Dispetto",
            "Polneve",
            "Protezione",
            "Pugnorapido",
            "Visotruce",
            "Finta",
            "Dolcebacio",
            "Panciamburo",
            "Fangobomba",
            "Fangosberla",
            "Octazooka",
            "Punte",
            "Elettrocannone",
            "Preveggenza",
            "Destinobbligato",
            "Ultimocanto",
            "Ventogelato",
            "Individua",
            "Ossoraffica",
            "Localizza",
            "Oltraggio",
            "Terrempesta",
            "Gigassorbimento",
            "Resistenza",
            "Fascino",
            "Rotolamento",
            "Falsofinale",
            "Bullo",
            "Buonlatte",
            "Scintilla",
            "Tagliofuria",
            "Alacciaio",
            "Malosguardo",
            "Attrazione",
            "Sonnolalia",
            "Rintoccasana",
            "Ritorno",
            "Regalino",
            "Frustrazione",
            "Salvaguardia",
            "Malcomune",
            "Magifuoco",
            "Magnitudo",
            "Dinamipugno",
            "Megacorno",
            "Dragospiro",
            "Staffetta",
            "Ripeti",
            "Inseguimento",
            "Rapigiro",
            "Profumino",
            "Codacciaio",
            "Ferrartigli",
            "Vitaltiro",
            "Mattindoro",
            "Sintesi",
            "Lucelunare",
            "Introforza",
            "Incrocolpo",
            "Tornado",
            "Pioggiadanza",
            "Giornodisole",
            "Sgranocchio",
            "Specchiovelo",
            "Psicamisù",
            "Extrarapido",
            "Forzantica",
            "Palla Ombra",
            "Divinazione",
            "Spaccaroccia",
            "Mulinello",
            "Picchiaduro",
            "Bruciapelo",
            "Baraonda",
            "Accumulo",
            "Sfoghenergia",
            "Introenergia",
            "Ondacalda",
            "Grandine",
            "Attaccalite",
            "Adulazione",
            "Fuocofatuo",
            "Memento",
            "Facciata",
            "Centripugno",
            "Maniereforti",
            "Sonoqui",
            "Naturforza",
            "Sottocarica",
            "Provocazione",
            "Altruismo",
            "Raggiro",
            "Giocodiruolo",
            "Desiderio",
            "Assistente",
            "Radicamento",
            "Troppoforte",
            "Magivelo",
            "Riciclo",
            "Vendetta",
            "Breccia",
            "Sbadiglio",
            "Privazione",
            "Rimonta",
            "Eruzione",
            "Baratto",
            "Esclusiva",
            "Rinfrescata",
            "Rancore",
            "Scippo",
            "Forzasegreta",
            "Sub",
            "Sberletese",
            "Camuffamento",
            "Codadiluce",
            "Abbagliante",
            "Foschisfera",
            "Danzadipiume",
            "Strampadanza",
            "Calciardente",
            "Fangata",
            "Palla Gelo",
            "Pugnospine",
            "Pigro",
            "Granvoce",
            "Velenodenti",
            "Tritartigli",
            "Incendio",
            "Idrocannone",
            "Meteorpugno",
            "Sgomento",
            "Palla Clima",
            "Aromaterapia",
            "Falselacrime",
            "Aerasoio",
            "Vampata",
            "Segugio",
            "Rocciotomba",
            "Ventargenteo",
            "Ferrostrido",
            "Meloderba",
            "Solletico",
            "Cosmoforza",
            "Zampillo",
            "Segnoraggio",
            "Pugnodombra",
            "Extrasenso",
            "Stramontante",
            "Sabbiotomba",
            "Purogelo",
            "Fanghiglia",
            "Semitraglia",
            "Aeroassalto",
            "Gelolancia",
            "Ferroscudo",
            "Blocco",
            "Gridodilotta",
            "Dragartigli",
            "Radicalbero",
            "Granfisico",
            "Rimbalzo",
            "Colpodifango",
            "Velenocoda",
            "Supplica",
            "Locomovolt",
            "Fogliamagica",
            "Docciascudo",
            "Calmamente",
            "Fendifoglia",
            "Dragodanza",
            "Cadutamassi",
            "Ondashock",
            "Idropulsar",
            "Desiderio Fatale",
            "Psicoslancio",
            "Trespolo",
            "Gravità",
            "Miracolvista",
            "Svegliopacca",
            "Martelpugno",
            "Vortexpalla",
            "Curardore",
            "Acquadisale",
            "Dononaturale",
            "Fintoattacco",
            "Spennata",
            "Ventoincoda",
            "Acupressione",
            "Metalscoppio",
            "Retromarcia",
            "Zuffa",
            "Rivincita",
            "Garanzia",
            "Divieto",
            "Lancio",
            "Psicotransfer",
            "Asso",
            "Anticura",
            "Strizzata",
            "Ingannoforza",
            "Gastroacido",
            "Fortuncanto",
            "Precedenza",
            "Copione",
            "Barattoforza",
            "Barattoscudo",
            "Punizione",
            "Ultimascelta",
            "Affannoseme",
            "Sbigoattacco",
            "Fielepunte",
            "Cuorbaratto",
            "Acquanello",
            "Magnetascesa",
            "Fuococarica",
            "Palmoforza",
            "Sferapulsar",
            "Lucidatura",
            "Velenpuntura",
            "Neropulsar",
            "Nottesferza",
            "Idrondata",
            "Semebomba",
            "Eterelama",
            "Forbice X",
            "Ronzio",
            "Dragopulsar",
            "Dragofuria",
            "Gemmoforza",
            "Assorbipugno",
            "Vuotonda",
            "Focalcolpo",
            "Energipalla",
            "Baldeali",
            "Geoforza",
            "Rapidscambio",
            "Gigaimpatto",
            "Congiura",
            "Pugnoscarica",
            "Slavina",
            "Geloscheggia",
            "Ombrartigli",
            "Fulmindenti",
            "Gelodenti",
            "Rogodenti",
            "Furtivombra",
            "Pantanobomba",
            "Psicotaglio",
            "Cozzata Zen",
            "Cristalcolpo",
            "Cannonflash",
            "Scalaroccia",
            "Scacciabruma",
            "Distortozona",
            "Dragobolide",
            "Scarica",
            "Lavasbuffo",
            "Verdebufera",
            "Vigorcolpo",
            "Devastomasso",
            "Velenocroce",
            "Sporcolancio",
            "Metaltestata",
            "Bombagnete",
            "Pietrataglio",
            "Incanto",
            "Levitoroccia",
            "Laccioerboso",
            "Schiamazzo",
            "Giudizio",
            "Coleomorso",
            "Raggioscossa",
            "Mazzuolegno",
            "Acquagetto",
            "Comandourto",
            "Comandoscudo",
            "Comandocura",
            "Zuccata",
            "Doppiosmash",
            "Fragortempo",
            "Fendispazio",
            "Lunardanza",
            "Sbriciolmano",
            "Magmaclisma",
            "Vuototetro",
            "Infuriaseme",
            "Funestovento",
            "Oscurotuffo",
            "Unghiaguzze",
            "Bodyguard",
            "Paridifesa",
            "Pariattacco",
            "Mirabilzona",
            "Psicoshock",
            "Velenoshock",
            "Sganciapesi",
            "Polverabbia",
            "Telecinesi",
            "Magicozona",
            "Abbattimento",
            "Tempestretta",
            "Pirolancio",
            "Fangonda",
            "Eledanza",
            "Pesobomba",
            "Sincrumore",
            "Energisfera",
            "Inondazione",
            "Nitrocarica",
            "Arrotola",
            "Calciobasso",
            "Acidobomba",
            "Ripicca",
            "Ondisinvolta",
            "Saltamicizia",
            "Cortesia",
            "Coro",
            "Echeggiavoce",
            "Insidia",
            "Pulifumo",
            "Veicolaforza",
            "Anticipo",
            "Cambiaposto",
            "Idrovampata",
            "Gettaguscio",
            "Curapulsar",
            "Sciagura",
            "Cadutalibera",
            "Cambiomarcia",
            "Ribaltiro",
            "Bruciatutto",
            "Spintone",
            "Acrobazia",
            "Riflettipo",
            "Nemesi",
            "Azzardo",
            "Cediregalo",
            "Marchiatura",
            "Acquapatto",
            "Fiammapatto",
            "Erbapatto",
            "Invertivolt",
            "Entomoblocco",
            "Battiterra",
            "Alitogelido",
            "Codadrago",
            "Cuordileone",
            "Elettrotela",
            "Sprizzalampo",
            "Giravvita",
            "Doppiocolpo",
            "Cuorestampo",
            "Legnicorno",
            "Spadasolenne",
            "Conchilama",
            "Marchiafuoco",
            "Vorticerba",
            "Rulloduro",
            "Cotonscudo",
            "Urtoscuro",
            "Psicobotta",
            "Spazzasberla",
            "Tifone",
            "Ricciolata",
            "Ingracolpo",
            "Sparafuoco",
            "Tecnobotto",
            "Cantoantico",
            "Spadamistica",
            "Gelamondo",
            "Lucesiluro",
            "Fuocoblu",
            "Voldifuoco",
            "Elettrogelo",
            "Vampagelida",
            "Urlorabbia",
            "Scagliagelo",
            "Generatore V",
            "Incrofiamma",
            "Incrotuono",
            "Schiacciatuffo",
            "Ribaltappeto",
            "Rutto",
            "Aracampo",
            "Rete Vischiosa",
            "Pungiglione",
            "Spettrotuffo",
            "Halloween",
            "Urlo",
            "Pioggiaplasma",
            "Caricaparabola",
            "Boscomalocchio",
            "Fiortempesta",
            "Liofilizzazione",
            "Incantavoce",
            "Monito",
            "Sottosopra",
            "Assorbibacio",
            "Truccodifesa",
            "Fiordifesa",
            "Campo Erboso",
            "Campo Nebbioso",
            "Elettrocontagio",
            "Carineria",
            "Vento di Fata",
            "Forza Lunare",
            "Ondaboato",
            "Blocco Fatato",
            "Scudo Reale",
            "Simpatia",
            "Confidenza",
            "Diamantempesta",
            "Vaporscoppio",
            "Forodimensionale",
            "Acqualame",
            "Magifiamma",
            "Agodifesa",
            "Nebularoma",
            "Elettromistero",
            "Velenotrappola",
            "Pulviscoppio",
            "Geocontrollo",
            "Controllo Polare",
            "Cuccagna",
            "Campo Elettrico",
            "Magibrillio",
            "Auguri",
            "Mano nella Mano",
            "Occhioni Teneri",
            "Elettrococcola",
            "Riguardo",
            "Assillo",
            "Crescipugno",
            "Ali del Fato",
            "Mille Frecce",
            "Mille Onde",
            "Forza Tellurica",
            "Luce Nefasta",
            "Primopulsar",
            "Spade Telluriche",
            "Ascesa del Drago",
            "Urtodimensionale",
            "Carica Travolgente",
            "Carica Travolgente",
            "Iperscarica Furiosa",
            "Iperscarica Furiosa",
            "Picchiata Devastante",
            "Picchiata Devastante",
            "Acidiluvio Corrosivo",
            "Acidiluvio Corrosivo",
            "Furore della Terra",
            "Furore della Terra",
            "Gigamacigno Polverizzante",
            "Gigamacigno Polverizzante",
            "Bozzolo Fatale",
            "Bozzolo Fatale",
            "Abbraccio Spettrale",
            "Abbraccio Spettrale",
            "Spirale Perforante",
            "Spirale Perforante",
            "Fiammobomba Detonante",
            "Fiammobomba Detonante",
            "Idrovortice Abissale",
            "Idrovortice Abissale",
            "Floriscoppio Sfolgorante",
            "Floriscoppio Sfolgorante",
            "Gigascarica Folgorante",
            "Gigascarica Folgorante",
            "Impatto Psicocinetico",
            "Impatto Psicocinetico",
            "Criodistruzione Polare",
            "Criodistruzione Polare",
            "Dragoschianto Finale",
            "Dragoschianto Finale",
            "Buco Nero del Non Ritorno",
            "Buco Nero del Non Ritorno",
            "Astroimpatto Fatato",
            "Astroimpatto Fatato",
            "Super Pikaboom",
            "Sabbiaccumulo",
            "Schermaglia",
            "Fortino",
            "Cucitura d’Ombra",
            "Braccioteso",
            "Canto Effimero",
            "Martelgelo",
            "Cura Floreale",
            "Forza Equina",
            "Assorbiforza",
            "Lama Solare",
            "Fogliame",
            "Riflettore",
            "Velenotela",
            "Concentrazione",
            "Marciainpiù",
            "Colpo Infernale",
            "Sferapolline",
            "Colpo d’Ancora",
            "Campo Psichico",
            "Assalto",
            "Frusta di Fuoco",
            "Tracotanza",
            "Ultima Fiamma",
            "Velociscambio",
            "Sottilcorno",
            "Purificazione",
            "Mutadanza",
            "Nucleocastigo",
            "Tropicalcio",
            "Imposizione",
            "Cannonbecco",
            "Clamorsquame",
            "Marteldrago",
            "Vorticolpo",
            "Velaurora",
            "Dardoassalto Spettrale",
            "Iperschianto delle Tenebre",
            "Sinfonia del Mare",
            "Collera del Guardiano",
            "Colpo Eptastellare Rubanima",
            "Elettrosurf Folgorante",
            "Adesso Faccio sul Serio",
            "Potenziamento Eevolutivo",
            "Supernova delle Origini",
            "Gusciotrappola",
            "Cannonfiore",
            "Psicozanna",
            "Battipiedi",
            "Ossotetro",
            "Rocciarapida",
            "Idrobreccia",
            "Prismalaser",
            "Ombrafurto",
            "Astrocarica",
            "Raggio d’Ombra",
            "Occhionilucidi",
            "Elettropizzico",
            "Ira della Natura",
            "Multiattacco",
            "Iperfulmine",
            "Sbalorditesta",
            "Pugni Plasma",
            "Geyser Fotonico",
            "Fotodistruzione Apocalittica",
            "Supercollisione Solare",
            "Deflagrazione Lunare",
            "Dolcesacco di Botte",
            "Litotempesta Radiale",
            "Dracofonia Divampante",
        };
    }

    extern int moveID;

    struct Moves {
        vector<string> name;
        vector<int> choiceNo;
    };

    void FindMoveKB(MenuEntry *entry);

    struct Ribbons {
        int category;
        const char *name;
        int index;
    };

    namespace English {
        static const Ribbons allRibbons[48] = {
            {0, "Champion Kalos", 0},
            {0, "Champion G3", 1},
            {0, "Champion Sinnoh", 2},
            {0, "Best Friends", 3},
            {0, "Training", 4},
            {0, "Battler Skillful", 5},
            {0, "Battler Expert", 6},
            {0, "Effort", 7},
            {1, "Alert", 0},
            {1, "Shock", 1},
            {1, "Downcast", 2},
            {1, "Careless", 3},
            {1, "Relax", 4},
            {1, "Snooze", 5},
            {1, "Smile", 6},
            {1, "Gorgeous", 7},
            {2, "Royal", 0},
            {2, "Gorgeous Royal", 1},
            {2, "Artist", 2},
            {2, "Footprint", 3},
            {2, "Record", 4},
            {2, "Legend", 5},
            {2, "Country", 6},
            {2, "National", 7},
            {3, "Earth", 0},
            {3, "World", 1},
            {3, "Classic", 2},
            {3, "Premier", 3},
            {3, "Event", 4},
            {3, "Birthday", 5},
            {3, "Special", 6},
            {3, "Souvenir", 7},
            {4, "Wishing", 0},
            {4, "Champion Battle", 1},
            {4, "Champion Regional", 2},
            {4, "Champion National", 3},
            {4, "Champion World", 4},
            {4, "Champion G6 Hoenn", 7},
            {5, "Contest Star", 0},
            {5, "Master Coolness", 1},
            {5, "Master Beauty", 2},
            {5, "Master Cuteness", 3},
            {5, "Master Cleverness", 4},
            {5, "Master Toughness", 5},
            {5, "Champion Alola", 6},
            {5, "Battle Royale", 7},
            {6, "Battle Tree Great", 0},
            {6, "Battle Tree Master", 1}
        };
    }

    namespace French {
        static const Ribbons allRibbons[48] = {
            {0, "Champion Kalos", 0},
            {0, "Champion G3", 1},
            {0, "Champion Sinnoh", 2},
            {0, "Amis Proches", 3},
            {0, "Entraînement", 4},
            {0, "Combattant Doué", 5},
            {0, "Combattant Expert", 6},
            {0, "Effort", 7},
            {1, "Alerte", 0},
            {1, "Électrique", 1},
            {1, "Attristé", 2},
            {1, "Négligent", 3},
            {1, "Détendu", 4},
            {1, "Somnolent", 5},
            {1, "Sourire", 6},
            {1, "Magnifique", 7},
            {2, "Royal", 0},
            {2, "Royal Magnifique", 1},
            {2, "Artiste", 2},
            {2, "Empreinte", 3},
            {2, "Record", 4},
            {2, "Légendaire", 5},
            {2, "Campagnard", 6},
            {2, "National", 7},
            {3, "Terrestre", 0},
            {3, "Monde", 1},
            {3, "Classique", 2},
            {3, "Premier", 3},
            {3, "Événement", 4},
            {3, "Anniversaire", 5},
            {3, "Spécial", 6},
            {3, "Souvenir", 7},
            {4, "Souhait", 0},
            {4, "Champion Combat", 1},
            {4, "Champion Régional", 2},
            {4, "Champion National", 3},
            {4, "Champion du Monde", 4},
            {4, "Champion G6 Hoenn", 7},
            {5, "Étoile Concours", 0},
            {5, "Maître Style", 1},
            {5, "Maître Beauté", 2},
            {5, "Maître Mignon", 3},
            {5, "Maître Ingénieux", 4},
            {5, "Maître Robuste", 5},
            {5, "Champion Alola", 6},
            {5, "Combat Royal", 7},
            {6, "Grand Maître Arbre", 0},
            {6, "Maître Arbre Ultime", 1}
        };
    }

    namespace Italian {
        static const Ribbons allRibbons[48] = {
            {0, "Campione Kalos", 0},
            {0, "Campione Hoenn (Gen 3)", 1},
            {0, "Campione Sinnoh", 2},
            {0, "Amicizia", 3},
            {0, "Training", 4},
            {0, "Asso della Lotta", 5},
            {0, "Genio della Lotta", 6},
            {0, "Merito", 7},
            {1, "Allarme", 0},
            {1, "Stupore", 1},
            {1, "Sconforto", 2},
            {1, "Indolenza", 3},
            {1, "Relax", 4},
            {1, "Pisolino", 5},
            {1, "Sorriso", 6},
            {1, "Meraviglia", 7},
            {2, "Reale", 0},
            {2, "Meraviglia Reale", 1},
            {2, "Artista", 2},
            {2, "Orma", 3},
            {2, "Record", 4},
            {2, "Leggenda", 5},
            {2, "Paese", 6},
            {2, "Nazionale", 7},
            {3, "Geo", 0},
            {3, "Mondiale", 1},
            {3, "Classico", 2},
            {3, "Principale", 3},
            {3, "Evento", 4},
            {3, "Compleanno", 5},
            {3, "Speciale", 6},
            {3, "Ricordo", 7},
            {4, "Desiderio", 0},
            {4, "Campione Lotta", 1},
            {4, "Campione Locale", 2},
            {4, "Campione Nazionale", 3},
            {4, "Campione Mondiale", 4},
            {4, "Campione Hoenn (Gen 6)", 7},
            {5, "Stella delle Gare", 0},
            {5, "Classe Suprema", 1},
            {5, "Bellezza Suprema", 2},
            {5, "Grazia Suprema", 3},
            {5, "Acume Supremo", 4},
            {5, "Grinta Suprema", 5},
            {5, "Campione Alola", 6},
            {5, "Asso Royale", 7},
            {6, "Asso dell'Albero", 0},
            {6, "Genio dell'Albero", 1}
        };
    }

    struct Music {
        const char *name;
    };

    namespace XY {
        static const vector<Music> musicFiles = {
            {"bgm_xy_ajito"},
            {"bgm_xy_battle_house"},
            {"bgm_xy_bd_01"},
            {"bgm_xy_bd_02"},
            {"bgm_xy_bicycle"},
            {"bgm_xy_boutique"},
            {"bgm_xy_c_01"},
            {"bgm_xy_c_02"},
            {"bgm_xy_c_03"},
            {"bgm_xy_c_04"},
            {"bgm_xy_c_05"},
            {"bgm_xy_c_06"},
            {"bgm_xy_c_07"},
            {"bgm_xy_c_08"},
            {"bgm_xy_c_09"},
            {"bgm_xy_demo_01"},
            {"bgm_xy_demo_02"},
            {"bgm_xy_demo_03"},
            {"bgm_xy_demo_04"},
            {"bgm_xy_demo_05"},
            {"bgm_xy_demo_06"},
            {"bgm_xy_demo_07"},
            {"bgm_xy_demo_08"},
            {"bgm_xy_demo_09"},
            {"bgm_xy_demo_legend_x"},
            {"bgm_xy_demo_legend_y"},
            {"bgm_xy_demo_opening"},
            {"bgm_xy_demo_weapon_x"},
            {"bgm_xy_demo_weapon_y"},
            {"bgm_xy_dendouiri"},
            {"bgm_xy_d_01"},
            {"bgm_xy_d_02"},
            {"bgm_xy_d_04"},
            {"bgm_xy_d_05"},
            {"bgm_xy_d_06"},
            {"bgm_xy_d_07"},
            {"bgm_xy_d_08"},
            {"bgm_xy_d_champroad"},
            {"bgm_xy_ending"},
            {"bgm_xy_epilogue"},
            {"bgm_xy_eye_01"},
            {"bgm_xy_eye_02"},
            {"bgm_xy_eye_03"},
            {"bgm_xy_eye_04"},
            {"bgm_xy_eye_05"},
            {"bgm_xy_eye_06"},
            {"bgm_xy_eye_07"},
            {"bgm_xy_eye_08"},
            {"bgm_xy_eye_09"},
            {"bgm_xy_eye_10"},
            {"bgm_xy_eye_11"},
            {"bgm_xy_eye_12"},
            {"bgm_xy_eye_13"},
            {"bgm_xy_eye_14"},
            {"bgm_xy_eye_15"},
            {"bgm_xy_eye_16"},
            {"bgm_xy_eye_17"},
            {"bgm_xy_eye_flare"},
            {"bgm_xy_e_01"},
            {"bgm_xy_e_02"},
            {"bgm_xy_e_03"},
            {"bgm_xy_e_04"},
            {"bgm_xy_e_05"},
            {"bgm_xy_e_06"},
            {"bgm_xy_e_07"},
            {"bgm_xy_e_08"},
            {"bgm_xy_e_09"},
            {"bgm_xy_e_10"},
            {"bgm_xy_e_11"},
            {"bgm_xy_e_12"},
            {"bgm_xy_e_13"},
            {"bgm_xy_e_14"},
            {"bgm_xy_e_champ"},
            {"bgm_xy_e_doctor"},
            {"bgm_xy_e_flare"},
            {"bgm_xy_e_handsome"},
            {"bgm_xy_e_handsome_02"},
            {"bgm_xy_e_tip_01"},
            {"bgm_xy_e_tip_02"},
            {"bgm_xy_e_tsureteke1"},
            {"bgm_xy_e_tsureteke2"},
            {"bgm_xy_fs"},
            {"bgm_xy_game_sync"},
            {"bgm_xy_gate"},
            {"bgm_xy_gts"},
            {"bgm_xy_gym"},
            {"bgm_xy_hotel"},
            {"bgm_xy_koukan"},
            {"bgm_xy_labo"},
            {"bgm_xy_miracle_trade"},
            {"bgm_xy_m_tower"},
            {"bgm_xy_naminori"},
            {"bgm_xy_pokecen"},
            {"bgm_xy_pokemon_league"},
            {"bgm_xy_pokemon_link"},
            {"bgm_xy_pokemon_theme"},
            {"bgm_xy_poketore"},
            {"bgm_xy_poketore_fever"},
            {"bgm_xy_pvd_01"},
            {"bgm_xy_pvd_02"},
            {"bgm_xy_pvd_03"},
            {"bgm_xy_pvd_04"},
            {"bgm_xy_pvd_05"},
            {"bgm_xy_pvd_06"},
            {"bgm_xy_pvd_07"},
            {"bgm_xy_pvd_08"},
            {"bgm_xy_pvd_09"},
            {"bgm_xy_pvd_10"},
            {"bgm_xy_pvd_11"},
            {"bgm_xy_pvd_12"},
            {"bgm_xy_pvd_13"},
            {"bgm_xy_pvd_14"},
            {"bgm_xy_pvd_15"},
            {"bgm_xy_pvd_16"},
            {"bgm_xy_pvd_17"},
            {"bgm_xy_pvd_18"},
            {"bgm_xy_pvd_19"},
            {"bgm_xy_pvd_20"},
            {"bgm_xy_pvd_21"},
            {"bgm_xy_pvd_22"},
            {"bgm_xy_pvd_23"},
            {"bgm_xy_pvd_24"},
            {"bgm_xy_pvd_25"},
            {"bgm_xy_pvd_26"},
            {"bgm_xy_pvd_27"},
            {"bgm_xy_pvd_28"},
            {"bgm_xy_pvd_29"},
            {"bgm_xy_pvd_30"},
            {"bgm_xy_pvd_31"},
            {"bgm_xy_pvd_32"},
            {"bgm_xy_pvd_studio"},
            {"bgm_xy_random_match"},
            {"bgm_xy_r_a"},
            {"bgm_xy_r_b"},
            {"bgm_xy_r_c"},
            {"bgm_xy_r_d"},
            {"bgm_xy_r_e"},
            {"bgm_xy_r_f"},
            {"bgm_xy_safari"},
            {"bgm_xy_salon"},
            {"bgm_xy_shinka"},
            {"bgm_xy_silence"},
            {"bgm_xy_sp_clear"},
            {"bgm_xy_sp_gameover"},
            {"bgm_xy_sp_gamestart"},
            {"bgm_xy_sp_menu"},
            {"bgm_xy_sp_stage"},
            {"bgm_xy_sp_stage_02"},
            {"bgm_xy_starting"},
            {"bgm_xy_sushi"},
            {"bgm_xy_test1"},
            {"bgm_xy_test2"},
            {"bgm_xy_test3"},
            {"bgm_xy_test4"},
            {"bgm_xy_test5"},
            {"bgm_xy_test6"},
            {"bgm_xy_test7"},
            {"bgm_xy_thinking"},
            {"bgm_xy_title_01"},
            {"bgm_xy_t_01"},
            {"bgm_xy_t_02"},
            {"bgm_xy_t_03"},
            {"bgm_xy_t_04"},
            {"bgm_xy_t_05"},
            {"bgm_xy_t_06"},
            {"bgm_xy_t_07"},
            {"bgm_xy_vs_champ"},
            {"bgm_xy_vs_flarebgm_xy_vs_flare_boss"},
            {"bgm_xy_vs_gymleader"},
            {"bgm_xy_vs_gymleader2"},
            {"bgm_xy_vs_legend"},
            {"bgm_xy_vs_norapoke"},
            {"bgm_xy_vs_rival"},
            {"bgm_xy_vs_secret_01"},
            {"bgm_xy_vs_shitenno"},
            {"bgm_xy_vs_special_01"},
            {"bgm_xy_vs_trainer"},
            {"bgm_xy_vs_trainer_pss"},
            {"bgm_xy_wifi_present"},
            {"bgm_xy_win1"},
            {"bgm_xy_win2"},
            {"bgm_xy_win3"},
            {"bgm_xy_win4"},
            {"bgm_xy_win5"},
            {"bgm_xy_yagi"},
            {"bgm_xy_yagi2"},
            {"me_xy_acce"},
            {"me_xy_badge"},
            {"me_xy_bpget"},
            {"me_xy_dressup_01"},
            {"me_xy_dressup_02"},
            {"me_xy_dressup_03"},
            {"me_xy_dressup_04"},
            {"me_xy_dressup_05"},
            {"me_xy_dressup_06"},
            {"me_xy_dressup_07"},
            {"me_xy_dressup_08"},
            {"me_xy_dressup_09"},
            {"me_xy_dressup_10"},
            {"me_xy_dressup_11"},
            {"me_xy_hyouka01"},
            {"me_xy_hyouka02"},
            {"me_xy_hyouka03"},
            {"me_xy_hyouka04"},
            {"me_xy_hyouka05"},
            {"me_xy_hyouka06"},
            {"me_xy_hyouka07"},
            {"me_xy_hyouka08"},
            {"me_xy_item"},
            {"me_xy_item_mystery"},
            {"me_xy_kaifuku"},
            {"me_xy_keyitem"},
            {"me_xy_kinomi"},
            {"me_xy_lvup"},
            {"me_xy_massage"},
            {"me_xy_mega_stone"},
            {"me_xy_o_power"},
            {"me_xy_pokemon_flute"},
            {"me_xy_quest"},
            {"me_xy_quiz_01"},
            {"me_xy_quiz_02"},
            {"me_xy_shinkaome"},
            {"me_xy_sp_stage_open"},
            {"me_xy_tamago_get"},
            {"me_xy_test1"},
            {"me_xy_test2"},
            {"me_xy_test3"},
            {"me_xy_train"},
            {"me_xy_wasure"},
            {"me_xy_waza"}
        };
    }

    namespace ORAS {
        static const vector<Music> musicFiles = {
            {"bgm_sg_ajito"},
            {"bgm_sg_art_gallery"},
            {"bgm_sg_battle_resort"},
            {"bgm_sg_bicycle"},
            {"bgm_sg_contest"},
            {"bgm_sg_contest2"},
            {"bgm_sg_contest_champ"},
            {"bgm_sg_contest_lobby"},
            {"bgm_sg_contest_result"},
            {"bgm_sg_c_01"},
            {"bgm_sg_c_02"},
            {"bgm_sg_c_03"},
            {"bgm_sg_c_04"},
            {"bgm_sg_c_05"},
            {"bgm_sg_c_06"},
            {"bgm_sg_c_07"},
            {"bgm_sg_demo_01"},
            {"bgm_sg_demo_02"},
            {"bgm_sg_demo_03"},
            {"bgm_sg_demo_04"},
            {"bgm_sg_demo_05"},
            {"bgm_sg_demo_06"},
            {"bgm_sg_demo_07"},
            {"bgm_sg_demo_08"},
            {"bgm_sg_demo_09"},
            {"bgm_sg_demo_10"},
            {"bgm_sg_demo_11"},
            {"bgm_sg_demo_track"},
            {"bgm_sg_dendouiri"},
            {"bgm_sg_diving"},
            {"bgm_sg_d_01"},
            {"bgm_sg_d_02"},
            {"bgm_sg_d_03"},
            {"bgm_sg_d_04"},
            {"bgm_sg_d_05"},
            {"bgm_sg_d_06"},
            {"bgm_sg_d_07"},
            {"bgm_sg_d_09"},
            {"bgm_sg_d_champroad"},
            {"bgm_sg_ending"},
            {"bgm_sg_ending2"},
            {"bgm_sg_epilogue"},
            {"bgm_sg_epilogue2"},
            {"bgm_sg_epilogue3"},
            {"bgm_sg_eye_01"},
            {"bgm_sg_eye_01"},
            {"bgm_sg_eye_03"},
            {"bgm_sg_eye_04"},
            {"bgm_sg_eye_05"},
            {"bgm_sg_eye_06"},
            {"bgm_sg_eye_07"},
            {"bgm_sg_eye_08"},
            {"bgm_sg_eye_09"},
            {"bgm_sg_eye_10"},
            {"bgm_sg_eye_11"},
            {"bgm_sg_eye_12"},
            {"bgm_sg_eye_13"},
            {"bgm_sg_eye_14"},
            {"bgm_sg_eye_aqua"},
            {"bgm_sg_eye_magma"},
            {"bgm_sg_e_01"},
            {"bgm_sg_e_02"},
            {"bgm_sg_e_03"},
            {"bgm_sg_e_04"},
            {"bgm_sg_e_05"},
            {"bgm_sg_e_06"},
            {"bgm_sg_e_07"},
            {"bgm_sg_e_08"},
            {"bgm_sg_e_09"},
            {"bgm_sg_e_10"},
            {"bgm_sg_e_11"},
            {"bgm_sg_e_12"},
            {"bgm_sg_e_13"},
            {"bgm_sg_e_14"},
            {"bgm_sg_e_15"},
            {"bgm_sg_e_16"},
            {"bgm_sg_e_17"},
            {"bgm_sg_e_18"},
            {"bgm_sg_e_19"},
            {"bgm_sg_e_aqua_magma"},
            {"bgm_sg_e_aq_mg_l"},
            {"bgm_sg_e_champ"},
            {"bgm_sg_e_haruka"},
            {"bgm_sg_e_higana"},
            {"bgm_sg_e_shitenno"},
            {"bgm_sg_e_tsureteke1"},
            {"bgm_sg_e_yuuki"},
            {"bgm_sg_fs"},
            {"bgm_sg_gym"},
            {"bgm_sg_island"},
            {"bgm_sg_karakuri"},
            {"bgm_sg_labo"},
            {"bgm_sg_legend_room"},
            {"bgm_sg_museum"},
            {"bgm_sg_naminori"},
            {"bgm_sg_pokecen"},
            {"bgm_sg_pokemon_theme"},
            {"bgm_sg_r_a"},
            {"bgm_sg_r_b"},
            {"bgm_sg_r_c"},
            {"bgm_sg_r_d"},
            {"bgm_sg_r_e"},
            {"bgm_sg_r_f"},
            {"bgm_sg_r_g"},
            {"bgm_sg_safari"},
            {"bgm_sg_school"},
            {"bgm_sg_secret_zone"},
            {"bgm_sg_sky"},
            {"bgm_sg_sky2"},
            {"bgm_sg_sora"},
            {"bgm_sg_sora02"},
            {"bgm_sg_starting"},
            {"bgm_sg_starting2"},
            {"bgm_sg_title_01"},
            {"bgm_sg_t_01"},
            {"bgm_sg_t_02"},
            {"bgm_sg_t_03"},
            {"bgm_sg_t_04"},
            {"bgm_sg_t_05"},
            {"bgm_sg_vs_aqua_magma"},
            {"bgm_sg_vs_aqua_magma_leader"},
            {"bgm_sg_vs_bfrontier"},
            {"bgm_sg_vs_champ_sg"},
            {"bgm_sg_vs_cobalion"},
            {"bgm_sg_vs_deoxys"},
            {"bgm_sg_vs_dialga"},
            {"bgm_sg_vs_giratina"},
            {"bgm_sg_vs_gymleader_sg"},
            {"bgm_sg_vs_heatran"},
            {"bgm_sg_vs_higana"},
            {"bgm_sg_vs_houou"},
            {"bgm_sg_vs_legend_02_sg"},
            {"bgm_sg_vs_legend_sg"},
            {"bgm_sg_vs_lugia"},
            {"bgm_sg_vs_norapoke_sg"},
            {"bgm_sg_vs_rival_sg"},
            {"bgm_sg_vs_shitenno_sg"},
            {"bgm_sg_vs_special_02"},
            {"bgm_sg_vs_suikun"},
            {"bgm_sg_vs_trainer_sg"},
            {"bgm_sg_vs_uxie"},
            {"bgm_sg_vs_zekrom"},
            {"bgm_sg_win1"},
            {"bgm_sg_win2"},
            {"bgm_sg_win3"},
            {"bgm_sg_win4"},
            {"bgm_sg_win5"},
            {"bgm_xy_battle_house"},
            {"bgm_xy_bd_01"},
            {"bgm_xy_bd_02"},
            {"bgm_xy_e_handsome_02"},
            {"bgm_xy_game_sync"},
            {"bgm_xy_gts"},
            {"bgm_xy_koukan"},
            {"bgm_xy_miracle_trade"},
            {"bgm_xy_pokemon_link"},
            {"bgm_xy_random_match"},
            {"bgm_xy_shinka"},
            {"bgm_xy_silence"},
            {"bgm_xy_sp_clear"},
            {"bgm_xy_sp_gameover"},
            {"bgm_xy_sp_gamestart"},
            {"bgm_xy_sp_menu"},
            {"bgm_xy_sp_stage"},
            {"bgm_xy_sp_stage_02"},
            {"bgm_xy_vs_secret_01"},
            {"bgm_xy_vs_trainer_pss"},
            {"bgm_xy_wifi_present"},
            {"me_sg_ball"},
            {"me_sg_con_ribbon2"},
            {"me_sg_danlvup"},
            {"me_sg_hyouka09"},
            {"me_sg_secretitem"},
            {"me_xy_acce"},
            {"me_xy_badge"},
            {"me_xy_bpget"},
            {"me_xy_dressup_04"},
            {"me_xy_hyouka01"},
            {"me_xy_hyouka02"},
            {"me_xy_hyouka03"},
            {"me_xy_hyouka04"},
            {"me_xy_hyouka05"},
            {"me_xy_hyouka06"},
            {"me_xy_hyouka07"},
            {"me_xy_hyouka08"},
            {"me_xy_item"},
            {"me_xy_item_mystery"},
            {"me_xy_kaifuku"},
            {"me_xy_keyitem"},
            {"me_xy_kinomi"},
            {"me_xy_lvup"},
            {"me_xy_massage"},
            {"me_xy_o_power"},
            {"me_xy_shinkaome"},
            {"me_xy_sp_stage_open"},
            {"me_xy_tamago_get"},
            {"me_xy_wasure"},
            {"me_xy_wazas"}
        };

        struct Model {
            int id;
            const char *name;
        };

        namespace English {
            static const Model models[196] = {
                {211, "Aarune"},
                {261, "Ace Trainer Female"},
                {260, "Ace Trainer Male"},
                {505, "Altaria"},
                {205, "Aqua Grunt Female"},
                {204, "Aqua Grunt Male"},
                {441, "Aqua Suit"},
                {177, "Aqua Suit Brendan"},
                {175, "Aqua Suit May"},
                {214, "Aqua Zinnia"},
                {201, "Archie"},
                {254, "Aroma Lady"},
                {428, "Azurill Doll"},
                {275, "Backpacker"},
                {427, "Bag"},
                {237, "Battle Girl"},
                {252, "Beauty"},
                {510, "Bicycle"},
                {513, "Bicycle 2"},
                {317, "Biking Brendan"},
                {316, "Biking May"},
                {258, "Biking Triathlete"},
                {247, "Bird Keeper"},
                {236, "Black Belt"},
                {188, "Brawly"},
                {172, "Brendan"},
                {220, "Bug Catcher"},
                {241, "Bug Maniac"},
                {356, "Bush"},
                {223, "Camper"},
                {224, "Camper 2"},
                {309, "Captain Stern"},
                {238, "Collector"},
                {174, "Contest Brendan"},
                {173, "Contest May"},
                {198, "Courtney"},
                {277, "Delinquent"},
                {437, "Deoxys Triangle"},
                {528, "Diving Kyogre"},
                {511, "Diving Pokémon"},
                {248, "Dragon Tamer"},
                {186, "Drake"},
                {504, "Electrike"},
                {263, "Expert Female"},
                {262, "Expert Male"},
                {272, "Fairy Tale Girl"},
                {235, "Female Breeder"},
                {230, "Female Swimmer"},
                {239, "Fisherman"},
                {190, "Flannery"},
                {435, "Fossil"},
                {408, "Frame"},
                {409, "Frame 2"},
                {412, "Frame 3"},
                {413, "Frame 4"},
                {414, "Frame 5"},
                {279, "Free Driver"},
                {313, "Game Director"},
                {231, "Gentleman"},
                {185, "Glacia"},
                {473, "Groudon"},
                {249, "Guitarist"},
                {301, "Gym Guide"},
                {418, "Helmet"},
                {243, "Hex Maniac"},
                {233, "Hiker"},
                {439, "Hoopa Ring"},
                {264, "Interviewer Female"},
                {265, "Interviewer Male"},
                {487, "Kecleon"},
                {246, "Kindler"},
                {475, "Kyogre"},
                {226, "Lady"},
                {431, "Lapras Doll"},
                {219, "Lass"},
                {479, "Latias"},
                {480, "Latios"},
                {210, "Lisia"},
                {193, "Liza"},
                {215, "Looker"},
                {483, "Machoke"},
                {509, "Machoke 2"},
                {200, "Magma Grunt Female"},
                {199, "Magma Grunt Male"},
                {440, "Magma Suit"},
                {178, "Magma Suit Brendan"},
                {176, "Magma Suit May"},
                {213, "Magma Zinnia"},
                {234, "Male Breeder"},
                {229, "Male Swimmer"},
                {465, "Marill"},
                {202, "Matt"},
                {196, "Maxie"},
                {171, "May"},
                {497, "Meditite"},
                {496, "Minun"},
                {416, "Mirror"},
                {280, "Mom"},
                {296, "Mom 2"},
                {308, "Mr.Bonding"},
                {283, "Mr.Briney"},
                {282, "Mr.Stone"},
                {300, "Mystery Gift Lady"},
                {302, "Mystery Gift Lady 2"},
                {303, "Mystery Gift Lady 3"},
                {245, "Ninja Boy"},
                {191, "Norman"},
                {290, "O-Power Guy 1"},
                {291, "O-Power Guy 2"},
                {292, "O-Power Guy 3"},
                {293, "O-Power Guy 4"},
                {294, "O-Power Guy 5"},
                {295, "O-Power Guy 6"},
                {287, "Old Female"},
                {286, "Old Male"},
                {253, "Parasol Lady"},
                {184, "Phoebe"},
                {495, "Plusle"},
                {240, "Poké Maniac"},
                {298, "PokéCenter Nurse"},
                {256, "Pokéfan Female"},
                {255, "Pokéfan Male"},
                {299, "PokéMart Clerk"},
                {251, "Pokémon Ranger Female"},
                {250, "Pokémon Ranger Male"},
                {491, "Poochyena"},
                {179, "Professor Birch"},
                {244, "Psychic"},
                {477, "Rayquaza"},
                {489, "Regice"},
                {488, "Regirock"},
                {490, "Registeel"},
                {461, "Rhyhorn"},
                {225, "Rich Boy"},
                {363, "Rock"},
                {367, "Rock 2"},
                {406, "Rock 3"},
                {407, "Rock 4"},
                {500, "Roselia"},
                {187, "Roxanne"},
                {242, "Ruin Maniac"},
                {232, "Sailor"},
                {221, "School Kid Boy"},
                {222, "School Kid Girl"},
                {307, "Scientist"},
                {310, "Scientist 2"},
                {278, "Scuba Driver"},
                {203, "Shelly"},
                {498, "Shroomish"},
                {183, "Sidney"},
                {492, "Skitty"},
                {429, "Skitty Doll"},
                {499, "Slakoth"},
                {432, "Snorlax Doll"},
                {366, "Spiritomb Stone"},
                {436, "Spiritomb Stone 2"},
                {415, "Stars"},
                {182, "Steven"},
                {507, "Stone Groudon"},
                {508, "Stone Kyogre"},
                {276, "Street Thug"},
                {274, "Surfing Ace Female"},
                {273, "Surfing Ace Male"},
                {527, "Surfing Kyogre"},
                {532, "Surfing Sharpedo"},
                {430, "Swablu Doll"},
                {197, "Tabitha"},
                {419, "Table"},
                {501, "Taillow"},
                {194, "Tate"},
                {417, "Team Flare Glass"},
                {270, "Teammate 1"},
                {271, "Teammate 2"},
                {355, "TM"},
                {365, "Tree"},
                {257, "Triathlete"},
                {259, "Triathlete 2"},
                {227, "Tuber Boy"},
                {228, "Tuber Girl"},
                {266, "Twins"},
                {494, "Wailmer"},
                {195, "Wallace"},
                {180, "Wally"},
                {181, "Wally 2"},
                {288, "Wally's dad"},
                {189, "Wattson"},
                {503, "Whismur"},
                {484, "Wingull"},
                {192, "Winona"},
                {410, "Xerneas Tree"},
                {269, "Young Couple Female"},
                {268, "Young Couple Male"},
                {218, "Youngster"},
                {411, "Yveltal Cocoon"},
                {493, "Zigzagoon"},
                {212, "Zinnia"}
            };
        }

        namespace French {
            static const Model models[196] = {
                {211, "Amary"},
                {261, "Dresseuse Aspirante"},
                {260, "Dresseur Aspirant"},
                {505, "Altaria"},
                {205, "Aquatubeuse"},
                {204, "Aquatube"},
                {441, "Combi Aqua"},
                {177, "Combi Aqua Brendan"},
                {175, "Combi Aqua Marine"},
                {214, "Aqua Zinnia"},
                {201, "Archie"},
                {254, "Dame Aromatique"},
                {428, "Poupée Azurill"},
                {275, "Randonneuse"},
                {427, "Sac"},
                {237, "Gamine"},
                {252, "Belle"},
                {510, "Vélo"},
                {513, "Vélo 2"},
                {317, "Bicycliste Brendan"},
                {316, "Bicycliste Marine"},
                {258, "Triathlète Cycliste"},
                {247, "Gardien des Oiseaux"},
                {236, "Karatéka"},
                {188, "Peter"},
                {172, "Sacha"},
                {220, "Chenipan"},
                {241, "Maniaque des Insectes"},
                {356, "Buisson"},
                {223, "Campeur"},
                {224, "Campeur 2"},
                {309, "Capitaine Dock"},
                {238, "Collectionneur"},
                {174, "Peter de Concours"},
                {173, "Marina de Concours"},
                {198, "Courtney"},
                {277, "Voyou"},
                {437, "Deoxys Triangle"},
                {528, "Kyogre Plongée"},
                {511, "Plongeur Pokémon"},
                {248, "Dompteur de Dragons"},
                {186, "Dracologue"},
                {504, "Dynavolt"},
                {263, "Spécialiste Femme"},
                {262, "Spécialiste Homme"},
                {272, "Jeune Fille Contes de Fées"},
                {235, "Éleveuse Femme"},
                {230, "Nageuse Femme"},
                {239, "Pêcheur"},
                {190, "Ondine"},
                {435, "Fossile"},
                {408, "Cadre"},
                {409, "Cadre 2"},
                {412, "Cadre 3"},
                {413, "Cadre 4"},
                {414, "Cadre 5"},
                {279, "Pilote de Quad"},
                {313, "Directeur du Jeu"},
                {231, "Gentleman"},
                {185, "Alyxia"},
                {473, "Groudon"},
                {249, "Guitariste"},
                {301, "Guide de Salle"},
                {418, "Casque"},
                {243, "Maniaque des Hexagones"},
                {233, "Randonneur"},
                {439, "Anneau d'Hoopa"},
                {264, "Intervieweuse Femme"},
                {265, "Intervieweur Homme"},
                {487, "Kecleon"},
                {246, "Pyro"},
                {475, "Kyogre"},
                {226, "Dame"},
                {431, "Poupée Lokhlass"},
                {219, "Dresseuse"},
                {479, "Latias"},
                {480, "Latios"},
                {210, "Lisia"},
                {193, "Liza"},
                {215, "Lokhlass"},
                {483, "Machopeur"},
                {509, "Machopeur 2"},
                {200, "Aquatubeuse"},
                {199, "Aquatube"},
                {440, "Combi Magma"},
                {178, "Combi Magma Brendan"},
                {176, "Combi Magma Marine"},
                {213, "Magma Zinnia"},
                {234, "Éleveur Homme"},
                {229, "Nageur Homme"},
                {465, "Marill"},
                {202, "Matt"},
                {196, "Maxie"},
                {171, "Marin"},
                {497, "Méditikka"},
                {496, "Negapi"},
                {416, "Miroir"},
                {280, "Maman"},
                {296, "Maman 2"},
                {308, "Lien-Spirituel"},
                {283, "Capitaine Malo"},
                {282, "Monsieur Pierre"},
                {300, "Dame du Cadeau Mystère"},
                {302, "Dame du Cadeau Mystère 2"},
                {303, "Dame du Cadeau Mystère 3"},
                {245, "Ninja"},
                {191, "Norman"},
                {290, "O-Puissant 1"},
                {291, "O-Puissant 2"},
                {292, "O-Puissant 3"},
                {293, "O-Puissant 4"},
                {294, "O-Puissant 5"},
                {295, "O-Puissant 6"},
                {287, "Dame Âgée"},
                {286, "Monsieur Âgé"},
                {253, "Parasol Lady"},
                {184, "Phoebe"},
                {495, "Posipi"},
                {240, "Maniaque des Pokémon"},
                {298, "Infirmière Pokémon"},
                {256, "Dame Passionnée"},
                {255, "Monsieur Passionné"},
                {299, "Vendeur Pokémon"},
                {251, "Ranger Pokémon Femme"},
                {250, "Ranger Pokémon Homme"},
                {491, "Medhyèna"},
                {179, "Professeur Seko"},
                {244, "Mentaliste"},
                {477, "Rayquaza"},
                {489, "Regice"},
                {488, "Regirock"},
                {490, "Registeel"},
                {461, "Rhinocorne"},
                {225, "Jeune Riche"},
                {363, "Roche"},
                {367, "Roche 2"},
                {406, "Roche 3"},
                {407, "Roche 4"},
                {500, "Rosabyss"},
                {187, "Géraldine"},
                {242, "Maniaque des Ruines"},
                {232, "Marin"},
                {221, "Gamin Garçon"},
                {222, "Gamin Fille"},
                {307, "Scientifique"},
                {310, "Scientifique 2"},
                {278, "Plongeur"},
                {203, "Shelly"},
                {498, "Balignon"},
                {183, "Sidney"},
                {492, "Éoko"},
                {429, "Poupée Skitty"},
                {499, "Parecool"},
                {432, "Poupée Ronflex"},
                {366, "Pierre de Spiritomb"},
                {436, "Pierre de Spiritomb 2"},
                {415, "Étoiles"},
                {182, "Steven"},
                {507, "Combi Groudon"},
                {508, "Combi Kyogre"},
                {276, "Jeune Bourrin"},
                {274, "Ace de la Glisse Femme"},
                {273, "Ace de la Glisse Homme"},
                {527, "Surf Kyogre"},
                {532, "Surf Sharpedo"},
                {430, "Poupée Tylton"},
                {197, "Courtney"},
                {419, "Table"},
                {501, "Nirondelle"},
                {194, "Gustave"},
                {417, "Lunettes Flare"},
                {270, "Équipier 1"},
                {271, "Équipier 2"},
                {355, "CT"},
                {365, "Arbre"},
                {257, "Triathlète"},
                {259, "Triathlète 2"},
                {227, "Gamin Garçon"},
                {228, "Gamin Fille"},
                {266, "Jumelles"},
                {494, "Wailmer"},
                {195, "Albert"},
                {180, "Liam"},
                {181, "Liam 2"},
                {288, "Père de Liam"},
                {189, "Olivier"},
                {503, "Chuchmur"},
                {484, "Goélise"},
                {192, "Violette"},
                {410, "Arbre de Xerneas"},
                {269, "Couple de Jeunes Femmes"},
                {268, "Couple de Jeunes Hommes"},
                {218, "Jeune Dresseur"},
                {411, "Cocon d'Yveltal"},
                {493, "Zigzaton"},
                {212, "Zinnia"}
            };
        }

        namespace Italian {
            static const Model models[196] = {
                {211, "Iperio"},
                {261, "Fantallenatrice"},
                {260, "Fantallenatore"},
                {505, "Altaria"},
                {205, "Recluta Team Idro (F)"},
                {204, "Recluta Team Idro (M)"},
                {441, "Tuta Idro"},
                {177, "Tuta Idro (Brendan)"},
                {175, "Tuta Idro (Vera)"},
                {214, "Lyris (Team Idro)"},
                {201, "Ivan"},
                {254, "Profumina"},
                {428, "Bambola Azurill"},
                {275, "Giramondo"},
                {427, "Borsa"},
                {237, "Combat Girl"},
                {252, "Bellezza"},
                {510, "Bicicletta [verde]"},
                {513, "Bicicletta [gialla]"},
                {317, "Brendan in bicicletta"},
                {316, "Vera in bicicletta"},
                {258, "Triatleta in bicicletta"},
                {247, "Avicoltore"},
                {236, "Cinturanera"},
                {188, "Rudi"},
                {172, "Brendan"},
                {220, "Pigliamosche"},
                {241, "Insettologo"},
                {356, "Cespuglio"},
                {223, "Campeggiatore (M)"},
                {224, "Campeggiatore (F)"},
                {309, "Capitano Remo"},
                {238, "Cercapokémon"},
                {174, "Contest [Brendan]"},
                {173, "Contest [Vera]"},
                {198, "Rossella"},
                {277, "Tipaccia"},
                {437, "Triangolo di Deoxys"},
                {528, "Kyogre sott'acqua"},
                {511, "Pokémon sott'acqua"},
                {248, "Domadraghi"},
                {186, "Drake"},
                {504, "Electrike"},
                {263, "Specialista (F)"},
                {262, "Specialista (M)"},
                {272, "Ragazza delle fiabe"},
                {235, "Allevapokémon (F)"},
                {230, "Nuotatrice"},
                {239, "Pescatore"},
                {190, "Fiammetta"},
                {435, "Fossile"},
                {408, "Cornice [1]"},
                {409, "Cornice [2]"},
                {412, "Cornice [3]"},
                {413, "Cornice [4]"},
                {414, "Cornice [5]"},
                {279, "Pescatrice di Perle"},
                {313, "Game Director"},
                {231, "Gentiluomo"},
                {185, "Frida"},
                {473, "Groudon"},
                {249, "Chitarrista"},
                {301, "Guida alla Palestra"},
                {418, "Cloche"},
                {243, "Streghetta"},
                {233, "Montanaro"},
                {439, "Anello di Hoopa"},
                {264, "Reporter (F)"},
                {265, "Reporter (M)"},
                {487, "Kecleon"},
                {246, "Kindler"},
                {475, "Kyogre"},
                {226, "Lady"},
                {431, "Bambola Lapras"},
                {219, "Teenager"},
                {479, "Latias"},
                {480, "Latios"},
                {210, "Orthilla"},
                {193, "Liza"},
                {215, "Bellocchio"},
                {483, "Machoke [1]"},
                {509, "Machoke [2]"},
                {200, "Recluta Team Magma (F)"},
                {199, "Recluta Team Magma (M)"},
                {440, "Tuta Magma"},
                {178, "Tuta Magma (Brendan)"},
                {176, "Tuta Magma (Vera)"},
                {213, "Lyris (Team Magma)"},
                {234, "Allevapokémon (M)"},
                {229, "Nuotatore"},
                {465, "Marill"},
                {202, "Alan [Team Idro]"},
                {196, "Max [Team Magma]"},
                {171, "Vera"},
                {497, "Meditite"},
                {496, "Minun"},
                {416, "Speculare1"},
                {280, "Mamma [1]"},
                {296, "Mamma [2]"},
                {308, "Mr. Fratellanza"},
                {283, "Mr. Briney"},
                {282, "Sig. Marino"},
                {300, "Ragazza Reg. Misterioso [1]"},
                {302, "Ragazza Reg. Misterioso [2]"},
                {303, "Ragazza Reg. Misterioso [3]"},
                {245, "Ninja Boy"},
                {191, "Norman"},
                {290, "O-Power [rosso]"},
                {291, "O-Power [giallo]"},
                {292, "O-Power [blu]"},
                {293, "O-Power [verde]"},
                {294, "O-Power [rosa]"},
                {295, "O-Power [nero]"},
                {287, "Anziana"},
                {286, "Anziano"},
                {253, "Ombrellina"},
                {184, "Ester"},
                {495, "Plusle"},
                {240, "Pokéfanatico"},
                {298, "Infermiera Centro Pokémon"},
                {256, "Pokéfan Female"},
                {255, "Pokéfan Male"},
                {299, "Impiegato del PokéMart"},
                {251, "Pokémon Ranger (F)"},
                {250, "Pokémon Ranger (M)"},
                {491, "Poochyena"},
                {179, "Professor Birch"},
                {244, "Sensitivo"},
                {477, "Rayquaza"},
                {489, "Regice"},
                {488, "Regirock"},
                {490, "Registeel"},
                {461, "Rhyhorn"},
                {225, "Elegantone"},
                {363, "Roccia [1]"},
                {367, "Roccia [2]"},
                {406, "Roccia [3]"},
                {407, "Roccia [4]"},
                {500, "Roselia"},
                {187, "Petra"},
                {242, "Scoprirovine"},
                {232, "Marinaio"},
                {221, "Scolaro"},
                {222, "Scolara"},
                {307, "Scienziato [1]"},
                {310, "Scienziato [2]"},
                {278, "Sub"},
                {203, "Shelly"},
                {498, "Shroomish"},
                {183, "Fosco"},
                {492, "Skitty"},
                {429, "Skitty bambola"},
                {499, "Slakoth"},
                {432, "Snorlax bambola"},
                {366, "Roccianima [1]"},
                {436, "Roccianima [2]"},
                {415, "Stelle"},
                {182, "Steven"},
                {507, "Groudon statua"},
                {508, "Kyogre statua"},
                {276, "Tipaccio"},
                {274, "Fantallenatrice [surf]"},
                {273, "Fantallenatore [surf]"},
                {527, "Surf su Kyogre"},
                {532, "Surf su Sharpedo"},
                {430, "Swablu bambola"},
                {197, "Ottavio"},
                {419, "Tavolo"},
                {501, "Taillow"},
                {194, "Tate"},
                {417, "Occhiali Team Flare"},
                {270, "Compagna [1]"},
                {271, "Compagna [2]"},
                {355, "TM"},
                {365, "Tree"},
                {257, "Triatleta [1]"},
                {259, "Triatleta [2]"},
                {227, "Ciambellino"},
                {228, "Ciambellina"},
                {266, "Gemelle"},
                {494, "Wailmer"},
                {195, "Adriano"},
                {180, "Lino [1]"},
                {181, "Lino [2]"},
                {288, "Padre di Lino"},
                {189, "Walter"},
                {503, "Whismur"},
                {484, "Wingull"},
                {192, "Alice"},
                {410, "Xerneas [albero]"},
                {269, "Coppietta (F)"},
                {268, "Coppietta (M)"},
                {218, "Marmocchio"},
                {411, "Bozzolo di Yveltal"},
                {493, "Zigzagoon"},
                {212, "Lyris"}
            };
        }
    }

    namespace SM {
        static const vector<Music> musicFiles = {
            {"bgm_nj_base"},
            {"bgm_nj_battletree"},
            {"bgm_nj_c01"},
            {"bgm_nj_c01_n"},
            {"bgm_nj_c02"},
            {"bgm_nj_c02_n"},
            {"bgm_nj_c03"},
            {"bgm_nj_c03_n"},
            {"bgm_nj_c04"},
            {"bgm_nj_c04_n"},
            {"bgm_nj_c05"},
            {"bgm_nj_c05_n"},
            {"bgm_nj_canyon"},
            {"bgm_nj_cave"},
            {"bgm_nj_champroad"},
            {"bgm_nj_croyal"},
            {"bgm_nj_d01"},
            {"bgm_nj_demo01"},
            {"bgm_nj_demo03"},
            {"bgm_nj_demo04"},
            {"bgm_nj_demo05"},
            {"bgm_nj_demo06"},
            {"bgm_nj_demo07"},
            {"bgm_nj_demo08"},
            {"bgm_nj_demo09"},
            {"bgm_nj_demo10"},
            {"bgm_nj_demo11"},
            {"bgm_nj_demo12"},
            {"bgm_nj_demo13"},
            {"bgm_nj_demo14"},
            {"bgm_nj_demo15"},
            {"bgm_nj_demo16"},
            {"bgm_nj_dendouiri"},
            {"bgm_nj_desert"},
            {"bgm_nj_e_doctor"},
            {"bgm_nj_e_tsureteke"},
            {"bgm_nj_e01"},
            {"bgm_nj_e02"},
            {"bgm_nj_e03"},
            {"bgm_nj_e05"},
            {"bgm_nj_e06"},
            {"bgm_nj_e07"},
            {"bgm_nj_e08"},
            {"bgm_nj_e09"},
            {"bgm_nj_e10"},
            {"bgm_nj_e11_01"},
            {"bgm_nj_e11_02"},
            {"bgm_nj_e12"},
            {"bgm_nj_e13"},
            {"bgm_nj_e14"},
            {"bgm_nj_e15"},
            {"bgm_nj_e16"},
            {"bgm_nj_e17"},
            {"bgm_nj_e18"},
            {"bgm_nj_e19"},
            {"bgm_nj_e20"},
            {"bgm_nj_e21"},
            {"bgm_nj_e22"},
            {"bgm_nj_e23"},
            {"bgm_nj_e24"},
            {"bgm_nj_e25"},
            {"bgm_nj_e26"},
            {"bgm_nj_e27"},
            {"bgm_nj_e28"},
            {"bgm_nj_e29"},
            {"bgm_nj_endcave"},
            {"bgm_nj_ending01"},
            {"bgm_nj_ending02"},
            {"bgm_nj_epilogue"},
            {"bgm_nj_eye01"},
            {"bgm_nj_eye02"},
            {"bgm_nj_eye03"},
            {"bgm_nj_eye04"},
            {"bgm_nj_farm"},
            {"bgm_nj_festa_d"},
            {"bgm_nj_festa_event"},
            {"bgm_nj_festa_eventend"},
            {"bgm_nj_festa_n"},
            {"bgm_nj_harbor"},
            {"bgm_nj_hole"},
            {"bgm_nj_islandfes"},
            {"bgm_nj_istarting"},
            {"bgm_nj_koukan"},
            {"bgm_nj_labo01"},
            {"bgm_nj_labo02"},
            {"bgm_nj_lake01"},
            {"bgm_nj_league01"},
            {"bgm_nj_league02"},
            {"bgm_nj_lilii_fes"},
            {"bgm_nj_malasada"},
            {"bgm_nj_market01"},
            {"bgm_nj_market02"},
            {"bgm_nj_megafloat01"},
            {"bgm_nj_megafloat02"},
            {"bgm_nj_megafloat03"},
            {"bgm_nj_niji01"},
            {"bgm_nj_niji02"},
            {"bgm_nj_niji03"},
            {"bgm_nj_niji04"},
            {"bgm_nj_niji05"},
            {"bgm_nj_pisland_d"},
            {"bgm_nj_pisland_n"},
            {"bgm_nj_pokecen"},
            {"bgm_nj_pokeride01"},
            {"bgm_nj_pokeride02"},
            {"bgm_nj_r_02"},
            {"bgm_nj_r_03"},
            {"bgm_nj_r_04"},
            {"bgm_nj_r_05"},
            {"bgm_nj_r_06"},
            {"bgm_nj_r01"},
            {"bgm_nj_refre"},
            {"bgm_nj_ruin"},
            {"bgm_nj_school"},
            {"bgm_nj_shinka_intro"},
            {"bgm_nj_shinka01"},
            {"bgm_nj_shinka02"},
            {"bgm_nj_starting"},
            {"bgm_nj_studium"},
            {"bgm_nj_t01"},
            {"bgm_nj_t01_n"},
            {"bgm_nj_t02"},
            {"bgm_nj_t02_n"},
            {"bgm_nj_t03"},
            {"bgm_nj_t04"},
            {"bgm_nj_t04_n"},
            {"bgm_nj_vs_beast"},
            {"bgm_nj_vs_broyal"},
            {"bgm_nj_vs_champ"},
            {"bgm_nj_vs_ether"},
            {"bgm_nj_vs_friend"},
            {"bgm_nj_vs_friend"},
            {"bgm_nj_vs_giver"},
            {"bgm_nj_vs_legend"},
            {"bgm_nj_vs_mother"},
            {"bgm_nj_vs_motherbeast"},
            {"bgm_nj_vs_norapoke"},
            {"bgm_nj_vs_norapoke_02"},
            {"bgm_nj_vs_redgreen"},
            {"bgm_nj_vs_rival"},
            {"bgm_nj_vs_scull"},
            {"bgm_nj_vs_scullboss"},
            {"bgm_nj_vs_scullelite"},
            {"bgm_nj_vs_shitenno"},
            {"bgm_nj_vs_special01"},
            {"bgm_nj_vs_trainer"},
            {"bgm_nj_win1"},
            {"bgm_nj_win1_st"},
            {"bgm_nj_win2"},
            {"bgm_nj_win2_st"},
            {"bgm_nj_win3"},
            {"bgm_nj_win3_st"},
            {"bgm_nj_win4"},
            {"bgm_nj_win4_st"},
            {"bgm_nj_win5"},
            {"bgm_nj_win5_st"},
            {"bgm_nj_win6"},
            {"bgm_nj_win6_st"},
            {"bgm_nj_win7"},
            {"bgm_nj_win7_st"},
            {"bgm_nj_win8"},
            {"bgm_nj_win8_st"},
            {"bgm_nj_win9"},
            {"bgm_nj_win9_st"},
            {"bgm_xy_bd_01"},
            {"bgm_xy_bd_02"},
            {"bgm_xy_boutique"},
            {"bgm_xy_e_handsome"},
            {"bgm_xy_e_handsome_02"},
            {"bgm_xy_gts"},
            {"bgm_xy_miracle_trade"},
            {"bgm_xy_random_match"},
            {"bgm_xy_salon"},
            {"bgm_xy_silence"},
            {"bgm_xy_sushi"},
            {"bgm_xy_vs_secret_01"},
            {"bgm_xy_wifi_present"},
            {"me_finder_update"},
            {"me_finder_update_f"},
            {"me_nj_01"},
            {"me_nj_02"},
            {"me_nj_03"},
            {"me_nj_04"},
            {"me_nj_acce"},
            {"me_nj_bpget"},
            {"me_nj_chime"},
            {"me_nj_festa_failure"},
            {"me_nj_festa_lvup"},
            {"me_nj_festa_newshop"},
            {"me_nj_festa_newshop_nc"},
            {"me_nj_festa_success"},
            {"me_nj_festa_uranai"},
            {"me_nj_item"},
            {"me_nj_kaifuku"},
            {"me_nj_keyitem"},
            {"me_nj_lvup"},
            {"me_nj_massage"},
            {"me_nj_oyasumi"},
            {"me_nj_resort_finish"},
            {"me_nj_shinkaome"},
            {"me_nj_syoukan"},
            {"me_nj_tamago_get"},
            {"me_nj_test13"},
            {"me_nj_waza"},
            {"me_nj_zygarde"},
            {"me_xy_dressup_04"},
            {"me_xy_hyouka01"},
            {"me_xy_hyouka02"},
            {"me_xy_hyouka03"},
            {"me_xy_hyouka04"},
            {"me_xy_hyouka05"},
            {"me_xy_hyouka06"},
            {"me_xy_hyouka07"},
            {"me_xy_hyouka08"},
            {"me_xy_item_mystery"},
            {"me_xy_kinomi"},
            {"me_xy_mega_stone"},
            {"me_xy_o_power"},
            {"me_xy_quest"},
            {"me_xy_wasure"},
            {"strm_bgm_xy_e_05"},
            {"strm_demo_renrakusen"},
            {"strm_demo_sd9200"}
        };
    }

    namespace USUM {
        static const vector<Music> musicFiles = {
            {"bgm_mj_e01"},
            {"bgm_mj_e02"},
            {"bgm_mj_e03"},
            {"bgm_mj_e04"},
            {"bgm_mj_ev5050_m"},
            {"bgm_mj_ev5050_s"},
            {"bgm_mj_ev5080_m"},
            {"bgm_mj_ev5080_s"},
            {"bgm_mj_g01"},
            {"bgm_mj_m01"},
            {"bgm_mj_m03"},
            {"bgm_mj_m04"},
            {"bgm_mj_m05"},
            {"bgm_mj_m06"},
            {"bgm_mj_m07"},
            {"bgm_mj_m08"},
            {"bgm_mj_m09"},
            {"bgm_mj_s01"},
            {"bgm_mj_s02"},
            {"bgm_mj_s03"},
            {"bgm_mj_sys01"},
            {"bgm_mj_sys02"},
            {"bgm_mj_vs01"},
            {"bgm_mj_vs02"},
            {"bgm_mj_vs03"},
            {"bgm_mj_vs04"},
            {"bgm_mj_vs05"},
            {"bgm_mj_vs06"},
            {"bgm_mj_vs07"},
            {"bgm_mj_vs08"},
            {"bgm_mj_vs09"},
            {"bgm_mj_vsdivezone01"},
            {"bgm_mj_vsdivezone02"},
            {"bgm_mj_vsdivezone03"},
            {"bgm_mj_vsdivezone04"},
            {"bgm_mj_vsdivezone05"},
            {"bgm_mj_vsdivezone06"},
            {"bgm_mj_vsdivezone07"},
            {"bgm_mj_vsdivezone08"},
            {"bgm_mj_vsdivezone09"},
            {"bgm_mj_vsdivezone10"},
            {"bgm_mj_vsdivezone11"},
            {"bgm_mj_vsdivezone12"},
            {"bgm_mj_vsdivezone13"},
            {"bgm_mj_vsdivezone14"},
            {"bgm_mj_vsdivezone15"},
            {"bgm_mj_vsdivezone16"},
            {"bgm_mj_vs_champ"},
            {"bgm_mj_vs_norapoke"},
            {"bgm_mj_vs_trainer"},
            {"bgm_nj_base"},
            {"bgm_nj_battletree"},
            {"bgm_nj_c01"},
            {"bgm_nj_c01_n"},
            {"bgm_nj_c02"},
            {"bgm_nj_c02_n"},
            {"bgm_nj_c03"},
            {"bgm_nj_c03_n"},
            {"bgm_nj_c04"},
            {"bgm_nj_c04_n"},
            {"bgm_nj_c05"},
            {"bgm_nj_c05_n"},
            {"bgm_nj_canyon"},
            {"bgm_nj_cave"},
            {"bgm_nj_champroad"},
            {"bgm_nj_croyal"},
            {"bgm_nj_d01"},
            {"bgm_nj_demo01"},
            {"bgm_nj_demo03"},
            {"bgm_nj_demo04"},
            {"bgm_nj_demo05"},
            {"bgm_nj_demo06"},
            {"bgm_nj_demo07"},
            {"bgm_nj_demo08"},
            {"bgm_nj_demo09"},
            {"bgm_nj_demo10"},
            {"bgm_nj_demo11"},
            {"bgm_nj_demo12"},
            {"bgm_nj_demo13"},
            {"bgm_nj_demo14"},
            {"bgm_nj_demo15"},
            {"bgm_nj_demo16"},
            {"bgm_nj_dendouiri"},
            {"bgm_nj_desert"},
            {"bgm_nj_e01"},
            {"bgm_nj_e02"},
            {"bgm_nj_e03"},
            {"bgm_nj_e05"},
            {"bgm_nj_e06"},
            {"bgm_nj_e07"},
            {"bgm_nj_e08"},
            {"bgm_nj_e09"},
            {"bgm_nj_e10"},
            {"bgm_nj_e11_01"},
            {"bgm_nj_e11_02"},
            {"bgm_nj_e12"},
            {"bgm_nj_e13"},
            {"bgm_nj_e14"},
            {"bgm_nj_e15"},
            {"bgm_nj_e16"},
            {"bgm_nj_e17"},
            {"bgm_nj_e18"},
            {"bgm_nj_e19"},
            {"bgm_nj_e20"},
            {"bgm_nj_e21"},
            {"bgm_nj_e22"},
            {"bgm_nj_e23"},
            {"bgm_nj_e24"},
            {"bgm_nj_e25"},
            {"bgm_nj_e26"},
            {"bgm_nj_e27"},
            {"bgm_nj_e28"},
            {"bgm_nj_e29"},
            {"bgm_nj_endcave"},
            {"bgm_nj_ending02"},
            {"bgm_nj_epilogue"},
            {"bgm_nj_eye01"},
            {"bgm_nj_eye02"},
            {"bgm_nj_eye03"},
            {"bgm_nj_eye04"},
            {"bgm_nj_e_doctor"},
            {"bgm_nj_e_tsureteke"},
            {"bgm_nj_farm"},
            {"bgm_nj_festa_d"},
            {"bgm_nj_festa_event"},
            {"bgm_nj_festa_eventend"},
            {"bgm_nj_festa_n"},
            {"bgm_nj_harbor"},
            {"bgm_nj_hole"},
            {"bgm_nj_islandfes"},
            {"bgm_nj_istarting"},
            {"bgm_nj_koukan"},
            {"bgm_nj_labo01"},
            {"bgm_nj_labo02"},
            {"bgm_nj_lake01"},
            {"bgm_nj_league01"},
            {"bgm_nj_league02"},
            {"bgm_nj_lilii_fes"},
            {"bgm_nj_malasada"},
            {"bgm_nj_market01"},
            {"bgm_nj_market02"},
            {"bgm_nj_megafloat01"},
            {"bgm_nj_megafloat02"},
            {"bgm_nj_megafloat03"},
            {"bgm_nj_niji01"},
            {"bgm_nj_niji02"},
            {"bgm_nj_niji03"},
            {"bgm_nj_niji04"},
            {"bgm_nj_niji05"},
            {"bgm_nj_pisland_d"},
            {"bgm_nj_pisland_n"},
            {"bgm_nj_pokecen"},
            {"bgm_nj_pokeride01"},
            {"bgm_nj_pokeride02"},
            {"bgm_nj_r01"},
            {"bgm_nj_refre"},
            {"bgm_nj_ruin"},
            {"bgm_nj_r_02"},
            {"bgm_nj_r_03"},
            {"bgm_nj_r_04"},
            {"bgm_nj_r_05"},
            {"bgm_nj_r_06"},
            {"bgm_nj_school"},
            {"bgm_nj_shinka01"},
            {"bgm_nj_shinka02"},
            {"bgm_nj_shinka_intro"},
            {"bgm_nj_starting"},
            {"bgm_nj_studium"},
            {"bgm_nj_t01"},
            {"bgm_nj_t01_n"},
            {"bgm_nj_t02"},
            {"bgm_nj_t02_n"},
            {"bgm_nj_t03"},
            {"bgm_nj_t04"},
            {"bgm_nj_t04_n"},
            {"bgm_nj_vs_beast"},
            {"bgm_nj_vs_broyal"},
            {"bgm_nj_vs_champ"},
            {"bgm_nj_vs_ether"},
            {"bgm_nj_vs_friend"},
            {"bgm_nj_vs_giver"},
            {"bgm_nj_vs_legend"},
            {"bgm_nj_vs_mother"},
            {"bgm_nj_vs_motherbeast"},
            {"bgm_nj_vs_norapoke"},
            {"bgm_nj_vs_norapoke_02"},
            {"bgm_nj_vs_redgreen"},
            {"bgm_nj_vs_rival"},
            {"bgm_nj_vs_scull"},
            {"bgm_nj_vs_scullboss"},
            {"bgm_nj_vs_scullelite"},
            {"bgm_nj_vs_shitenno"},
            {"bgm_nj_vs_special01"},
            {"bgm_nj_vs_trainer"},
            {"bgm_nj_win1"},
            {"bgm_nj_win1_st"},
            {"bgm_nj_win2"},
            {"bgm_nj_win2_st"},
            {"bgm_nj_win3"},
            {"bgm_nj_win3_st"},
            {"bgm_nj_win4"},
            {"bgm_nj_win4_st"},
            {"bgm_nj_win5"},
            {"bgm_nj_win5_st"},
            {"bgm_nj_win6"},
            {"bgm_nj_win6_st"},
            {"bgm_nj_win7"},
            {"bgm_nj_win7_st"},
            {"bgm_nj_win8"},
            {"bgm_nj_win8_st"},
            {"bgm_nj_win9"},
            {"bgm_nj_win9_st"},
            {"bgm_xy_bd_01"},
            {"bgm_xy_bd_02"},
            {"bgm_xy_boutique"},
            {"bgm_xy_e_handsome_02"},
            {"bgm_xy_gts"},
            {"bgm_xy_miracle_trade"},
            {"bgm_xy_random_match"},
            {"bgm_xy_salon"},
            {"bgm_xy_silence"},
            {"bgm_xy_sushi"},
            {"bgm_xy_vs_secret_01"},
            {"bgm_xy_wifi_present"},
            {"me_finder_update"},
            {"me_finder_update_f"},
            {"me_nj_01"},
            {"me_nj_02"},
            {"me_nj_03"},
            {"me_nj_04"},
            {"me_nj_acce"},
            {"me_nj_bpget"},
            {"me_nj_chime"},
            {"me_nj_festa_failure"},
            {"me_nj_festa_lvup"},
            {"me_nj_festa_newshop"},
            {"me_nj_festa_newshop_nc"},
            {"me_nj_festa_success"},
            {"me_nj_festa_uranai"},
            {"me_nj_item"},
            {"me_nj_kaifuku"},
            {"me_nj_keyitem"},
            {"me_nj_lvup"},
            {"me_nj_massage"},
            {"me_nj_oyasumi"},
            {"me_nj_resort_finish"},
            {"me_nj_shinkaome"},
            {"me_nj_syoukan"},
            {"me_nj_tamago_get"},
            {"me_nj_test13"},
            {"me_nj_waza"},
            {"me_nj_zygarde"},
            {"me_xy_dressup_04"},
            {"me_xy_hyouka01"},
            {"me_xy_hyouka02"},
            {"me_xy_hyouka03"},
            {"me_xy_hyouka04"},
            {"me_xy_hyouka05"},
            {"me_xy_hyouka06"},
            {"me_xy_hyouka07"},
            {"me_xy_hyouka08"},
            {"me_xy_item_mystery"},
            {"me_xy_kinomi"},
            {"me_xy_mega_stone"},
            {"me_xy_o_power"},
            {"me_xy_quest"},
            {"me_xy_wasure"},
            {"strm_bgm_xy_e_05"},
            {"strm_demo_renrakusen"},
            {"strm_demo_sd9200"}
        };
    }
}

#endif